//*****************************************************************************
//*
//*
//*		CmpPathDlg.cpp: Implementierungsdatei
//*
//*
//*****************************************************************************
#include	"StdAfx.h"
#include	"AfxUtility.h"
#include	"DataFinder.h"
#include	"CmpPathDlg.h"
#include	"PathDlg.h"

#ifdef		_DEBUG
#define new	 DEBUG_NEW
#undef		 THIS_FILE
static char	 THIS_FILE[] = __FILE__;
#endif


BEGIN_MESSAGE_MAP(CCmpPathDlg, CDialog)
	//{{AFX_MSG_MAP(CCmpPathDlg)
	ON_WM_DESTROY()
	ON_BN_CLICKED(IDC_CHECK4, OnSeachNew)
	ON_BN_CLICKED(IDC_PATH1, OnPath1)
	ON_BN_CLICKED(IDC_PATH2, OnPath2)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

DLG_OLDPOS(CCmpPathDlg)


//*****************************************************************************
//*
//*		Dialogfeld CCmpPathDlg
//*
//*****************************************************************************
CCmpPathDlg::CCmpPathDlg(CWnd *pParent) : CDialog(CCmpPathDlg::IDD,pParent)
{
	//{{AFX_DATA_INIT(CCmpPathDlg)
	sPath			= _T("");
	sPlus			= _T("");
	sMinus			= _T("");
	bChangeFile		= TRUE;
	bChangeAttrib	= FALSE;
	bChangeDelete	= FALSE;
	bChangeInsert	= FALSE;
	bIgnoreLinefeeds= FALSE;
	//}}AFX_DATA_INIT
}



//*****************************************************************************
//*
//*		DoDataExchange
//*
//*****************************************************************************
void CCmpPathDlg::DoDataExchange(CDataExchange *pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CCmpPathDlg)
	DDX_CBString(pDX, IDC_COMBO1, sPath);
	DDX_CBString(pDX, IDC_COMBO2, sPlus);
	DDX_CBString(pDX, IDC_COMBO3, sMinus);
	DDX_CBString(pDX, IDC_COMBO4, sPcmp);
	DDX_Check(pDX, IDC_CHECK1, bChangeFile);
	DDX_Check(pDX, IDC_CHECK2, bChangeAttrib);
	DDX_Check(pDX, IDC_CHECK3, bChangeDelete);
	DDX_Check(pDX, IDC_CHECK4, bChangeInsert);
	DDX_Check(pDX, IDC_CHECK5, bIgnoreLinefeeds);
	//}}AFX_DATA_MAP
}

//*****************************************************************************
//*
//*		OnInitDialog
//*
//*****************************************************************************
BOOL CCmpPathDlg::OnInitDialog()
{
CRegKeys	sKey;
CString		sStr;
char	   *pStr;
int			i;



	SET_DLG_OLDPOS()

	SetButtonBitmap(this,IDC_PATH1,IDB_OPEN);
	SetButtonBitmap(this,IDC_PATH2,IDB_OPEN);


	sKey.Open(0,CRK_READ);
	sKey.Get(bChangeFile     ,"ChangeFile"     );
	sKey.Get(bChangeAttrib   ,"ChangeAttrib"   );
	sKey.Get(bChangeDelete   ,"ChangeDelete"   );
	sKey.Get(bChangeInsert   ,"ChangeInsert"   );
	sKey.Get(bIgnoreLinefeeds,"IgnoreLinefeeds");
	

	CDialog::OnInitDialog();


	SubclassComboBox(this,IDC_COMBO1,SCB_DROPFILE);
	SubclassComboBox(this,IDC_COMBO4,SCB_DROPFILE);

	cBPath  = (CComboBox*)GetDlgItem(IDC_COMBO1);
	cBPlus  = (CComboBox*)GetDlgItem(IDC_COMBO2);
	cBMinus	= (CComboBox*)GetDlgItem(IDC_COMBO3);
	cBPcmp  = (CComboBox*)GetDlgItem(IDC_COMBO4);

	sKey.Get((void**)&pStr,"FindPath",REG_MULTI_SZ );
	if(pStr)
		{
		sKPath.Add(&pStr);
		sKPath.ContainerInit();
		for(i=0;i<sKPath.Count();i++)cBPath->InsertString(i,sKPath[i]);
		if(sPath=="")cBPath->SetCurSel(0);
		delete pStr;
		}

	sKey.Get((void**)&pStr,"FindCmp",REG_MULTI_SZ );
	if(pStr)
		{
		sKPcmp.Add(&pStr);
		sKPcmp.ContainerInit();
		sStr=sKPcmp.Get(0);
		for(i=0;i<sKPcmp.Count();i++)cBPcmp->InsertString(i,sKPcmp[i]);
		if(sPcmp=="")cBPcmp->SetCurSel(0);
		delete pStr;
		}

	sKey.Get((void**)&pStr,"FilterPlus",REG_MULTI_SZ );
	if(pStr)
		{
		sKPlus.Add(&pStr);
		sKPlus.ContainerInit();
		for(i=0;i<sKPlus.Count();i++)cBPlus->InsertString(i,sKPlus[i]);
		if(sPlus=="")cBPlus->SetCurSel(0);
		delete pStr;
		}

	sKey.Get((void**)&pStr,"FilterMinus",REG_MULTI_SZ );
	if(pStr)
		{
		sKMinus.Add(&pStr);
		sKMinus.ContainerInit();
		for(i=0;i<sKMinus.Count();i++)cBMinus->InsertString(i,sKMinus[i]);
		if(sMinus=="")cBMinus->SetCurSel(0);
		delete pStr;
		}


	OnSeachNew();


	if(sStr!="" && (sPath==sPcmp || sPcmp==""))
		{
		sPcmp = sStr;
		UpdateData(FALSE);
		}


return TRUE;
}


//*****************************************************************************
//*
//*		OnDestroy
//*
//*****************************************************************************
void CCmpPathDlg::OnDestroy()
{

	DelButtonBitmap(this,IDC_PATH1);
	DelButtonBitmap(this,IDC_PATH2);

	CDialog::OnDestroy();

}



//*****************************************************************************
//*
//*		OnSeachNew
//*
//*****************************************************************************
void CCmpPathDlg::OnSeachNew()
{

	UpdateData();
	cBPlus ->EnableWindow(bChangeInsert);
	cBMinus->EnableWindow(bChangeInsert);
}


//*****************************************************************************
//*
//*		OnPath1
//*
//*****************************************************************************
void CCmpPathDlg::OnPath1()
{
CPathDlg	sDlg;


	UpdateData();

	   sDlg.SetPath(sPath);
	if(sDlg.DoModal("Path1")!=IDOK)return;

	sPath=sDlg.GetPath();
	UpdateData(FALSE);


}

//*****************************************************************************
//*
//*		OnPath2
//*
//*****************************************************************************
void CCmpPathDlg::OnPath2()
{
CPathDlg	sDlg;


	UpdateData();

	   sDlg.SetPath(sPcmp);
	if(sDlg.DoModal("Path2")!=IDOK)return;

	sPcmp=sDlg.GetPath();
	UpdateData(FALSE);


}

//*****************************************************************************
//*
//*		OnCancel
//*
//*****************************************************************************
void CCmpPathDlg::OnCancel()
{

	GET_DLG_OLDPOS()
	CDialog::OnCancel();

}

//*****************************************************************************
//*
//*		OnOK
//*
//*****************************************************************************
void CCmpPathDlg::OnOK()
{
CRegKeys	sKey;
char	   *pStr;
int			i;


	GET_DLG_OLDPOS()
	UpdateData();


	sKey.Open();
	sKPath .CAdd(sPath);
	sKPcmp .CAdd(sPcmp);
	sKPlus .CAdd(sPlus);
	sKMinus.CAdd(sMinus);

	i=sKPath.Chain(&pStr);
	sKey.Set(pStr,i,"FindPath",REG_MULTI_SZ );
	delete pStr;

	i=sKPcmp.Chain(&pStr);
	sKey.Set(pStr,i,"FindCmp",REG_MULTI_SZ );
	delete pStr;

	i=sKPlus.Chain(&pStr);
	sKey.Set(pStr,i,"FilterPlus",REG_MULTI_SZ );
	delete pStr;

	i=sKMinus.Chain(&pStr);
	sKey.Set(pStr,i,"FilterMinus",REG_MULTI_SZ );
	delete pStr;

	sKey.Set(bChangeFile     ,"ChangeFile"     );
	sKey.Set(bChangeAttrib   ,"ChangeAttrib"   );
	sKey.Set(bChangeDelete   ,"ChangeDelete"   );
	sKey.Set(bChangeInsert   ,"ChangeInsert"   );
	sKey.Set(bIgnoreLinefeeds,"IgnoreLinefeeds");

	CDialog::OnOK();
}

