//*****************************************************************************
//*
//*
//*		CopyFilesDlg.cpp: Implementierungsdatei
//*
//*
//*****************************************************************************
#include	"StdAfx.h"
#include	"AfxUtility.h"
#include	"DataFinder.h"
#include	"CopyFilesDlg.h"
#include	"PathDlg.h"

#ifdef		_DEBUG
#define new	 DEBUG_NEW
#undef		 THIS_FILE
static char	 THIS_FILE[] = __FILE__;
#endif


BEGIN_MESSAGE_MAP(CCopyFilesDlg, CDialog)
	//{{AFX_MSG_MAP(CCopyFilesDlg)
	ON_WM_DESTROY()
	ON_BN_CLICKED(IDC_CHECK4, OnSeachNew)
	ON_BN_CLICKED(IDC_PATH1, OnPath1)
	ON_BN_CLICKED(IDC_PATH2, OnPath2)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

DLG_OLDPOS(CCopyFilesDlg)


//*****************************************************************************
//*
//*		Dialogfeld CCopyFilesDlg
//*
//*****************************************************************************
CCopyFilesDlg::CCopyFilesDlg(CWnd *pParent) : CDialog(CCopyFilesDlg::IDD,pParent)
{
	//{{AFX_DATA_INIT(CCopyFilesDlg)
	sSource 		 = _T("");
	bNoOverWrite = TRUE;
	bRemoveWr	 = FALSE;
	bAskReadOnly = FALSE;
	bAskAlways  = FALSE;
	//}}AFX_DATA_INIT
}



//*****************************************************************************
//*
//*		DoDataExchange
//*
//*****************************************************************************
void CCopyFilesDlg::DoDataExchange(CDataExchange *pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CCopyFilesDlg)
	DDX_CBString(pDX, IDC_COMBO1, sSource);
	DDX_CBString(pDX, IDC_COMBO2, sTarget);
	DDX_Check(pDX, IDC_CHECK1, bNoOverWrite);
	DDX_Check(pDX, IDC_CHECK2, bRemoveWr);
	DDX_Check(pDX, IDC_CHECK3, bAskReadOnly);
	DDX_Check(pDX, IDC_CHECK4, bAskAlways);
	//}}AFX_DATA_MAP
}

//*****************************************************************************
//*
//*		OnInitDialog
//*
//*****************************************************************************
BOOL CCopyFilesDlg::OnInitDialog()
{
CRegKeys	sKey;
CString		sStr;
char	   *pStr;
int			i;



	SET_DLG_OLDPOS()

	SetButtonBitmap(this,IDC_PATH1,IDB_OPEN);
	SetButtonBitmap(this,IDC_PATH2,IDB_OPEN);


	sKey.Open(0,CRK_READ);
	sKey.Get(bNoOverWrite	,"NoOverWrite");
	sKey.Get(bRemoveWr		,"RemoveWr"   );
	sKey.Get(bAskReadOnly	,"AskReadOnly");
	sKey.Get(bAskAlways	,"AskAlways" );

	CDialog::OnInitDialog();


	SubclassComboBox(this,IDC_COMBO1,SCB_DROPFILE);
	SubclassComboBox(this,IDC_COMBO2,SCB_DROPFILE);

	cBPath  = (CComboBox*)GetDlgItem(IDC_COMBO1);
	cBPcmp  = (CComboBox*)GetDlgItem(IDC_COMBO2);

	sKey.Get((void**)&pStr,"Source",REG_MULTI_SZ);
	if(pStr)
		{
		sKPath.Add(&pStr);
		sKPath.ContainerInit();
		for(i=0;i<sKPath.Count();i++)cBPath->InsertString(i,sKPath[i]);
		if(sSource=="")cBPath->SetCurSel(0);
		delete pStr;
		}

	sKey.Get((void**)&pStr,"Target",REG_MULTI_SZ);
	if(pStr)
		{
		sKPcmp.Add(&pStr);
		sKPcmp.ContainerInit();
		sStr=sKPcmp.Get(0);
		for(i=0;i<sKPcmp.Count();i++)cBPcmp->InsertString(i,sKPcmp[i]);
		if(sTarget=="")cBPcmp->SetCurSel(0);
		delete pStr;
		}

	OnSeachNew();


	if(sStr!="" && (sSource==sTarget || sTarget==""))
		{
		sTarget = sStr;
		UpdateData(FALSE);
		}


return TRUE;
}


//*****************************************************************************
//*
//*		OnDestroy
//*
//*****************************************************************************
void CCopyFilesDlg::OnDestroy()
{

	DelButtonBitmap(this,IDC_PATH1);
	DelButtonBitmap(this,IDC_PATH2);

	CDialog::OnDestroy();

}



//*****************************************************************************
//*
//*		OnSeachNew
//*
//*****************************************************************************
void CCopyFilesDlg::OnSeachNew()
{

	UpdateData();

}


//*****************************************************************************
//*
//*		OnPath1
//*
//*****************************************************************************
void CCopyFilesDlg::OnPath1()
{
CPathDlg	sDlg;


	UpdateData();

	   sDlg.SetPath(sSource);
	if(sDlg.DoModal("Path1")!=IDOK)return;

	sSource=sDlg.GetPath();
	UpdateData(FALSE);


}

//*****************************************************************************
//*
//*		OnPath2
//*
//*****************************************************************************
void CCopyFilesDlg::OnPath2()
{
CPathDlg	sDlg;


	UpdateData();

	   sDlg.SetPath(sTarget);
	if(sDlg.DoModal("Path2")!=IDOK)return;

	sTarget=sDlg.GetPath();
	UpdateData(FALSE);


}

//*****************************************************************************
//*
//*		OnCancel
//*
//*****************************************************************************
void CCopyFilesDlg::OnCancel()
{

	GET_DLG_OLDPOS()
	CDialog::OnCancel();

}

//*****************************************************************************
//*
//*		OnOK
//*
//*****************************************************************************
void CCopyFilesDlg::OnOK()
{
CRegKeys	sKey;
char	   *pStr;
int			i;


	GET_DLG_OLDPOS()
	UpdateData();


	sKey.Open();
	sKPath .CAdd(sSource);
	sKPcmp .CAdd(sTarget);

	i=sKPath.Chain(&pStr);
	sKey.Set(pStr,i,"Source",REG_MULTI_SZ );
	delete pStr;

	i=sKPcmp.Chain(&pStr);
	sKey.Set(pStr,i,"Target",REG_MULTI_SZ );
	delete pStr;

	sKey.Set(bNoOverWrite	,"NoOverWrite");
	sKey.Set(bRemoveWr		,"RemoveWr"   );
	sKey.Set(bAskReadOnly	,"AskReadOnly");
	sKey.Set(bAskAlways	,"AskAlways" );

	CDialog::OnOK();
}

