//*****************************************************************************
//*
//*		
//*		DataFinder.cpp : Legt das Klassenverhalten fr die Anwendung fest.
//*
//*
//*****************************************************************************
//	
//	Syntax:		-P:???		Plusfilter
//				-M:???		Minusfilter
//				-S			Keine Unterverzeichnisse
//
#include "StdAfx.h"	  
#include "MainFrm.h"
#include "DataFinder.h"
#include "DataFinderDoc.h"
#include "DataFinderView.h"
#include "MainViewDlg.h"
  	  
#ifdef		_DEBUG
#define new  DEBUG_NEW
#undef		 THIS_FILE
static char  THIS_FILE[] = __FILE__;
#endif
					    

BEGIN_MESSAGE_MAP(CDataFinderApp, CWinApp)
	//{{AFX_MSG_MAP(CDataFinderApp)
	ON_COMMAND(ID_APP_ABOUT, OnAppAbout)
	ON_COMMAND(ID_INFO, OnAppInfo)
	//}}AFX_MSG_MAP
	// Dateibasierte Standard-Dokumentbefehle
	ON_COMMAND(ID_FILE_NEW,  CWinApp::OnFileNew)
	ON_COMMAND(ID_FILE_OPEN, CWinApp::OnFileOpen)
END_MESSAGE_MAP()


CDataFinderApp theApp;

//*****************************************************************************
//*
//*		Konstruktor
//*
//*****************************************************************************
CDataFinderApp::CDataFinderApp()
{
}

//*****************************************************************************
//*
//*		GetDocument
//*
//*****************************************************************************
CDataFinderDoc *CDataFinderApp::GetDocument()
{										
POSITION	pos;						

	if(!pDocTemplate)return 0;				
		pos=pDocTemplate->GetFirstDocPosition();			
	if(!pos)return 0;										

return (CDataFinderDoc*)pDocTemplate->GetNextDoc(pos);				
}														
			
//*****************************************************************************
//*
//*		InitInstance
//*
//*****************************************************************************
BOOL CDataFinderApp::InitInstance()
{
CMainViewDlg	view;
CDataFinderDoc *doc;
char		   *param,*plus=0,*minus=0;
int				x,subdir=1;
	
	
	AfxUtilityInit();
	AfxOleInit();
	AfxEnableControlContainer();
	

	// Standardinitialisierung

#ifdef _AFXDLL
	Enable3dControls();			// Diese Funktion bei Verwendung von MFC in gemeinsam genutzten DLLs aufrufen
#else
	Enable3dControlsStatic();	// Diese Funktion bei statischen MFC-Anbindungen aufrufen
#endif

	// ndern des Registrierungsschlssels, unter dem unsere Einstellungen gespeichert sind.
	SetRegistryKey(_T("AZ"));

	LoadStdProfileSettings(9);  // Standard INI-Dateioptionen laden (einschlielich MRU)

	view.Create(IDD_MAINVIEW);
	view.ShowWindow(SW_SHOW);
	view.UpdateWindow();

	// Dokumentvorlagen registrieren
	pDocTemplate = new CSingleDocTemplate(
		IDR_MAINFRAME,
		RUNTIME_CLASS(CDataFinderDoc),
		RUNTIME_CLASS(CMainFrame),       // Haupt-SDI-Rahmenfenster
		RUNTIME_CLASS(CDataFinderView));
	AddDocTemplate(pDocTemplate);

	// Befehlszeile parsen, um zu prfen auf Standard-Umgebungsbefehle DDE, Datei offen
	CCommandLineInfo cmdInfo;
	ParseCommandLine(cmdInfo);

	// Verteilung der in der Befehlszeile angegebenen Befehle
	if (!ProcessShellCommand(cmdInfo))return FALSE;


	doc =(CDataFinderDoc*)GetDocument();

	for(x=1;x<__argc;x++)			// Zu einer bestimmten Addresse scrollen
		{
		param=__targv[x];
		if(param[0]!='-' && param[0]!='/')continue;
		if(param[1]=='P' || param[1]=='p')
			{
			if(param[2]!=':')continue;
			plus=param+3;
			continue;
			}
		if(param[1]=='M' || param[1]=='m')
			{
			if(param[2]!=':')continue;
			minus=param+3;
			continue;
			}
		if(param[1]=='S' || param[1]=='s')
			{
			subdir=0;
			continue;
			}
		}

	if((plus || minus) && doc)				// Vorauswahl
		{
		doc->SetFilter(plus,minus,subdir);
		}

	m_pMainWnd->ShowWindow(SW_SHOW);
	m_pMainWnd->UpdateWindow();
	view.DestroyWindow();

	return TRUE;
}



//*****************************************************************************
//*
//*		OnAppAbout
//*
//*****************************************************************************
void CDataFinderApp::OnAppAbout()
{
	CDialog aboutDlg(IDD_ABOUTBOX);
	aboutDlg.DoModal();
}

//*****************************************************************************
//*
//*		OnAppInfo
//*
//*****************************************************************************
void CDataFinderApp::OnAppInfo()
{
	CDialog aboutDlg(IDD_INFOBOX);
	aboutDlg.DoModal();
}
