//*****************************************************************************
//*
//*
//*		DataFinderView.cpp : Implementierung der Klasse CDataFinderView
//*
//*
//*****************************************************************************
//
//	(C) Copyright Anton Zechner 2007
//
#include	"StdAfx.h"
#include	"MainFrm.h"
#include	"DataFinder.h"
#include	"DataFinderDlg.h"
#include	"DataFinderDoc.h"
#include	"DataFinderView.h"
#include	"AnsiMessage.h"
#include	"AppMessage.h"
#include	"HexMessage.h"
#include	"TextDlg.h"
#include	"HexDlg.h"
#include	"ZipDlg.h"
#include	"AendernDlg.h"
#include	"CmpFileDlg.h"
#include	"CmpPathDlg.h"
#include	"CopyFilesDlg.h"
#include	"AsciiAnsiDlg.h"
#include	"ExecConfigDlg.h"
#include	"ChangePreviewDlg.h"
#include	"LfCrConvertDlg.h"
#include	"TabConvertDlg.h"
#include	"FindSameDlg.h"
#include	"RenameDlg.h"
#include	"LinesDlg.h"

#ifdef		_DEBUG
#define new  DEBUG_NEW
#undef		 THIS_FILE
static char  THIS_FILE[] = __FILE__;
#endif

#ifndef		 ID_DELETE
#define 	 ID_DELETE		0x5652
#endif

#define 	 ID_BROWSER		0x5393
#define 	 ID_FILELIST	0x5394
#define 	 ID_FINDLIST	0x5395
#define 	 ID_TXT_EDITOR	0x5396
#define 	 ID_HEX_EDITOR 	0x5397
#define 	 ID_SHELLOPEN	0x5398
#define 	 ID_LISTCOPY	0x5399
#define 	 ID_LISTMARK	0x539A
#define 	 ID_SORTPATH	0x539B
#define 	 ID_SORTNAME	0x539C
#define 	 ID_SORTTYPE	0x539D
#define 	 ID_FINDWORD	0x539E
#define 	 ID_COPY_PATH	0x539F
#define 	 ID_COPY_NAME	0x53A0
#define 	 ID_COPY_FULL	0x53A1
#define 	 ID_COPY_LAST	0x53A2
#define 	 ID_COPY_LIST	0x53A3
#define 	 ID_SCAN_PROG	0x53A4
#define 	 ID_PATHCOPY	0x53A5
#define 	 CTF_USELIST	0x8000
#define 	 MAX_DIFF		4096


IMPLEMENT_DYNCREATE(CDataFinderView, CView)

BEGIN_MESSAGE_MAP(CDataFinderView, CView)
	//{{AFX_MSG_MAP(CDataFinderView)
	ON_WM_SIZE()
	ON_WM_TIMER()
	ON_WM_DESTROY()
	ON_WM_SETFOCUS()
	ON_WM_LBUTTONDOWN()
	ON_WM_CONTEXTMENU()
	ON_NOTIFY(NM_RCLICK			,ID_FILELIST    ,OnMouseRButton)
	ON_NOTIFY(NM_SETFOCUS		,ID_FILELIST    ,OnFocusList)
	ON_NOTIFY(NM_SETFOCUS		,ID_BROWSER     ,OnFocusFiles)
	ON_NOTIFY(CFL_STATUSBARSET	,ID_FILELIST    ,OnListStatus)
	ON_NOTIFY(CBC_STATUSBARSET	,ID_BROWSER		,OnFileStatus)
	ON_NOTIFY(CBC_FOLDERSELECT	,ID_BROWSER		,OnFolderSelect)
	ON_NOTIFY(CBC_LISTRCLICK	,ID_BROWSER		,OnBrowserRButton)
	ON_NOTIFY(CLB_BEGINDRAG		,ID_FINDLIST	,OnBeginDrag)
	ON_UPDATE_COMMAND_UI(		 ID_EXECFILES	,OnExecFilesUpdate)
	ON_UPDATE_COMMAND_UI(		 ID_AENDERN		,OnChangeUpdate)
	ON_LBN_DBLCLK  (ID_FINDLIST	,OnFindDblClk)
	ON_LBN_SETFOCUS(ID_FINDLIST	,OnFocusFind)
	ON_COMMAND(ID_ADDFILES		,OnAddFiles)
	ON_COMMAND(ID_FINDTEXT		,OnFindText)
	ON_COMMAND(ID_FINDHEX		,OnFindHex)
	ON_COMMAND(ID_EDIT_CUT		,OnCut)
	ON_COMMAND(ID_EDIT_COPY		,OnCopy)
	ON_COMMAND(ID_EDIT_PASTE	,OnPaste)
	ON_COMMAND(ID_AENDERN		,OnChange)
	ON_COMMAND(ID_DELETE		,OnDelete)
	ON_COMMAND(ID_MAXFIND		,OnMaxFind)
	ON_COMMAND(ID_CACHE_SIZE	,OnChacheSize)
	ON_COMMAND(ID_INSERTALLFILES,OnInsertAllFiles)
	ON_COMMAND(ID_DELETALLFILES	,OnDeleteAllFiles)
	ON_COMMAND(ID_COMPAREFILES	,OnCompareFiles)
	ON_COMMAND(ID_COMPARETEXT	,OnCompareText)
	ON_COMMAND(ID_RENAMEFILES	,OnRenameFiles)
	ON_COMMAND(ID_TABCONVERT	,OnTabConvert)
	ON_COMMAND(ID_DELLINES		,OnDelLines)
	ON_COMMAND(ID_ADDLINES		,OnAddLines)
	ON_COMMAND(ID_FINDSAME		,OnFindSame)
	ON_COMMAND(ID_RELOAD		,OnReload)
	ON_COMMAND(ID_ZIPFILES		,OnZipFiles)
	ON_COMMAND(ID_CPPBEATIFY	,OnCppBeatify)
	ON_COMMAND(ID_ASCIIANSI		,OnAsciiAnsi)
	ON_COMMAND(ID_TXT_EDITOR	,OnTxtEditor)
	ON_COMMAND(ID_HEX_EDITOR	,OnHexEditor)
	ON_COMMAND(ID_COPY_PATH		,OnCopyPath)
	ON_COMMAND(ID_COPY_NAME		,OnCopyName)
	ON_COMMAND(ID_COPY_FULL		,OnCopyFull)
	ON_COMMAND(ID_COPY_LAST		,OnCopyLast)
	ON_COMMAND(ID_COPY_LIST		,OnCopyList)
	ON_COMMAND(ID_SHELLOPEN		,OnShellOpen)
	ON_COMMAND(ID_LFCRCONVERT	,OnLfCrConvert)
	ON_COMMAND(ID_CMPDIRECTORY	,OnCompareDirectory)
	ON_COMMAND(ID_COPYFILES		,OnCopyFiles)
	ON_COMMAND(ID_EXECMENUS		,OnExecMenus)
	ON_COMMAND(ID_EXECFILES		,OnExecFiles)
	ON_COMMAND(ID_LISTCOPY		,OnListCopy)
	ON_COMMAND(ID_PATHCOPY		,OnPathCopy)
	ON_COMMAND(ID_LISTMARK		,OnListMark)
	ON_COMMAND(ID_FINDWORD		,OnFindWord)
	ON_COMMAND(ID_SORTPATH		,OnSortPath)
	ON_COMMAND(ID_SORTNAME		,OnSortName)
	ON_COMMAND(ID_SORTTYPE		,OnSortType)
	//}}AFX_MSG_MAP
	ON_UPDATE_COMMAND_UI(ID_FINDHEX			, OnFilesUpdate)
	ON_UPDATE_COMMAND_UI(ID_FINDTEXT		, OnFilesUpdate)
	ON_UPDATE_COMMAND_UI(ID_COMPAREFILES	, OnFilesUpdate)
	ON_UPDATE_COMMAND_UI(ID_COMPARETEXT		, OnFilesUpdate)
	ON_UPDATE_COMMAND_UI(ID_TABCONVERT		, OnFilesUpdate)
	ON_UPDATE_COMMAND_UI(ID_FINDSAME		, OnFilesUpdate)
	ON_UPDATE_COMMAND_UI(ID_RENAMEFILES		, OnFilesUpdate)
	ON_UPDATE_COMMAND_UI(ID_ASCIIANSI		, OnFilesUpdate)
	ON_UPDATE_COMMAND_UI(ID_LFCRCONVERT		, OnFilesUpdate)
	ON_UPDATE_COMMAND_UI(ID_CMPDIRECTORY	, OnFilesUpdate)
	ON_UPDATE_COMMAND_UI(ID_CPPBEATIFY		, OnFilesUpdate)
	ON_UPDATE_COMMAND_UI(ID_COPYFILES		, OnFilesUpdate)
	ON_UPDATE_COMMAND_UI(ID_ZIPFILES		, OnFilesUpdate)
END_MESSAGE_MAP()


typedef	struct
	{
	const char	*path;					// Zeiger auf den Einfgepfad
	const char	*plus;					// Zeiger auf den Plusfilter
	const char	*minus;					// Zeiger auf den Minusfilter
	int			 mode;					// Flags fr CFileListCtrl z.B. CFL_SUBDIR
	int			 protect;				// 0=alle einfgen  1=nur schreibgeschtzte 2=nicht schreibgeschtzte
	int			 timemode;				// 0=egal  1=erstellt vor   2=erstellt nach  3=gendert vor  4=gendert nach
	time_t		 timevalue;				// Zeitwert wenn TimeMode nicht 0 ist
	}AddFilesStruct;

LPCTSTR CDataFinderView::cpp_words[] =
		{
		_T("ATOM"),
		_T("BOOL"),
		_T("BOOLEAN"),
		_T("BYTE"),
		_T("BitmapImage"),
		_T("CArray"),
		_T("CBitField"),
		_T("CBitmap"),
		_T("CBitmapWnd"),
		_T("CBrowseCtrl"),
		_T("CBrush"),
		_T("CButton"),
		_T("CClientDC"),
		_T("CCmdUI"),
		_T("CColorListBox"),
		_T("CColumnDlg"),
		_T("CComboBox"),
		_T("CComboDlg"),
		_T("CCriticalSection"),
		_T("CDC"),
		_T("CDataField"),
		_T("CDataList"),
		_T("CDataPointer"),
		_T("CDialog"),
		_T("CDocument"),
		_T("CEdit"),
		_T("CEvent"),
		_T("CFastListCtrl"),
		_T("CFileBuffer"),
		_T("CFileDialog"),
		_T("CFileFinder"),
		_T("CFileListCtrl"),
		_T("CFolderTreeCtrl"),
		_T("CFont"),
		_T("CFrameWnd"),
		_T("CHAR"),
		_T("CHeaderCtrl"),
		_T("CHuffman"),
		_T("CLabelCtrl"),
		_T("CListCtrl"),
		_T("CListDialog"),
		_T("CListbox"),
		_T("CMapFile"),
		_T("CMenu"),
		_T("CMutex"),
		_T("CONST"),
		_T("CObject"),
		_T("COleVariant"),
		_T("CPaintDC"),
		_T("CPathDlg"),
		_T("CPen"),
		_T("CPoint"),
		_T("CPrintInfo"),
		_T("CProgressCtrl"),
		_T("CProgressDlg"),
		_T("CRITICAL_SECTION"),
		_T("CRect"),
		_T("CRegKeys"),
		_T("CRgn"),
		_T("CScrollBar"),
		_T("CSemaphore"),
		_T("CSize"),
		_T("CStartProg"),
		_T("CString"),
		_T("CStringChain"),
		_T("CTabCtrl"),
		_T("CTextBuffer"),
		_T("CTextDlg"),
		_T("CTime"),
		_T("CToolBar"),
		_T("CTreeCtrl"),
		_T("CTreeList"),
		_T("CTreeListCtrl"),
		_T("CValueDlg"),
		_T("CView"),
		_T("CWinApp"),
		_T("CWnd"),
		_T("CZipFile"),
		_T("DC"),
		_T("DLGPROC"),
		_T("DWORD"),
		_T("FARPROC"),
		_T("FILE"),
		_T("FLOAT"),
		_T("GUID"),
		_T("HACCEL"),
		_T("HANDLE"),
		_T("HBITMAP"),
		_T("HBRUSH"),
		_T("HCURSOR"),
		_T("HDC"),
		_T("HFILE"),
		_T("HFONT"),
		_T("HICON"),
		_T("HKEY"),
		_T("HPEN"),
		_T("HRESULT"),
		_T("HRGN"),
		_T("HRSRC"),
		_T("HTREEITEM"),
		_T("HWND"),
		_T("INT"),
		_T("LONG"),
		_T("LONGLONG"),
		_T("LPARAM"),
		_T("LPBOOL"),
		_T("LPBYTE"),
		_T("LPCOLORREF"),
		_T("LPCSTR"),
		_T("LPCTSTR"),
		_T("LPCWSTR"),
		_T("LPRECT"),
		_T("LPSIZE"),
		_T("LPSTR"),
		_T("LPTSTR"),
		_T("LPVOID"),
		_T("LPVOID"),
		_T("LPWORD"),
		_T("LPWSTR"),
		_T("LRESULT"),
		_T("NMHDR"),
		_T("PBOOL"),
		_T("PBOOLEAN"),
		_T("PBYTE"),
		_T("PCHAR"),
		_T("PCTSTR"),
		_T("PCWSTR"),
		_T("PHKEY"),
		_T("PVOID"),
		_T("QDictIterator"),
		_T("QSqlQuery"),
		_T("QString"),
		_T("QStringList"),
		_T("RECT"),
		_T("SHORT"),
		_T("SIZE"),
		_T("TCHAR"),
		_T("TIMERPROC"),
		_T("UINT"),
		_T("ULONG"),
		_T("ULONGLONG"),
		_T("USHORT"),
		_T("VOID"),
		_T("WCHAR"),
		_T("WNDPROC"),
		_T("WORD"),
		_T("WPARAM"),
		_T("__cdecl"),
		_T("__fastcall"),
		_T("__int16"),
		_T("__int32"),
		_T("__int64"),
		_T("__int8"),
		_T("__stdcall"),
		_T("_cdecl"),
		_T("_fastcall"),
		_T("_stdcall"),
		_T("auto"),
		_T("bad_cast"),
		_T("bad_typeid"),
		_T("bool"),
		_T("break"),
		_T("case"),
		_T("catch"),
		_T("char"),
		_T("class"),
		_T("const"),
		_T("const_cast"),
		_T("const_cast"),
		_T("continue"),
		_T("default"),
		_T("delete"),
		_T("do"),
		_T("double"),
		_T("dynamic_cast"),
		_T("else"),
		_T("enum"),
		_T("except"),
		_T("explicit"),
		_T("extern"),
		_T("false"),
		_T("finally"),
		_T("float"),
		_T("for"),
		_T("friend"),
		_T("goto"),
		_T("if"),
		_T("inline"),
		_T("inline"),
		_T("int"),
		_T("long"),
		_T("mutable"),
		_T("namespace"),
		_T("new"),
		_T("operator"),
		_T("private"),
		_T("protected"),
		_T("public"),
		_T("register"),
		_T("reinterpret_cast"),
		_T("return"),
		_T("short"),
		_T("signed"),
		_T("size_t"),
		_T("sizeof"),
		_T("static"),
		_T("static_cast"),
		_T("struct"),
		_T("switch"),
		_T("template"),
		_T("this"),
		_T("throw"),
		_T("time_t"),
		_T("tm"),
		_T("true"),
		_T("try"),
		_T("type_info"),
		_T("typedef"),
		_T("typeid"),
		_T("typename"),
		_T("union"),
		_T("unsigned"),
		_T("using"),
		_T("va_list"),
		_T("virtual"),
		_T("void"),
		_T("volatile"),
		_T("wchar_t"),
		_T("while"),
		};


//*****************************************************************************
//*
//*		Konstruktor
//*
//*****************************************************************************
CDataFinderView::CDataFinderView()
{
CRegKeys	key;
char	   *ptr;
int			num;


	teilung			= 300;
	list_brt		= 100;
	list_on			= 0;
	list_mode		= 0;				// 0=Text 1=Hex 2=Cmp
	list_count		= 0;				// Anzahl der gefunden Eintrge
	file_sort   	= CFF_SORT_NAME;	// Sortierrichtung fr Verzeichniss
	sort_list		= CFL_SORT_NAME;	// Sortierrichtung fr Dateiliste	
	last_focus		= 0;				// 0=tree 1=files 2=list 3=find
	drag_on			= 0;				// Ist ein Text-Drag aktiv
	sort_dir		= 0;				// Sortierrichtung fr Dateivergleich
	sort_mode		= -1;				// Sortiermodus fr Dateivergleich (-1=keine 0=Pfad 1=Name 2=Typ)
	cmp_mode		= 0;				// Ergebnis fr Verzeichnissvergeich (0=keine Unterschiede 1=keine Dateien)
	cache_max		= 250<<20;			// Maximale Gre des Datei-Caches (250 MB)

	file_name[0]	= 0;
	file_full[0]	= 0;

	cmp_return.DataLength(sizeof(int));
	cache_data.DataLength(sizeof(CacheItem));

	memset(prog_pos,0,sizeof(prog_pos));
	memset(prog_on ,0,sizeof(prog_on ));


	key.Open(HKEY_CURRENT_USER,0,CRK_READ);
	key.Get(cache_max,"CacheSize");
	key.Get(file_sort,"SortMode" );
	key.Get(sort_list,"SortList" );

	if(key.Get((void**)&ptr,"FilterPlus",REG_MULTI_SZ))
		{
		delete ptr;
		}
	else{
		char	text[]=	"*.c;*.cpp;*.h;*.hpp;*.cc;*.cxx;*.asm;*.inl;*.inc;*.prv\0"
						"*.h;*.hpp;*.inl\0"
						"*.htm;*.html\0"
						"*.dsp\0"
						"*.rc\0\0";

		key.Open(HKEY_CURRENT_USER,0);
		key.Set(text,sizeof(text),"FilterPlus",REG_MULTI_SZ);
		}

	ExecCount();


	num = cache_max/2;
	if(num<32<<20)num=32<<20;

	SetProcessWorkingSetSize(GetCurrentProcess(),num,num*3);

}


//*****************************************************************************
//*
//*		Destruktor
//*
//*****************************************************************************
CDataFinderView::~CDataFinderView()
{
CacheItem  *item;
CRegKeys	key;
int			pos;


	pos = cache_data.Count();

	while(pos>0)										// Den Datei-Cache lschen
		{
		pos--;
		item = (CacheItem*)cache_data.Data(pos);
		delete item->mem;
		cache_data.Del(pos);
		}
	
	sort_list = list_wnd.GetSortMode();
	file_sort = file_wnd.GetSortMode();
	key.Open(HKEY_CURRENT_USER,0);
	key.Set(cache_max,"CacheSize");
	key.Set(file_sort,"SortMode");
	key.Set(sort_list,"SortList");

}

//*****************************************************************************
//*
//*		Create
//*
//*****************************************************************************
BOOL CDataFinderView::Create(LPCTSTR pClassName,LPCTSTR pWindowName,DWORD dwStyle,const RECT &Rect,CWnd* pParentWnd, UINT nID, CCreateContext* pContext)
{
CRect	rect(0,0,0,0);


	if(!CWnd::Create(pClassName,pWindowName,dwStyle,Rect,pParentWnd,nID,pContext))
		{
		return FALSE;
		}

	SetClassLongPtr(m_hWnd,GCLP_HCURSOR,(LPARAM)LoadCursor(0,IDC_SIZENS));
	SetClassLongPtr(m_hWnd,GCLP_HBRBACKGROUND,0);


	file_wnd.Create(WS_VISIBLE|CBC_STATUSBAR|CBC_DRAG|CBC_SETCOLUMN|CBC_TABEXIT,rect,this,ID_BROWSER);
	list_wnd.Create(WS_VISIBLE|CFL_STATUSBAR|CFL_SETCOLUMN|CFL_DEFAULT|CFL_ALLOWPASTE|CFL_CANDELETE|CFL_ALLOWDROP|CFL_ALLOWDRAG|CFL_SORT|CFL_TABEXIT,rect,this,ID_FILELIST);
	find_wnd.Create(WS_VISIBLE|WS_VSCROLL|LBS_NOTIFY|LBS_NOINTEGRALHEIGHT,rect,this,ID_FINDLIST);
	find_wnd.SetExtendedStyle(CLB_EX_DRAGITEMS|CLB_EX_NOCONTEXTMENU,CLB_EX_DRAGITEMS|CLB_EX_NOCONTEXTMENU);
	find_wnd.SetOption(CLBO_BASEIDENT,2);
	find_wnd.SetColor( 4,RGB(  0,  0,128));
	find_wnd.SetColor( 5,RGB(128,  0,128));
	find_wnd.SetColor( 6,RGB( 64,  0,128));
	find_wnd.SetColor( 7,RGB(  0,  0,200));
	find_wnd.SetColor( 8,RGB(  0,128,  0));
	find_wnd.SetColor( 9,RGB(  0,128,128));
	find_wnd.SetColor(10,RGB(  0,  0,192));
	find_wnd.SetColor(11,RGB(128,  0,  0));
	find_wnd.SetColor(12,RGB(128,  0,128));
	find_wnd.SetColor(13,RGB(128,128,128));
	find_wnd.SetColor(14,RGB(128,  0,144));
	find_wnd.SetColor(15,RGB(208,  0,  0));
	find_wnd.SetColor(16,RGB(108, 50,100));
	find_wnd.SetCursorMode(TRUE);
	find_wnd.SetTabExit   (TRUE);
	find_wnd.SetFont      (NULL);
	file_wnd.Sort(file_sort);
	list_wnd.Sort(sort_list);

	find_wnd.SetOption(CLBO_BASEIDENT,1);
	SetWndData(find_wnd,(LONG)GetWndProc(find_wnd));
	SetWndProc(find_wnd,ListBoxProc);


return TRUE;
}


//*****************************************************************************
//*
//*		PreCreateWindow
//*
//*****************************************************************************
BOOL CDataFinderView::PreCreateWindow(CREATESTRUCT& cs)
{
	return CView::PreCreateWindow(cs);
}



//*****************************************************************************
//*
//*		OnDraw
//*
//*****************************************************************************
void CDataFinderView::OnDraw(CDC *pDC)
{
CRect	rect;
int		pos1;
int		pos;



	CDataFinderDoc* pDoc = GetDocument();
	ASSERT_VALID(pDoc);

	if(list_on)
		{
		   pos=teilung-list_brt-7;
		if(pos<0)pos=0;
		}
	else{
		pos=teilung;
		}

	DrawSeparator(pDC,pos,10000,TRUE);


	if(list_on)
		{
		GetClientRect(&rect);
		   pos1=rect.bottom-list_brt-7;
		if(pos1<7)pos1=7;

		DrawSeparator(pDC,pos1,10000,TRUE);
		}

}


//*****************************************************************************
//*
//*		Debug Funktionen
//*
//*****************************************************************************
#ifdef _DEBUG
void CDataFinderView::AssertValid() const
{
	CView::AssertValid();
}

void CDataFinderView::Dump(CDumpContext& dc) const
{
	CView::Dump(dc);
}

CDataFinderDoc* CDataFinderView::GetDocument() // Die endgltige (nicht zur Fehlersuche kompilierte) Version ist Inline
{
	ASSERT(m_pDocument->IsKindOf(RUNTIME_CLASS(CDataFinderDoc)));
	return (CDataFinderDoc*)m_pDocument;
}
#endif




//*****************************************************************************
//*
//*		OnSize
//*
//*****************************************************************************
void CDataFinderView::OnSize(UINT nType, int cx, int cy)
{
	CView::OnSize(nType, cx, cy);
	if(cx && cy)SetSize();
}

//*****************************************************************************
//*
//*		SetSize
//*
//*****************************************************************************
//	Fenster Positionen berechnen
void CDataFinderView::SetSize()
{
int		cx,cy;
CRect	rect;


	GetClientRect(&rect);
	cx=rect.right;
	cy=rect.bottom;

	if(cx && cy)
		{
		CRect	r1,r2,r3;
		int		pos,pos1;

		if(teilung>cy)teilung=cy-100;
		if(teilung< 0)teilung=cy;

		if(list_on)
			{
			   pos=teilung-list_brt-7;
			if(pos<0)pos=0;
			   pos1=cy-list_brt-7;
			if(pos1<7)pos1=7;

			r1.SetRect(0,0     ,cx,pos );
			r2.SetRect(0,pos +7,cx,pos1);
			r3.SetRect(0,pos1+7,cx,cy  );
			}
		else{
			r1.SetRect(0,0        ,cx,teilung);
			r2.SetRect(0,teilung+7,cx,cy     );
			r3.SetRect(0,cy+1     ,cx,cy+1   );
			}

		if(IsWindow(file_wnd.m_hWnd))file_wnd.MoveWindow(r1);
		if(IsWindow(list_wnd.m_hWnd))list_wnd.MoveWindow(r2);
		if(IsWindow(find_wnd.m_hWnd))find_wnd.MoveWindow(r3);
		}


}

//*****************************************************************************
//*
//*		OnLButtonDown
//*
//*****************************************************************************
void CDataFinderView::OnLButtonDown(UINT nFlags, CPoint point)
{
CPoint	pt;
CRect	rect,r1;
int		x,pos,pos1;



	GetRectView(rect);
	GetClientRect(r1);

	if(list_on)
		{
		   pos=teilung-list_brt-7;
		if(pos<0)pos=0;
		   pos1=r1.bottom-list_brt-7;
		if(pos1<7)pos1=7;

		if(point.y<pos1)
			{
			rect.bottom-=7;
			pt   =point;
			pt.y-=pos;

			x=Resize(this,FALSE,rect,pos,pt,7,5);
			if(!x)return;

			if(list_brt<0)list_brt=0;
			if(teilung<list_brt)teilung=list_brt;

			teilung+=x;
			}
		else{
			rect.top   +=7+pos;
			pt   =point;
			pt.y-=pos1;

			x=Resize(this,FALSE,rect,pos1-7-pos,pt,7,5);
			if(!x)return;

			if(list_brt<0)list_brt=0;
			if(teilung<list_brt)teilung=list_brt;

			list_brt-=x;
			teilung -=x;
			}
		}
	else{
		pt    = point;
		pt.y -= teilung;

		x=Resize(this,FALSE,rect,teilung,pt,7,5);
		if(!x)return;
		teilung+=x;
		}


				 r1.bottom-=6;
	if(teilung >=r1.bottom)teilung =r1.bottom-1;
				 r1.bottom-=7;
	if(list_brt>=r1.bottom)list_brt=r1.bottom-1;
	if(teilung <         0)teilung =0;
	if(list_brt<         0)list_brt=0;

	SetSize();
	RedrawWindow();

}


//*****************************************************************************
//*
//*		OnTimer
//*
//*****************************************************************************
void CDataFinderView::OnTimer(UINT_PTR nIdEvent)
{
WINDOWPLACEMENT	 place;
CStartProg		*start;
HWND			 hwnd;
int				 pos;

	if(nIdEvent==ID_SCAN_PROG)
		{
		for(pos=0;pos<3;pos++)
			{
			if(!prog_on[pos])continue;

			switch(pos)
				{
			case 0:	start=&prog_text;	break;
			case 1:	start=&prog_hex;	break;
			case 2:	start=&prog_cmp;	break;
				}

			if(!start->IsRunning())
				{
				prog_on[pos] = FALSE;
				continue;
				}

				hwnd = start->GetMainWindow(0);
			if(!hwnd)
				{
				continue;
				}


			place.length = sizeof(place);

			if(!::GetWindowPlacement(hwnd,&place))
				{
				continue;
				}

			prog_pos[pos] = place;
			}

		return;
		}

	CView::OnTimer(nIdEvent);

}

//*****************************************************************************
//*
//*		SetProgPos
//*
//*****************************************************************************
//	Ein Program auf die vorherige position setzen
void CDataFinderView::SetProgPos(CStartProg *start,WINDOWPLACEMENT *place)
{
HWND	hwnd;



	if(!start || !place || !place->length)return;

		hwnd = start->GetMainWindow(10);
	if(!hwnd)return;


	::SetWindowPos(hwnd,NULL,place->rcNormalPosition.left,
							 place->rcNormalPosition.top,
							 place->rcNormalPosition.right -place->rcNormalPosition.left,
							 place->rcNormalPosition.bottom-place->rcNormalPosition.top,
							 SWP_NOZORDER);


	if(place->showCmd==SW_SHOWMAXIMIZED)
		{
		::ShowWindow(hwnd,SW_SHOWMAXIMIZED);
		}


}

//*****************************************************************************
//*
//*		OnFocusFiles
//*
//*****************************************************************************
void CDataFinderView::OnFocusFiles(NMHDR *pNmHdr, LRESULT *pResult)
{
LPCBC_SETFOCUS	pFocus=(LPCBC_SETFOCUS)pNmHdr;

	
	last_focus = (pFocus->iItem==1)? 1:0;

}

//*****************************************************************************
//*
//*		OnFocusList
//*
//*****************************************************************************
void CDataFinderView::OnFocusList(NMHDR *pNmHdr, LRESULT *pResult)
{

	last_focus = 2;

}

//*****************************************************************************
//*
//*		OnFocusFind
//*
//*****************************************************************************
void CDataFinderView::OnFocusFind()
{

	last_focus = 3;

}


//*****************************************************************************
//*
//*		OnSetFocus
//*
//*****************************************************************************
void CDataFinderView::OnSetFocus(CWnd *pOldWnd)
{
static DWORD	last;
static BOOL		lock;
DWORD			tick;
DWORD			diff;
int				item;


	if(lock)return;

	lock = TRUE;
	tick = GetTickCount();
	diff = tick-last;

	
	if(diff<100)goto Next;


	if(pOldWnd && pOldWnd->m_hWnd==find_wnd.m_hWnd)
		{
		if(GetAsyncKeyState(VK_SHIFT)&0x8000)
						last_focus=2;
		else			last_focus=0;
		}
	else if(pOldWnd && pOldWnd->m_hWnd==list_wnd.m_hWnd)
		{
		if(GetAsyncKeyState(VK_SHIFT)&0x8000)
						last_focus=1;
		else if(list_on)last_focus=3;
		else			last_focus=0;
		}
	else if(pOldWnd && pOldWnd->m_hWnd==file_wnd.ListWnd()->m_hWnd)
		{
		if(GetAsyncKeyState(VK_SHIFT)&0x8000)
						last_focus=0;
		else			last_focus=2;
		}
	else if(pOldWnd && pOldWnd->m_hWnd==file_wnd.TreeWnd()->m_hWnd)
		{
		if(!(GetAsyncKeyState(VK_SHIFT)&0x8000))
						last_focus=1;
		else if(list_on)last_focus=3;
		else			last_focus=2;
		}
	else if(pOldWnd && pOldWnd->m_hWnd==file_wnd.m_hWnd)
		{
		if(!(GetAsyncKeyState(VK_SHIFT)&0x8000))
			{
			last_focus = (last_focus==0)? 1:2;
			}
		else{			
			     if(last_focus!=0)last_focus=0;
			else if(list_on      )last_focus=3;
			else			      last_focus=2;
			}
		}

	last = tick;

Next:

	switch(last_focus)
		{
	case 3:	if(list_on){find_wnd.SetFocus( );break;}
	case 2:	list_wnd.SetFocus( );
			   item = list_wnd.GetFocusItem();
			if(item<0)list_wnd.SetFocusItem(0);
			break;
	case 0:	file_wnd.SetFocus(1);break;
	case 1:	file_wnd.SetFocus(0);break;
		}


	lock = FALSE;

}


//*****************************************************************************
//*
//*		OnListKeyDown
//*
//*****************************************************************************
void CDataFinderView::OnListKeyDown(NMHDR *pNmHdr,LRESULT *pResult)
{
LV_KEYDOWN	*lk=(LV_KEYDOWN*)pNmHdr;


	if(lk->wVKey==VK_TAB)
		{
		if(GetAsyncKeyState(VK_SHIFT)&0x8000)
				file_wnd.SetFocus(0);
		else	file_wnd.SetFocus(1);

		*pResult=1;
		return;
		}

}


//*****************************************************************************
//*
//*		OnInsertAllFiles
//*
//*****************************************************************************
void CDataFinderView::OnInsertAllFiles()
{
CString			path;


	path=file_wnd.GetPath();

//	#ifndef _DEBUG

	AddFilesStruct	add;

	last_count		=-1;
	add.path		= path;
	add.plus		= 0;
	add.minus		= 0;
	add.mode		= CFL_SUBDIR;
	add.protect		= 0;
	add.timemode	= 0;
	add.timevalue	= 0;

	CProgressDlg	pdlg;

	pdlg.SetPriority(-2);
	pdlg.SetProgressMode(200);
	pdlg.SetTitle("Dateisuche");
	pdlg.SetTime (AddFilesTime,300);
	pdlg.SetProc (AddFilesProc,this,&add);
	pdlg.SetText ("Durchsuche :  ",add.path);
	pdlg.SetLines(2);
	pdlg.DoModal ();

/*	#else

	SetCursor(IDC_WAIT);
	list_wnd.Add(add.path,add.mode,add.plus,add.minus,add.protect,add.timemode,add.timevalue);
	SetCursor(IDC_ARROW);

	#endif
*/

	list_wnd.RedrawAllItems();


}

//*****************************************************************************
//*
//*		OnDeleteAllFiles
//*
//*****************************************************************************
void CDataFinderView::OnDeleteAllFiles()
{

	SetCursor(IDC_WAIT);
	list_wnd.DeleteAllItems();
	SetCursor(IDC_ARROW);

}

//*****************************************************************************
//*
//*		OnAddFiles
//*
//*****************************************************************************
void CDataFinderView::OnAddFiles()
{
CDataFinderDlg	dlg;
CProgressDlg	pdlg;


	   dlg.path=file_wnd.GetPath();
	if(dlg.path.GetLength()==2 && dlg.path[1]==':')
		{
		dlg.path += "\\";
		}

	if(dlg.DoModal()!=IDOK)return;

	if(dlg.clearlist)OnDeleteAllFiles();

	AddFiles(dlg.path,dlg.plus,dlg.minus,dlg.unterverz,dlg.prodect,dlg.timemode,dlg.timevalue);
	find_last = "";

}

//*****************************************************************************
//*
//*		AddFiles
//*
//*****************************************************************************
void CDataFinderView::AddFiles(const char *pPath,const char *pPlus,const char *pMinus,int iSubDir,int iProtect,int iTimeMode,time_t iTimeValue)
{
CProgressDlg	pdlg;
AddFilesStruct	add;


	if(!pPath)pPath=file_wnd.GetPath();
	if( pPlus  && !*pPlus )pPlus=0;
	if( pMinus && !*pMinus)pMinus=0;


	last_count		= -1;
	find_path		= pPath;
	add.path 		= pPath;
	add.plus 		= pPlus;
	add.minus		= pMinus;
	add.mode		=(iSubDir)? CFL_SUBDIR:0;
	add.protect		= iProtect;
	add.timemode	= iTimeMode;
	add.timevalue	= iTimeValue;


	pdlg.SetPriority(-2);
	pdlg.SetProgressMode(200);
	pdlg.SetTitle("Dateisuche");
	pdlg.SetTime (AddFilesTime,300);
	pdlg.SetProc (AddFilesProc,this,&add);
	pdlg.SetText ("Durchsuche :  ",add.path);
	pdlg.SetLines(2);
	pdlg.DoModal ();

}



//*****************************************************************************
//*
//*		AddFilesProc
//*
//*****************************************************************************
int _cdecl CDataFinderView::AddFilesProc(CProgressDlg *Dlg)
{
CDataFinderView	*view=(CDataFinderView*)Dlg->GetVoid1();
AddFilesStruct  *add =(AddFilesStruct *)Dlg->GetVoid2();


return view->list_wnd.Add(add->path,add->mode,add->plus,add->minus,add->protect,add->timemode,add->timevalue);
}

//*****************************************************************************
//*
//*		AddFilesTime
//*
//*****************************************************************************
void _cdecl CDataFinderView::AddFilesTime(CProgressDlg *Dlg)
{
CDataFinderView	 *view=(CDataFinderView*)Dlg->GetVoid1();
int				  count;

	if(Dlg->IsStoped())view->list_wnd.Break();

	count = view->list_wnd.Count();

	if(view->last_count!=count)
		{
		char	buffer[64];

		view->last_count = count;
		sprintf(buffer,"Es wurden %i Dateien gefunden.",count);

		Dlg->SetText(1,buffer);
		}

}

//*****************************************************************************
//*
//*     StatusbarInit
//*
//*****************************************************************************
// Erzeugt eine neue Statuszeile
int CDataFinderView::StatusbarInit()
{
INT			brt[] =	{-10,-10,-15};
INT			ind[] =	{  0,  1,  2};
CMainFrame *wnd;


		wnd =(CMainFrame*)AfxGetMainWnd();
	if(!wnd)return 0;
		wnd->StatusbarInit(ind,brt,3);



return 1;
}
//*****************************************************************************
//*
//*     StatusbarExit
//*
//*****************************************************************************
// Erzeugt eine neue Statuszeile
int CDataFinderView::StatusbarExit()
{
CMainFrame	*wnd;

	wnd =(CMainFrame*)AfxGetMainWnd();
	wnd->StatusbarInit();

return 1;
}


//*****************************************************************************
//*
//*		OnBeginDrag
//*
//*****************************************************************************
void CDataFinderView::OnBeginDrag(NMHDR *pNmHdr,LRESULT *pResult)
{
CLB_DRAG   *drag=(CLB_DRAG*)pNmHdr;
CString		text;



	if(drag_on)return;

	find_wnd.GetSelectedText(text);

	drag_on = 1;
	DragText((LPCTSTR)text);
	drag_on = 0;


}


//*****************************************************************************
//*
//*		OnListStatus
//*
//*****************************************************************************
void CDataFinderView::OnListStatus(NMHDR *pNmHdr,LRESULT *pResult)
{
char		 buffer[32];
CFL_STATUS	*hdr=(CFL_STATUS*)pNmHdr;
CMainFrame	*wnd;
CWnd		*focus;

	*pResult=0;

	   focus=GetFocus();
	if(focus && focus->m_hWnd!=list_wnd.m_hWnd)return;

		wnd =(CMainFrame*)AfxGetMainWnd();
	if(!wnd || !IsWindow(wnd->m_hWnd))return;


	sprintf(buffer,"%i Datei%s",hdr->iCount,(hdr->iCount==1)? "":"en");

	wnd->StatusbarSet( 1, buffer );
	wnd->StatusbarSet( 2, hdr->pSizeText  );

}


//*****************************************************************************
//*
//*		OnBrowserRButton
//*
//*****************************************************************************
void CDataFinderView::OnBrowserRButton(NMHDR *pNmHdr,LRESULT *pResult)
{
CBC_RCLICK	*pRClick=(CBC_RCLICK*)pNmHdr;

	*pResult=0;
	StartMenu(pRClick->pPath);


}

//*****************************************************************************
//*
//*		OnMouseRButton
//*
//*****************************************************************************
void CDataFinderView::OnMouseRButton(NMHDR *pNmHdr,LRESULT *pResult)
{
int		item;


	*pResult=0;

	item=list_wnd.GetFocusItem();
	if(item<0 || item>=list_wnd.GetItemCount())return ;

	StartMenu(list_wnd.GetFileName(item,1));

}


//*****************************************************************************
//*
//*		OnFileStatus
//*
//*****************************************************************************
void CDataFinderView::OnFileStatus(NMHDR *pNmHdr,LRESULT *pResult)
{
CBC_STATUS	*hdr=(CBC_STATUS*)pNmHdr;
CMainFrame	*wnd;
CWnd		*focus;

	*pResult=0;


	   focus=GetFocus();
	if(focus && focus->m_hWnd==list_wnd.m_hWnd)return;




		wnd =(CMainFrame*)AfxGetMainWnd();
	if(!wnd || !IsWindow(wnd->m_hWnd))return;
		wnd->StatusbarSet( 1, (char*)hdr->pCountText);
		wnd->StatusbarSet( 2, (char*)hdr->pSizeText );

}


//*****************************************************************************
//*
//*		OnFolderSelect
//*
//*****************************************************************************
void CDataFinderView::OnFolderSelect(NMHDR *pNmHdr,LRESULT *pResult)
{
CBC_FOLDER	*hdr=(CBC_FOLDER*)pNmHdr;
CDocument	*doc;



	*pResult=0;

	   doc=GetDocument();
	if(doc)
		{
		doc->SetTitle(hdr->pPath);
		}
}






//*****************************************************************************
//*
//*		OnUpdate
//*
//*****************************************************************************
void CDataFinderView::OnUpdate(CView* pSender, LPARAM lHint, CObject* pHint)
{
CTextFind	 f;
CDocument	*doc;
CString		 pfad;
CRegKeys	 key;



	StatusbarInit();

	   doc=GetDocument();
	if(doc)
		{
		pfad=doc->GetPathName();
		if(pfad=="")
			{
			key.Open(0,CRK_READ);
			key.Get(pfad,"Path");
			}
		else{
			if(ExistFile(pfad)==1)
				{
				SubFileName(pfad);
				DelBackSlash(pfad);
				}
			}

		if(ExistFile(pfad)>=2)file_wnd.SetPath(pfad);
		doc->SetTitle(pfad);
		}


}

//*****************************************************************************
//*
//*		OnFilesUpdate
//*
//*****************************************************************************
void CDataFinderView::OnFilesUpdate(CCmdUI *pCmdUI)
{

	pCmdUI->Enable(list_wnd.Count());

}

//*****************************************************************************
//*
//*		OnFindText
//*
//*****************************************************************************
void CDataFinderView::OnFindText()
{
CString		text;


	if(find_wnd.IsSeleced() && find_wnd.GetSelectedText(text)==1)
		{
		FindText(text);							// Suche markierten Text
		}
	else{
		FindText(0);
		}

}

//*****************************************************************************
//*
//*		FindText
//*
//*****************************************************************************
void CDataFinderView::FindText(const char *Text)
{
char			str[64];
char		   *text;
CMainFrame	   *wnd;
CTextFindDlg	dlg;
CProgressDlg	pdlg;
CStringChain	list;
int				flags;
int				mode;
int				line;
int				anz;



	dlg.SetListMode(list_count>0);

	if(dlg.DoModal(Text)!=IDOK)return;

	file_bytes	= 0;							// Gesamt Dateilnge berechnen
	last_count	=-1;
	anz			= list_wnd.GetItemCount();
	file_bytes	= list_wnd.GetSizeAll();
	flags		= dlg     .GetFlags();

	if(flags&FLAG_FIND_USE_RESULTS)
		{
		GetFileList(&list,1);
		}

	line =dlg.GetLines();
	text =dlg.GetText();
	find_wnd .ResetContent();
	find_text.Delete();

	if(flags&FLAG_FIND_EXPRESSION)
	if(text[strcwlen(text,0x01900000)]==0)
		{
		flags&=~FLAG_FIND_EXPRESSION;
		}
								    mode =0;
	if(flags&FLAG_FIND_CASE        )mode|=CTF_NOCASE;
	if(flags&FLAG_FIND_WORD		   )mode|=CTF_WORD;
	if(flags&FLAG_FIND_EXPRESSION  )mode|=CTF_SPECIAL;
	if(flags&FLAG_FIND_MULTILINNE  )mode|=CTF_MULTLINE;
	
	pdlg.SetPriority(-2);
	pdlg.SetTitle("Textsuche");
	pdlg.SetTime (FindTextTime,300);
	pdlg.SetProc (FindTextProc,this,text,&mode,&line,(flags&FLAG_FIND_USE_RESULTS)? &list:NULL);
	pdlg.SetText ("Suche in :  ",list_wnd.GetFileName(0,1));
	pdlg.SetRange(1024);
	pdlg.SetLines(2);
	pdlg.DoModal();

	   anz =find_text.Count();
	if(anz>=find_text.GetMaxCount())
		{
		MessageBox("Es wurden zuviele Eintrge gefunden.");
		}

	   wnd =(CMainFrame*)AfxGetMainWnd();
	if(wnd && IsWindow(wnd->m_hWnd))
		{
		sprintf(str,"%i Eintrge",anz);
		wnd->StatusbarSet( 0, str );
		}

	SetTextResult();
	SetFindWnd(1);

}

//*****************************************************************************
//*
//*		SetTextResult
//*
//*****************************************************************************
void CDataFinderView::SetTextResult()
{
int				anz,x,y,p1,p2,p3,num,len,add;
char			str[1024];
BYTE			col[1024];
char			sign;
LPCTSTR			name;


	anz = find_text.Count();

	for(x=0;x<anz;x++)
		{
		len=find_text.GetText(x,str,sizeof(str),32);
		for(y=0;str[y];y++)if(str[y]=='\t')str[y]=' ';
		len=y;

		for(y=2;y<len;y++)if(str[y]==':')break;	p3=y;
		for(   ;y>0  ;y--)if(str[y]==')')break;	p2=y;
		for(   ;y>0  ;y--)if(str[y]=='(')break;	p1=y;

		memset(col   ,4,p1    );
		memset(col+p1,6,p2 -p1);
		memset(col+p2,0,len-p2);

		for(y=0;y<p1;y++)
			{
			if(str[y]!='\\')continue;
			col[y]=0;
			}

		col[p2]=5;			 
		col[p1]=5;

		name = find_text.GetFileName(x,num);

		if(CmpFileType(name,"c;cpp;cc;cxx;h;hpp;rc;rc2",num))
			{
			num = 0;
			p3++;

			for(y=p3;y<len;y++)
				{
				if(str[y]=='"')					// Text gefunden
					{
					add = strlenstr(str+y,'\\','"',len-y);
					memset(col+y,9,add);
					y  += add-1;
					num = 0;
					continue;
					}

				if(str[y]=='\'')				// '...' gefunden
					{
					add = strlchar(str+y+1,'\'',len-y,'\\')+1;
					memset(col+y,9,add);
					y  += add-1;
					num = 0;
					continue;
					}

				if(str[y]=='/')					// Kommentar gefunden
					{
					if(str[y+1]=='/')
						{
						add = len-y;
						memset(col+y,8,add);
						break;
						}

					if(str[y+1]=='*')
						{
						add = strlfind(str+y,"*/",len-y,2);
						if(add<0)add=len-y;
						else     add+=2;
						memset(col+y,8,add);
						y += add-1;
						continue;
						}
					}

				if(str[y]=='#')					// Makro gefunden
					{
					add = strwlen(str+y+1,0xA0,len-y-1)+1;

					if(strwchar(str[y+add],0x0E))
						{
						add += strwlen(str+y+add,0x0F,len-y-add);
						memset(col+y,10,add);
						y   += add-1;
						num  = 1;
						continue;
						}
					}

				if(str[y]=='<' && num==1)		// #include <...> gefunden
					{
					add = strlenstr(str+y,'\\','<',len-y);
					memset(col+y,9,add);
					y  += add-1;
					num = 0;
					continue;
					}
												// #define NAME gefunden
				if(num==1 && strwchar(str[y],0x0E))
					{
					add = strwlen(str+y,0x0F,len-y);
					memset(col+y,12,add);
					y  += add-1;
					num = 0;
					continue;
					}

				if(str[y]=='(' && num==0)		// Funktion gefunden
					{
					add  = strbwlen(str+y    ,0xA0,y-p3    );
					add += strbwlen(str+y-add,0x0F,y-p3-add);

					if(strwchar(str[y-add],0x0E) && col[y-add]==13)
						{
						memset(col+y-add,11,add);
						}
					}


				if(strwchar(str[y],0x01))		// Zahl gefunden
					{
					if(str[y]=='0' && (str[y+1]=='x' || str[y+1]=='X'))
						{
						add  = strwlen(str+y+2,0x00040001,len-y-2)+2;
						}
					else{
						add  = strwlen(str+y+1,0x00000001,len-y-1)+2;
						}

					memset(col+y,12,add);
					y += add-1;
					}
				else if(strwchar(str[y],0x0E))	// Buchstaben gefunden
					{
					col[y] = 13;
					num    = 0;

					if(!strwchar(str[y-1],0x0F))// Auf Schlsselwort prfen
						{
						name = str+y;
						add  = strwlen(str+y,0x0F,len-y);
						sign = str[y+add];

						str[y+add] = 0;
												// Ist das Wort in der Liste
						if(bsearch(&name,cpp_words,sizeof(cpp_words)/sizeof(cpp_words[0]),sizeof(cpp_words[0]),SortWords))
							{
							str[y+add] = sign;
							memset(col+y,10,add);
							y += add-1;
							}					// Nur Grobuchstaben
						else if(strwlen(str+y,0x0B,len-y)==add)
							{
							str[y+add] = sign;
							memset(col+y,12,add);
							y += add-1;
							}
						else{					// Graues Wort
							str[y+add] = sign;
							memset(col+y,13,add);
							y += add-1;
							}
						}
					}
				else if(!strwchar(str[y],0xA0))
					{
					num = 0;
					}
				}
			}
		else if(CmpFileType(name,"xml;htm;html;rdf;xul;col;co_;svg;xlu;dtd;gpf;dcf;gpx;kml;resx;user;csproj;vcproj;vcxproj;filters;hhk;hhc",num))
			{
			num = 0;
			p3++;

			for(y=p3;y<len;y++)
				{
				if(str[y]=='"' || str[y]=='\'')	// Text gefunden
					{
					add = strlenstr(str+y,'\\',str[y],len-y);
					memset(col+y,9,add);
					y  += add-1;
					continue;
					}

				if(str[y]=='<')					// XML-Tag-Beginn
					{
					col[y] = 16; y++;
					if(str[y]=='/'){col[y]=0;y++;}
					if(strwchar(str[y],0x3000000E))
						{
						add = strwlen(str+y,0x3000000F);
						memset(col+y,14,add);
						y  += add;
						}
					y--;
					num = 1;
					continue;
					}

				if(str[y]=='>' && num)			// XML-Tag-Ende
					{
					col[y] = 16;
					num = 0;
					continue;
					}
												// Text innerhalb Tag
				if(num && strwchar(str[y],0x3000000E))
					{
					add = strwlen(str+y,0x3000000F);
					memset(col+y,(str[y+add]=='=')? 15:10,add);
					y  += add-1;
					continue;
					}

				if(strwchar(str[y],0x01))		// Zahl gefunden
					{
					add = strwlen(str+y,0x07);
					memset(col+y,11,add);
					y  += add-1;
					continue;
					}
				}
			}


		find_wnd.AddString(str,col,len);
		}

	list_mode	=0;					// 0=Text 1=Hex 2=Cmp
	list_count	=anz;				// Anzahl der gefunden Eintrge

	if(anz==0)find_wnd.AddString("Keine Eintrge gefunden.");

}

//*****************************************************************************
//*
//*		SortWords
//*
//*****************************************************************************
int _cdecl CDataFinderView::SortWords(const void *pPtr1,const void *pPtr2)
{
const char **pText1=(const char**)pPtr1;
const char **pText2=(const char**)pPtr2;

return strcmp(*pText1,*pText2);
}

//*****************************************************************************
//*
//*		FindTextProc
//*
//*****************************************************************************
int _cdecl CDataFinderView::FindTextProc(CProgressDlg *Dlg)
{
CDataFinderView	*view=(CDataFinderView*)Dlg->GetVoid1();
char			*text=(char*)			Dlg->GetVoid2();
int				 mode=*(int*)			Dlg->GetVoid3();
int				 line=*(int*)			Dlg->GetVoid4();
CStringChain	*list=(CStringChain   *)Dlg->GetVoid5();
int				 ret;


	view->CheckCache();
	view->find_text.SetChache((view->cache_max>0)? &view->cache_data:0,view->cache_max);
	view->find_text.SetLineCount(line&0xFF);

	if(list)
		{
		ret = view->find_text.Find(list,text,mode);
		}
	else{
		ret = view->find_text.Find(view->list_wnd.GetFiles(),text,mode);
		}


return ret;
}

//*****************************************************************************
//*
//*		FindTextTime
//*
//*****************************************************************************
void _cdecl CDataFinderView::FindTextTime(CProgressDlg *Dlg)
{
CDataFinderView	*view=(CDataFinderView*)Dlg->GetVoid1();
static int	last,pos,old;
__int64		wo,range;
int			count;
LPCTSTR		text;


	wo     =	 	   view->find_text.GetSearchByte();
	wo    += (unsigned)view->find_text.GetSearchPos ();
	count  = 		   view->find_text.Count        ();
	range  = (((__int64)1024)*wo)/view->file_bytes;

	if(old!=(int)range)
		{
		old=(int)range;
		Dlg->SetPos(old);
		}

	   pos=view->find_text.GetSearchFile();
	if(pos!=last)
		{


		text=view->list_wnd.GetFileName(pos,1);
		Dlg->SetText("Suche in :  ",text);
		pos=last;

		if(Dlg->IsStoped())view->find_text.Break();
		}


	if(view->last_count!=count)
		{
		char	buffer[64];

		view->last_count = count;
		sprintf(buffer,"Es wurden %i Eintrge gefunden.",count);

		Dlg->SetText(1,buffer);
		}

}

//*****************************************************************************
//*
//*		OnFindHex
//*
//*****************************************************************************
void CDataFinderView::OnFindHex()
{
CMainFrame	   *wnd;
CRegKeys		key;
CProgressDlg	pdlg;
CHexFindDlg		dlg;
int				flags=0,mode,anz,x;
char			str[64],*m_pGroup=0,*auswahl=0,*ergebnis=0,*text=0;





	if(key.Open( HKEY_CURRENT_USER,0,CRK_READ))
	if(key.Up  ( "HexSeach"))
		{
		key.Get ( flags, "Flags");
		key.Get ((void**)&auswahl, "Strings", REG_MULTI_SZ );
		key.Get ((void**)&m_pGroup , "Group"  , REG_MULTI_SZ );
		}

	if(auswahl)text=auswahl;
	if(dlg.DoModal(&flags,&auswahl,&m_pGroup,&ergebnis,text)!=IDOK)
		{
		if(m_pGroup  )delete m_pGroup;
		if(auswahl )delete auswahl;
		if(ergebnis)delete ergebnis;
		return;
		}

	last_count=-1;
	file_bytes=0;						// Gesamt Dateilnge berechnen
	anz=list_wnd.GetItemCount();
	for(x=0;x<anz;x++)
		{
		file_bytes+=(unsigned)list_wnd.GetFileLength(x);
		}

	find_wnd.ResetContent();
	find_hex.Delete();

	mode=(flags&HEX_FIND_IN_ORDER)? CHF_SAMEPOS:0;

	pdlg.SetPriority(-2);
	pdlg.SetTitle("HEX-Suche");
	pdlg.SetTime (FindHexTime,300);
	pdlg.SetProc (FindHexProc,this,ergebnis,&mode);
	pdlg.SetText ("Suche in :  ",list_wnd.GetFileName(0,1));
	pdlg.SetRange(1024);
	pdlg.SetLines(2);
	pdlg.DoModal();

	   anz =find_hex.Count();
	if(anz>=find_hex.GetMaxCount())
		{
		MessageBox("Es wurden zuviele Eintrge gefunden.");
		}

	   wnd =(CMainFrame*)AfxGetMainWnd();
	if(wnd && IsWindow(wnd->m_hWnd))
		{
		sprintf(str,"%i Eintrge",anz);
		wnd->StatusbarSet( 0, str );
		}

	if(key.Open( HKEY_CURRENT_USER,0,CRK_CREATE))
	if(key.Up  ( "HexSeach"))
		{
		key.Set ( flags,  "Flags");
		key.Set ( auswahl,256,"Strings",REG_MULTI_SZ );
		key.Set ( m_pGroup ,256,"Group"  ,REG_MULTI_SZ );
		}

	if(m_pGroup)delete m_pGroup;
	if(auswahl )delete auswahl;
	if(ergebnis)delete ergebnis;

	SetHexResult();
	SetFindWnd(1);
}

//*****************************************************************************
//*
//*		SetHexResult
//*
//*****************************************************************************
void CDataFinderView::SetHexResult()
{
int				flags=0,anz,x,y,len,p1,p2;
char			str[1024];
BYTE			col[1024];


	anz=find_hex.Count();

	for(x=0;x<anz;x++)
		{
		find_hex.GetText(x,str,sizeof(str),32);
		for(y=0;str[y];y++)if(str[y]=='\t')str[y]=' ';
		len=y;

		for(y=2;y<len;y++)if(str[y]==':')break;
		for(   ;y>0  ;y--)if(str[y]==')')break;	p2=y;
		for(   ;y>0  ;y--)if(str[y]=='(')break;	p1=y;

		y =len-p2-4;
		y-=y/16;
		y/=4;
		y*=3;
		y+=y/12+3;
		if(y<0)y=0;

		memset(col     ,4,p1    );
		memset(col+p1  ,6,p2 -p1);
		memset(col+p2  ,0,len-p2);
		memset(col+p2+1,7,y);
		col[p2]=5;
		col[p1]=5;

		find_wnd.AddString(str,col);
		}

	list_mode	=1;					// 0=Text 1=Hex 2=Cmp
	list_count	=anz;				// Anzahl der gefunden Eintrge

	if(anz==0)find_wnd.AddString("Keine Eintrge gefunden.");

}

//*****************************************************************************
//*
//*		FindHexProc
//*
//*****************************************************************************
int _cdecl CDataFinderView::FindHexProc(CProgressDlg *Dlg)
{
CDataFinderView	*view=(CDataFinderView*)Dlg->GetVoid1();
char			*text=(char*)			Dlg->GetVoid2();
int				 mode=*(int*)			Dlg->GetVoid3();


	view->CheckCache();
	view->find_hex.SetChache((view->cache_max>0)? &view->cache_data:0,view->cache_max);

return view->find_hex.Find(view->list_wnd.GetFiles(),text,mode);
}

//*****************************************************************************
//*
//*		FindHexTime
//*
//*****************************************************************************
void _cdecl CDataFinderView::FindHexTime(CProgressDlg *Dlg)
{
CDataFinderView	*view=(CDataFinderView*)Dlg->GetVoid1();
static int	last,pos,old;
__int64		wo,range;
int			count;
LPCTSTR		text;



	wo    =			  view->find_hex.GetSearchByte();
	wo   += (unsigned)view->find_hex.GetSearchPos ();
	count =  		  view->find_hex.Count        ();
	range = (((__int64)1024)*wo)/view->file_bytes;

	if(old!=(int)range)
		{
		old=(int)range;
		Dlg->SetPos(old);
		}


	   pos=view->find_hex.GetSearchFile();
	if(pos!=last)
		{
		text=view->list_wnd.GetFileName(pos,1);
		Dlg->SetText("Suche in :  ",text);
		pos=last;

		if(Dlg->IsStoped())view->find_hex.Break();
		}


	if(view->last_count!=count)
		{
		char	buffer[64];

		view->last_count = count;
		sprintf(buffer,"Es wurden %i Eintrge gefunden.",count);

		Dlg->SetText(1,buffer);
		}

}

//*****************************************************************************
//*
//*		CmpLineFeeds
//*
//*****************************************************************************
//	Prft ob eine Dateien bit auf ihre Linefeeds gleich sind. 
//	File1		: Ist der Name der Ersten  Datei
//	File2		: Ist der Name der zweiten Datei
//	Ergibt 0 wenn die beiden Dateien gleich sind
int _cdecl CDataFinderView::CmpLineFeeds(const char *File1,const char *File2)
{
CMapFile	map1;
CMapFile	map2;
char	   *ptr1;
char	   *ptr2;
int			len1;
int			len2;
int			pos1;
int			pos2;


	ptr1 = map1.Open(File1,&len1);
	ptr2 = map2.Open(File2,&len2);

	if(!ptr1)
		{
		if(ptr2)return -1;
		if(LengthFile(File1)!=0)return -1;
		if(LengthFile(File2)!=0)return -1;
		return 0;											
		}

	if(!ptr2)
		{
		if(ptr1)return 1;
		if(LengthFile(File1)!=0)return 1;
		if(LengthFile(File2)!=0)return 1;
		return 0;
		}

	
	pos1 = 0;
	pos2 = 0;

	while(pos1<len1 && pos2<len2)
		{
		if(ptr1[pos1]==ptr2[pos2])
			{
			pos1++;
			pos2++;
			continue;
			}

		if(ptr1[pos1]!='\n' && ptr1[pos1]!='\r')
			{
			return ptr1[pos1]-ptr2[pos2];
			}
	
		if(ptr2[pos2]!='\n' && ptr2[pos2]!='\r')
			{
			return ptr1[pos1]-ptr2[pos2];
			}

		if(ptr1[pos1]=='\r' && pos1+1<len1 && ptr1[pos1+1]=='\n')
			{
			pos1++;
			}

		if(ptr2[pos2]=='\r' && pos2+1<len2 && ptr2[pos2+1]=='\n')
			{
			pos2++;
			}

		pos1++;
		pos2++;
		}


	if(pos1<len1)return  1;
	if(pos2<len2)return -1;



return 0;
}

//*****************************************************************************
//*
//*		CmpFilesProc
//*
//*****************************************************************************
int _cdecl CDataFinderView::CmpFilesProc(CProgressDlg *Dlg)
{
CDataFinderView	*view =(CDataFinderView*)Dlg->GetVoid1();
CStringChain	*files=(CStringChain*)	 Dlg->GetVoid2();
int				 max  =					 Dlg->GetInt3();
int				 flags=					 Dlg->GetInt4();
char			 buffer[MAX_PATH+128],mem1[4096],mem2[4096],*name;
int				 i,j,k,nr,pos,size,add,len,temp,exist;
DWORD			 attrib1,attrib2,diff,found;
FILE			*file1,*file2;
__int64			 progress;



	add = files->Len(0);
	pos = files->Len(1);

	progress = 0;
	found	 = 0;


	if(flags&8)											// Neue Dateien suchen
		{
		CFileFinder	suchen;

		strlcpy(buffer,files->Get(1),sizeof(buffer));
		suchen.Set(files->Get(1),CFF_FIND_SUBDIR,files->Get(2),files->Get(3));
		files->Sort(4,-1,CSC_SORT_CASE);
		strlcpy(buffer,files->Get(0),sizeof(buffer));

		for(;;)
			{
				name=suchen.Next(2);
			if(!name)break;

			strlcpy(buffer+add,name,sizeof(buffer)-add);
			i=files->FindFast(buffer,4,-1,1);
			if(i<0)
				{
				i=3;
				j=strlen(buffer);
				k=1+16-(j&15);
				memset(buffer+j,' ',k);j+=k;
				strlcpy(buffer+j,":Neue Datei gefunden",sizeof(buffer)-j);
				view->cmp_return.Add(buffer,-1,&i);
				continue;
				}
			}
		}


	strlcpy(buffer,files->Get(1),sizeof(buffer));


	for(nr=4;nr<files->Count();nr++)					// Dateischleife
		{
		   Dlg->SetPos(progress);
		if(Dlg->IsStoped())break;


		if(view->cmp_return.Count()>=MAX_DIFF)break;

		name=files->Get(nr);
		strlcpy(buffer+pos,name+add,sizeof(buffer)-pos);

		size=LengthFile(buffer);
		Dlg->SetText("Vergleiche in :  ",name);

		   exist = (size>=0);
		if(exist)found++;

		if(flags&4)										// Existiert die Datei
			{
			if(exist!=1)
				{
				i=2;
				j=strlcpy(mem1,name,sizeof(mem1));
				k=1+16-(j&15);
				memset(mem1+j,' ',k);j+=k;
				strlcpy(mem1+j,":Datei existiert nicht",sizeof(mem1)-j);
				view->cmp_return.Add(mem1,-1,&i);
				progress+=size;
				continue;
				}
			}
		else{
			if(flags&3)
				{
				if(exist!=1)
					{
					progress+=size;
					continue;
					}
				}
			}

		if(flags&2)										// Attribute vergeichen
			{
			attrib1 = GetFileAttributes(name);
			attrib2 = GetFileAttributes(buffer);

			if(attrib1!=0xFFFFFFFF)
			if(attrib2!=0xFFFFFFFF)
				{
				diff=(attrib1^attrib2)&(FILE_ATTRIBUTE_HIDDEN|FILE_ATTRIBUTE_READONLY|FILE_ATTRIBUTE_SYSTEM|FILE_ATTRIBUTE_ARCHIVE);

				if(diff)
					{
					i=1;
					j=strlen(buffer);
					temp=j;
					k=1+16-(j&15);
					memset(buffer+j,' ',k);j+=k;
					j+=strlcpy(buffer+j,":",sizeof(buffer)-j);
					if(diff&FILE_ATTRIBUTE_HIDDEN  )j+=strlcpy(buffer+j,(attrib2&FILE_ATTRIBUTE_HIDDEN  )? "HIDDEN+" :"HIDDEN-" ,sizeof(buffer)-j);
					if(diff&FILE_ATTRIBUTE_READONLY)j+=strlcpy(buffer+j,(attrib2&FILE_ATTRIBUTE_READONLY)? "RONLY+"  :"RONLY-"  ,sizeof(buffer)-j);
					if(diff&FILE_ATTRIBUTE_SYSTEM  )j+=strlcpy(buffer+j,(attrib2&FILE_ATTRIBUTE_SYSTEM  )? "SYSTEM+" :"SYSTEM-" ,sizeof(buffer)-j);
					if(diff&FILE_ATTRIBUTE_ARCHIVE )j+=strlcpy(buffer+j,(attrib2&FILE_ATTRIBUTE_ARCHIVE )? "ARCHIVE+":"ARCHIVE-",sizeof(buffer)-j);
					strlcpy(buffer+j,"",sizeof(buffer)-j);
					view->cmp_return.Add(buffer,-1,&i);
					buffer[temp]=0;
					}
				}
			}

		if(flags&1)										// Vergleiche die Dateien
			{
			i=LengthFile(buffer);

			if(i<0)
				{
				if(!(flags&4))continue;
				i=2;
				j=strlen(buffer);
				k=1+16-(j&15);
				memset(buffer+j,' ',k);j+=k;
				strlcpy(buffer+j,":Datei existiert nicht",sizeof(buffer)-j);
				view->cmp_return.Add(buffer,-1,&i);
				progress+=size;
				continue;
				}

			if(i!=size)
				{
				if(flags&0x10 && !CmpLineFeeds(name,buffer))
					{
					continue;
					}

				i=0;
				j=strlen(buffer);
				k=1+16-(j&15);
				memset(buffer+j,' ',k);j+=k;
				strlcpy(buffer+j,":andere Lnge",sizeof(buffer)-j);
				view->cmp_return.Add(buffer,-1,&i);
				progress+=size;
				continue;
				}

			if(flags&0x10)
				{
				if(!CmpLineFeeds(name,buffer))continue;

				i=0;
				j=strlen(buffer);
				k=1+16-(j&15);
				memset(buffer+j,' ',k);j+=k;
				strlcpy(buffer+j,":verndert",sizeof(buffer)-j);
				view->cmp_return.Add(buffer,-1,&i);
				progress+=size;
				continue;
				}				


				file1=fopen(name,"rb");
			if(!file1)
				{
				i=4;
				j=strlcpy(buffer,name,sizeof(buffer));
				k=1+16-(j&15);
				memset(buffer+j,' ',k);j+=k;
				strlcpy(buffer+j,":Fehler beim ffnen",sizeof(buffer)-j);
				view->cmp_return.Add(buffer,-1,&i);
				progress+=size;
				continue;
				}

				file2=fopen(buffer,"rb");
			if(!file2)
				{
				i=4;
				j=strlen(buffer);
				k=1+16-(j&15);
				memset(buffer+j,' ',k);j+=k;
				strlcpy(buffer+j,":Fehler beim ffnen",sizeof(buffer)-j);
				view->cmp_return.Add(buffer,-1,&i);
				progress+=size;
				fclose(file1);
				continue;
				}

			for(i=0;i<size;i+=len)						// Vergleiche Dateien
				{
				len = size-i;
				if(len>sizeof(mem1))len=sizeof(mem1);

				fread(mem1,1,len,file1);
				fread(mem2,1,len,file2);

				if(memcmp(mem1,mem2,len))
					{
					i=0;
					j=strlen(buffer);
					k=1+16-(j&15);
					memset(buffer+j,' ',k);j+=k;
					strlcpy(buffer+j,":verndert",sizeof(buffer)-j);
					view->cmp_return.Add(buffer,-1,&i);
					progress+=size-i;
					break;
					}

				progress+=len;
				}

			fclose(file1);
			fclose(file2);
			}
		}

	if(found==0 && !(flags&4))							// Keine Datei gefunden
		{
		return 2;
		}


return 1;
}



//*****************************************************************************
//*
//*		CopyFilesProc
//*
//*****************************************************************************
int _cdecl CDataFinderView::CopyFilesProc(CProgressDlg *Dlg)
{
CDataFinderView	*view =(CDataFinderView*)Dlg->GetVoid1();
CStringChain	*files=(CStringChain*)	 Dlg->GetVoid2();
int				 max  =					 Dlg->GetInt3();
int				 flags=					 Dlg->GetInt4();
char			 buffer[MAX_PATH+128],text[MAX_PATH+128],*name;
int				 i,nr,pos,add,len,info;
DWORD			 attrib1,attrib2,count;
__int64			 progress;



	add = files->Len(0);
	pos = files->Len(1);

	progress = 0;
	count	 = 0;


	strlcpy(buffer,files->Get(1),sizeof(buffer));


	for(nr=2;nr<files->Count();nr++)					// Dateischleife
		{
		   Dlg->SetPos(progress);
		if(Dlg->IsStoped())break;


		if(view->cmp_return.Count()>=MAX_DIFF)break;

		name = files->Get(nr);
		len  = files->DataGet(nr);

		strlcpy(buffer+pos,name+add,sizeof(buffer)-pos);

		Dlg->SetText("Kopiere :  ",name);


		info	= 0;
		attrib1 = GetFileAttributes(name);
		attrib2 = GetFileAttributes(buffer);

		if(attrib1==0xFFFFFFFF)
			{
			sprintf(text,"Die Datei %s existiert nicht !",name);
			Dlg->MessageBox(text,"Warnung",MB_OK|MB_ICONWARNING);
			continue;
			}
														
		if(attrib2!=0xFFFFFFFF)							// Existiert die Zieldatei
			{
			if(flags&1)									// Nie berschreiben
				{
				progress += len;
				continue;
				}

			if(attrib2&FILE_ATTRIBUTE_READONLY)			// Ist die Zieldatei schreibgeschtzt
				{
				if(flags&2)
					{
					SetFileAttributes(buffer,FILE_ATTRIBUTE_NORMAL);
					}
				else{
					sprintf(text,"Die Datei %s ist schreibgeschtzt !\nSoll sie berschreiben werden ?",buffer);
					i=Dlg->MessageBox(text,"Warnung",MB_YESNOCANCEL|MB_ICONWARNING);
					if(i==IDCANCEL)break;
					if(i!=IDYES)
						{
						progress += len;
						continue;
						}
					
					info = 1;
					}
				}

			if((flags&4) && !info)						// Fragen ob berschreiben
				{
				sprintf(text,"Die Datei %s existiert bereits !\nSoll sie berschreiben werden ?",buffer);
				i=Dlg->MessageBox(text,"Warnung",MB_YESNOCANCEL|MB_ICONWARNING);
				if(i==IDCANCEL)break;
				if(i!=IDYES)
					{
					progress += len;
					continue;
					}
				
				info = 1;
				}			
			}


		if((flags&8) && !info)						// Immer fragen
			{
			sprintf(text,"Soll die Datei %s kopiert werden ?",name);
			i=Dlg->MessageBox(text,"Frage",MB_YESNOCANCEL|MB_ICONQUESTION);
			if(i==IDCANCEL)break;
			if(i!=IDYES)
				{
				progress += len;
				continue;
				}
			
			info = 1;
			}			

		if(!CopyFile(name,buffer,FALSE))
			{
			sprintf(text,"Soll die Datei %s konnte nicht kopiert werden !\nNochmals versuchen ?",name);
			i=Dlg->MessageBox(text,"Frage",MB_YESNOCANCEL|MB_ICONQUESTION);
			if(i==IDCANCEL)break;
			
			if(i==IDYES)
				{
				nr--;
				continue;
				}
			
			
			}
		else{
			count++;
			}
		
		progress += len;
		}


return count;
}



//*****************************************************************************
//*
//*		OnCut
//*
//*****************************************************************************
void CDataFinderView::OnCut()
{
CWnd	*wnd;

	wnd=GetFocus();

	if(!wnd)return;

	if(wnd->m_hWnd==file_wnd.m_hWnd){file_wnd.SendMessage(WM_CUT);return;}
	if(wnd->m_hWnd==list_wnd.m_hWnd){list_wnd.SendMessage(WM_CUT);return;}

		wnd=wnd->GetParent();
	if(!wnd)return;

	if(wnd->m_hWnd==file_wnd.m_hWnd)file_wnd.SendMessage(WM_CUT);
}

//*****************************************************************************
//*
//*		OnCopy
//*
//*****************************************************************************
void CDataFinderView::OnCopy()
{
CWnd	*wnd;

	wnd=GetFocus();

	if(!wnd)return;

	if(wnd->m_hWnd==file_wnd.m_hWnd){file_wnd.SendMessage(WM_COPY);return;}
	if(wnd->m_hWnd==list_wnd.m_hWnd){list_wnd.SendMessage(WM_COPY);return;}
	if(wnd->m_hWnd==find_wnd.m_hWnd){find_wnd.SendMessage(WM_COPY);return;}

		wnd=wnd->GetParent();
	if(!wnd)return;

	if(wnd->m_hWnd==file_wnd.m_hWnd)file_wnd.SendMessage(WM_COPY);

}

//*****************************************************************************
//*
//*		OnPaste
//*
//*****************************************************************************
void CDataFinderView::OnPaste()
{
CWnd	*wnd;

	wnd=GetFocus();

	if(!wnd)return;

	if(wnd->m_hWnd==file_wnd.m_hWnd){file_wnd.SendMessage(WM_PASTE);return;}
	if(wnd->m_hWnd==list_wnd.m_hWnd){list_wnd.SendMessage(WM_PASTE);return;}

		wnd=wnd->GetParent();
	if(!wnd)return;

	if(wnd->m_hWnd==file_wnd.m_hWnd)file_wnd.SendMessage(WM_PASTE);

}

//*****************************************************************************
//*
//*		SetFindWnd
//*
//*****************************************************************************
//	Schaltet die Ergebnisliste ein oder aus
void CDataFinderView::SetFindWnd(BOOL On)
{

	if( list_on &&  On)return;
	if(!list_on && !On)return;

	list_on=!list_on;

	if(::IsWindow(m_hWnd))
		{
		SetSize();
		RedrawWindow();
		}

}


//*****************************************************************************
//*
//*		OnFindDblClk
//*
//*****************************************************************************
void CDataFinderView::OnFindDblClk()
{
int			nr,pos,len,mode;
char	   *file,text[1024];
char		pfad[MAX_PATH];
char		prog[MAX_PATH];
CRegKeys	key;


	   nr=find_wnd.GetCurSel();
	if(nr>=list_count)return;
	if(nr<0)return;


	find_wnd.GetText(nr,text);

	if(list_mode==2)						// Cmp Daten
		{
		if(nr>=cmp_return.Count())return;

		   mode=cmp_return.DataGet(nr);
		if(mode!=0)
			{
			MessageBox((mode>=2)? "Die Datei existiert nicht !":"Die Dateien sind gleich !");
			return;
			}

		for(;;)
			{
			if(key.Open())
			if(key.Get(prog,sizeof(prog),"TextCompare"))
				{
				file=prog;
				if(ExistFile(file)==1)break;
				}

			file="C:\\Windows\\TextCompare.exe";
			if(ExistFile(file)==1)break;

			GetExePath(prog);
			AddFileName(prog,"TextCompare.exe",sizeof(prog));
			file=prog;

			if(ExistFile(file)==1)break;
			GetWindowsDirectory(prog,sizeof(prog));
			AddFileName(prog,"TextCompare.exe",sizeof(prog));
			file=prog;
			if(ExistFile(file)==1)break;

			file="D:\\MyProjects\\TextCompare\\Release\\TextCompare.exe";
			if(ExistFile(file)==1)break;

			return;
			}


		CStartProg	prog_cmp;


		pos=cmp_path2.GetLength();
		len=strchar(text+pos,':')+pos;
		while(len>0 && text[len-1]==' ')len--;
		text[len]=0;

		strlcpy(pfad,cmp_path1,sizeof(pfad));
		strlcat(pfad,text+pos,sizeof(pfad));


		if(ExistFile(pfad)!=1)
			{
			CString	sText;
			sText.Format("Die Datei %s existiert nicht zum Vergleichen !",(LPCSTR)pfad);
			this->MessageBox(sText,"Fehler",MB_OK|MB_ICONERROR);
			return;
			}

		if(ExistFile(text)!=1)
			{
			CString	sText;
			sText.Format("Die Datei %s existiert nicht zum Vergleichen !",(LPCSTR)text);
			this->MessageBox(sText,"Fehler",MB_OK|MB_ICONERROR);
			return;
			}



		prog_cmp.SetFilename(file);
		prog_cmp.SetParam(pfad);
		prog_cmp.SetParam(text);

		if(CmpFileType(pfad,"c;cpp;h;hpp;asm;inl") || CmpFileType(text,"c;cpp;h;hpp;asm"))
			{
			prog_cmp.SetParam("-S");
			}

		prog_cmp.Start();
		prog_cmp.WaitForInit();

		}
	else if(list_mode==1)					// Hex Daten
		{
		if(!prog_hex.IsRunning())
			{
			for(;;)
				{
				if(key.Open())
				if(key.Get(pfad,sizeof(pfad),"HexEditor"))
					{
					file=pfad;
					if(ExistFile(file)==1)break;
					}
				file="C:\\Windows\\HexEditor.exe";
				if(ExistFile(file)==1)break;
				file="D:\\MyProjects\\HexEditor\\Release\\HexEditor.exe";
				if(ExistFile(file)==1)break;
				GetExePath(pfad);
				AddFileName(pfad,"HexEditor.exe",sizeof(pfad));
				file=pfad;
				if(ExistFile(file)==1)break;
				GetWindowsDirectory(pfad,sizeof(pfad));
				AddFileName(pfad,"HexEditor.exe",sizeof(pfad));
				file=pfad;
				if(ExistFile(file)==1)break;
				return;
				}
			prog_hex.SetFilename(file);
			prog_hex.Start();
			prog_hex.WaitForInit();
			}

		if(!APPWND_CMPDOCNAME(&prog_hex,find_hex.GetFileName(nr)))
			{
			APPWND_LOADFILE(&prog_hex,find_hex.GetFileName(nr));
			}

		pos=find_hex.GetPos(nr);
		HEXWND_SETCURSOR(&prog_hex,pos);
		HEXWND_SETSCROLL(&prog_hex,pos-5*16);
						  prog_hex.SetFocus();
		}
	else if(list_mode==0)
		{
		if(!prog_text.IsRunning())
			{
			for(;;)
				{
				if(key.Open())
				if(key.Get (pfad,sizeof(pfad),"Editor"))
					{
					file=pfad;
					if(ExistFile(file)==1)break;
					}

				GetExePath(pfad);
				AddFileName(pfad,"..\\Editor\\Editor.exe",sizeof(pfad));
				file=pfad;
				if(ExistFile(file)==1)break;

				GetExePath(pfad);
				AddFileName(pfad,"Editor.exe",sizeof(pfad));
				file=pfad;
				if(ExistFile(file)==1)break;

				file="D:\\MyProjects\\Editor\\Release\\Editor.exe";
				if(ExistFile(file)==1)break;

				GetWindowsDirectory(pfad,sizeof(pfad));
				AddFileName(pfad,"Notepad.exe",sizeof(pfad));
				file=pfad;
				if(ExistFile(file)==1)break;

				return;
				}

			prog_text.SetFilename(file);
			prog_text.Start(CSP_NOWAIT,"-F:0x%08X",AfxGetMainWnd()->m_hWnd);
			prog_text.WaitForInit();
			prog_on[0] = TRUE;
			SetTimer(ID_SCAN_PROG,2000,NULL);
			SetProgPos(&prog_text,prog_pos+0);
			}

		if(!APPWND_CMPDOCNAME(&prog_text,find_text.GetFileName(nr)))
			{
			APPWND_LOADFILE(&prog_text,find_text.GetFileName(nr));
			}

		CPoint	pt(0,find_text.GetLineNr(nr)-1);
		WND_SETCURSOR(&prog_text,pt);pt.y-=5;if(pt.y<0)pt.y=0;
		WND_SETSCROLL(&prog_text,pt);
					   prog_text.SetFocus();
		}

}



//*****************************************************************************
//*
//*		OnDestroy
//*
//*****************************************************************************
void CDataFinderView::OnDestroy()
{
CRegKeys	 key;



	key.Open();
	key.Set(file_wnd.GetPath(),"Path");


	CView::OnDestroy();
}

//*****************************************************************************
//*
//*		AddNetPath
//*
//*****************************************************************************
//	Fgt statisch einen Netzpfad ein
void CDataFinderView::AddNetPath(const char *Pfad)
{

	file_wnd.AddNetPath(Pfad);
}

//*****************************************************************************
//*
//*		SetPath
//*
//*****************************************************************************
void CDataFinderView::SetPath(const char *Pfad)
{

	file_wnd.SetPath(Pfad);

}


//*****************************************************************************
//*
//*		ListBoxProc
//*
//*****************************************************************************
LRESULT CALLBACK CDataFinderView::ListBoxProc(HWND hwnd,UINT uMsg,WPARAM wParam,LPARAM lParam)
{
WNDPROC	proc;

	proc = (WNDPROC)GetWndData(hwnd);

	if(uMsg==WM_KEYDOWN)
		{
		if(wParam==VK_RETURN)
			{
			::SendMessage(::GetParent(hwnd),WM_COMMAND,(LBN_DBLCLK<<16)|GetWndId(hwnd),(LPARAM)hwnd);
			}
		if(wParam==VK_DELETE)
			{
			::SendMessage(::GetParent(hwnd),WM_COMMAND,ID_DELETE,0);
			}
		}

return CallWindowProc(proc,hwnd,uMsg,wParam,lParam);
}


//*****************************************************************************
//*
//*		OnChange
//*
//*****************************************************************************
//	Alle gefunden Stellen ndern
void CDataFinderView::OnChange()
{
CChangePreviewDlg	cdlg;
CTextChangeDlg		dlg;
CMapFile			map;
CRegKeys			key;
CString				text;
FILE			   *file=0;
char				mem[260],pfad[MAX_PATH];
char				temp[MAX_PATH+4],*ptr=0;
int					len,add,off,nr,ok,flags=0,max=0,anz,pos=0;
int					wr=0,next,wr_old,mode,end,anzahl=0;
int					change;





	if(!key.Open( HKEY_CURRENT_USER,0,CRK_READ))return;
	if(!key.Up  ( "TextSeach"))return;
		key.Get ( flags, "Flags");



	if(list_mode==2)									// Im Cmp-Mode ?
		{
		MessageBox("ndern ist nur im Text oder Hex-Modus mglich !");
		return;
		}

	   dlg.find_mode=list_mode;
	if(dlg.DoModal()!=IDOK)return;

	SetCursor(IDC_WAIT);
	pfad[0] = 0;
	change  = 1;

	if(list_mode==1)									// Im Hex-Mode ?
		{
		len=StrToBin(dlg.text,mem,sizeof(mem));
		memset(mem+len,0,sizeof(mem)-len);
		if(dlg.mode==1 && dlg.len>0)
			{
			len=dlg.len;
			if(len>sizeof(mem))len=sizeof(len);
			}

		for(nr=0;nr<find_hex.Count();nr++)				// Alle Positionen durchlaufen
			{
			if(strcmp(pfad,find_hex.GetFileName(nr)))	// Eine Neue Datei ffnen
				{
				map.Close();
				strlcpy(pfad,find_hex.GetFileName(nr),sizeof(pfad));
				ptr=map.Open(pfad,CMF_WRITE);
				max=map.GetLength();

				if(!ptr)								// Fehler beim ffnen ?
					{
					text.Format("Fehler beim ffnen von:\n%s",pfad);
					ok=MessageBox(text,"Fehler",MB_OKCANCEL|MB_ICONERROR);
					if(ok!=IDOK){SetCursor(IDC_ARROW);return;}
					}

				}

			if(!ptr)continue;							// Ist Zeiger ok

			   pos=find_hex.GetPos(nr);
			if(pos<  0 )continue;
			if(pos>=max)continue;
			   anz=len;
			if(pos+anz>max)anz=max-pos;
			if(anz<=0)continue;

			memcpy(ptr+pos,mem,anz);
			anzahl++;
			}
		}
	else{												// Text-Mode
		if(dlg.sezial)
			{
			len=strtomem(mem,sizeof(mem)|STR_NOQUOTE,dlg.text);
			}
		else{
			len=strlcpy(mem,dlg.text,sizeof(mem));
			}

		switch(dlg.mode)
			{
		case 1:		if(dlg.len<0)dlg.len=0;  			// ndern bis
					break;
			}

		mode = (flags&FLAG_FIND_CASE)? 5:4;


		for(nr=0;nr<find_text.Count();nr++)				// Alle Positionen durchlaufen
			{
			if(strcmp(pfad,find_text.GetFileName(nr)))	// Eine Neue Datei ffnen
				{
				map.Close();
				strlcpy(pfad,find_text.GetFileName(nr),sizeof(pfad));
				ptr=map.Open(pfad,CMF_WRITE);
				max=map.GetLength();

				if(!ptr)								// Fehler beim ffnen ?
					{
					text.Format("Fehler beim ffnen von:\n%s",pfad);
					ok=MessageBox(text,"Fehler",MB_OKCANCEL|MB_ICONERROR);
					if(ok!=IDOK){SetCursor(IDC_ARROW);return;}
					break;
					}

				strcpy(temp,pfad);						// Temp-File erzeugen
				strcat(temp,".datafinder.tmp");
				file=fopen(temp,"wb");

				if(!file)								// Fehler beim ffnen ?
					{
					text.Format("Fehler beim Erstellen von:\n%s",temp);
					ok=MessageBox(text,"Fehler",MB_OKCANCEL|MB_ICONERROR);
					if(ok!=IDOK){SetCursor(IDC_ARROW);return;}
					break;
					}

				   pos=find_text.GetPos(nr);			// Anfang speichern
				if(pos>max)pos=max;
				fwrite(ptr,pos,1,file);
				wr=pos;
				}

			if(!ptr || !file)continue;					// Ist Zeiger ok

			anz=find_text.GetLength(nr);
			    find_text.SetPos(nr,wr);
			    wr_old=wr;

			if(pos+anz>max)anz=max-pos;
			if(anz<0)anz=0;


			if(dlg.single)								// Sollen Einzelabfragen gemacht werden ?
				{
				int			i;
				const char *pre;
				const char *post;
				int			prelen;
				int			postlen;


				for(i=0;i<pos && i<32;i++)				// Text vor nderung
					{
					if(ptr[pos-i-1]=='\n')break;
					if(ptr[pos-i-1]=='\r')break;
					}

				pre		= ptr+pos-i;
				prelen	= i;

				for(i=0;i<max-pos && i<32;i++)			// Text nach nderung
					{
					if(ptr[pos+anz+i+1]=='\n')break;
					if(ptr[pos+anz+i+1]=='\r')break;
					}

				post	= ptr+pos+anz;
				postlen	= i;


				switch(dlg.mode)
					{
				default:								// Eins zu eins tauschen
				case 0:	cdlg.SetNewText(pre,prelen,0,0,mem    ,len,0,0,post,postlen);
						cdlg.SetOldText(pre,prelen,0,0,ptr+pos,anz,0,0,post,postlen);
						break;

				case 1:	   add=anz-dlg.len;				// ndern bis
						if(add<0)add=0;
						off=pos+anz-add;

						cdlg.SetNewText(pre,prelen,0,0,mem    ,len    ,ptr+off,add,post,postlen);
						cdlg.SetOldText(pre,prelen,0,0,ptr+pos,anz-add,ptr+off,add,post,postlen);
						break;

				case 2:	   add=dlg.len;					// ndern ab
						if(add>anz)add=anz;

						cdlg.SetNewText(pre,prelen,ptr+pos,add,mem        ,len    ,0,0,post,postlen);
						cdlg.SetOldText(pre,prelen,ptr+pos,add,ptr+pos+add,anz-add,0,0,post,postlen);
						break;

				case 3:									// ndern bis spezial
						   off=memycmp(dlg.length,dlg.anz,ptr+pos,anz,mode);
						if(off>anz)off=anz;
						   add=anz-off;
						if(add<0)add=0;

						cdlg.SetNewText(pre,prelen,0,0,mem    ,len    ,ptr+pos+off,add,post,postlen);
						cdlg.SetOldText(pre,prelen,0,0,ptr+pos,anz-add,ptr+pos+off,add,post,postlen);
						break;

				case 4:									// ndern ab spezial
						   add=memycmp(dlg.length,dlg.anz,ptr+pos,anz,mode);
						if(add>anz)add=anz;

						cdlg.SetNewText(pre,prelen,ptr+pos,add,mem        ,len    ,0,0,post,postlen);
						cdlg.SetOldText(pre,prelen,ptr+pos,add,ptr+pos+add,anz-add,0,0,post,postlen);
						break;
					}


				switch(cdlg.DoModal())
					{
				default:
				case IDOK:		change=1;				break;
				case IDNO:		change=0;				break;
				case IDALL:		change=1;dlg.single=0;	break;
				case IDCANCEL:	change=0;dlg.single=0;	break;
					}
				}

			if(change)									// Datei ndern
				{
				switch(dlg.mode)
					{
				default:
				case 0:	fwrite(mem,len,1,file);			// Eins zu eins tauschen
						wr +=len;
						break;

				case 1:	   add=anz-dlg.len;				// ndern bis
						if(add<0)add=0;
						off=pos+anz-add;
						fwrite(mem    ,len,1,file);
						fwrite(ptr+off,add,1,file);
						wr +=len;
						wr +=add;
						break;

				case 2:	   add=dlg.len;					// ndern ab
						if(add>anz)add=anz;
						fwrite(ptr+pos,add,1,file);
						fwrite(mem    ,len,1,file);
						wr +=len;
						wr +=add;
						break;

				case 3:									// ndern bis spezial
						   off=memycmp(dlg.length,dlg.anz,ptr+pos,anz,mode);
						if(off>anz)off=anz;
						   add=anz-off;
						if(add<0)add=0;
						fwrite(mem        ,len,1,file);
						fwrite(ptr+pos+off,add,1,file);
						wr +=len;
						wr +=add;
						break;

				case 4:									// ndern ab spezial
						   add=memycmp(dlg.length,dlg.anz,ptr+pos,anz,mode);
						if(add>anz)add=anz;
						fwrite(ptr+pos,add,1,file);
						fwrite(mem    ,len,1,file);
						wr +=len;
						wr +=add;
						break;
					}


				   pos+=anz;
				if(pos>max)pos=max;

				find_text.SetLength(nr,wr-wr_old);
				}
			else{										// Keine nderung in Datei
				fwrite(ptr+pos,anz,1,file);
				   wr +=anz;
				   pos+=anz;
				if(pos>max)pos=max;
				}


			end=0;
			if(nr+1>=find_text.Count())end=1;
			if(!end && strcmp(pfad,find_text.GetFileName(nr+1)))end=1;


			if(!end)next=find_text.GetPos(nr+1);		// Nchste Position
			else	next=max;

			if(next<pos)next=pos;
			if(next>max)next=max;

			fwrite(ptr+pos,next-pos,1,file);
			wr+=next-pos;
			pos=next;

			if(end)										// Die Dateien tauschen
				{
				map.Close();
				fclose(file);
				RemoveFile(pfad);
				rename(temp,pfad);
				RemoveFile(temp);
				}

			anzahl+= change;
			}


		}

	SetCursor(IDC_ARROW);
	text.Format("Es wurden %i nderungen durch gefhrt.",anzahl);
	MessageBox(text,"ndern",MB_OK|MB_ICONINFORMATION);
}

//*****************************************************************************
//*
//*		OnChangeUpdate
//*
//*****************************************************************************
void CDataFinderView::OnChangeUpdate(CCmdUI *pCmdUI)
{
int 	enable;

	switch(list_mode)
		{
	case 0:	enable = find_text.Count();	break;
	case 1:	enable = find_hex .Count();	break;
	default:break;
		}


	pCmdUI->Enable(enable);

}


//*****************************************************************************
//*
//*		OnDelete
//*
//*****************************************************************************
void CDataFinderView::OnDelete()
{
int			 nr;
char		 str[32];
CMainFrame	*wnd;



	   nr=find_wnd.GetCurSel();
	if(nr>=list_count)return;
	if(nr<0)return;


	if(list_mode==1)					// Hex Daten
		{
		find_hex.Delete(nr);
		}

	else if(list_mode==0)
		{								// Text Daten
		find_text.Delete(nr);
		}


	find_wnd.DeleteString(nr);
	list_count--;

	   wnd =(CMainFrame*)AfxGetMainWnd();
	if(wnd && IsWindow(wnd->m_hWnd))
		{
		sprintf(str,"%i Eintrge",list_count);
		wnd->StatusbarSet( 0, str );
		}

										// Focus setzen
	if(nr<list_count)find_wnd.SetCurSel(nr);
	else{
		if(list_count>0)find_wnd.SetCurSel(list_count-1);
		}
}


//*****************************************************************************
//*
//*		OnCompareFiles
//*
//*****************************************************************************
void CDataFinderView::OnCompareFiles()
{
char	   *file,pfad[MAX_PATH];
CRegKeys	key;



	if(list_wnd.GetItemCount()<2)
		{
		MessageBox("Es mssen zwei Dateien in der Dateiliste sein.","DataFinder",MB_OK|MB_ICONERROR);
		return;
		}



	for(;;)
		{
		if(key.Open())
		if(key.Get (pfad,sizeof(pfad),"FileCompare"))
			{
			file=pfad;
			if(ExistFile(file)==1)break;
			}

		file="D:\\MyProjects\\TextCompare\\Release\\FileCompare.exe";
		if(ExistFile(file)==1)break;
		GetExePath(pfad);
		AddFileName(pfad,"FileCompare.exe",sizeof(pfad));
		file=pfad;
		if(ExistFile(file)==1)break;
		GetWindowsDirectory(pfad,sizeof(pfad));
		AddFileName(pfad,"FileCompare.exe",sizeof(pfad));
		file=pfad;
		if(ExistFile(file)==1)break;


		CCmpFileDlg	dlg;

		dlg.path1 = list_wnd.GetFileName(0,1);
		dlg.path2 = list_wnd.GetFileName(1,1);
		dlg.DoModal();


		return;
		}


	prog_cmp.SetFilename(file);
	prog_cmp.SetParam(list_wnd.GetFileName(0,1));
	prog_cmp.SetParam(list_wnd.GetFileName(1,1));
	prog_cmp.Start();
	prog_cmp.WaitForInit();






}

//*****************************************************************************
//*
//*		OnRenameFiles
//*
//*****************************************************************************
void CDataFinderView::OnRenameFiles()
{

	if(list_wnd.GetItemCount()<1)
		{
		MessageBox("Es mssen Dateien in der Dateiliste sein.","DataFinder",MB_OK|MB_ICONERROR);
		return;
		}

	CRenameDlg	dlg;

	dlg.m_pFileList=&list_wnd;
	dlg.DoModal();

	list_wnd.RedrawAllItems();
	file_wnd.Reload();
}



//*****************************************************************************
//*
//*		OnTabConvert
//*
//*****************************************************************************
//	Kovertiert den Text von der alten Tab-Breite 'Alt' zur neuen 'Neu'
//	Alt == 0	: Keine Tabs im Ursprungs Text
//	Neu == 0	: Keine Tabs im neuen Text
void CDataFinderView::OnTabConvert()
{
CString			text;
CProgressDlg	pdlg;
CTabConvertDlg	dlg;



	if(list_wnd.GetItemCount()<=0)
		{
		MessageBox("Es sind keine Dateien ausgewhlt !","DataFinder");
		return;
		}


	if(dlg.DoModal()!=IDOK)return;

	if(dlg.leer    )dlg.neu=0;
	if(dlg.alt   <0)dlg.alt=0;
	if(dlg.neu   <0)dlg.neu=0;
	if(dlg.space <0)dlg.neu|=0x8000;

	if(dlg.alt==dlg.neu && !dlg.space)
		{
		MessageBox("Es gab keine relevanten nderungen.","DataFinder");
		return;
		}

	pdlg.SetPriority(-2);
	pdlg.SetTitle("Tabulatoren konvertieren");
	pdlg.SetProc (TabConvertProc,this,(void*)dlg.alt,(void*)dlg.neu);
	pdlg.SetText ("Konvertiere :  ",list_wnd.GetFileName(0,1));
	pdlg.SetRange(1024);
	pdlg.DoModal ();

	text.Format("Es wurden %i von %i Dateien konvertiert.",pdlg.GetExitCode(),list_wnd.GetItemCount());
	MessageBox(text,"DataFinder");


}

//*****************************************************************************
//*
//*		TabConvertProc
//*
//*****************************************************************************
int  _cdecl CDataFinderView::TabConvertProc(CProgressDlg *Dlg)
{
__int64			 size,pos,range;
int				 w,x,z,anf,akt,tab_a,tab_n,len,nr,bytes,last,anz=0;
int				 alt,neu,space,error;
unsigned char   *text=0,*puffer;
CDataFinderView *view;
CFileBuffer		 fin,fout;
CString			 path,temp,name;



	view=(CDataFinderView*)Dlg->GetVoid1();


	alt  = Dlg->GetInt2()&0x00FF;
	neu  = Dlg->GetInt3()&0x00FF;
	space= Dlg->GetInt3()&0x8000;

	tab_a=(alt)? alt:1;
	tab_n=(neu)? neu:10000;


	puffer=new unsigned char[10000];
	text  =new unsigned char[10000];


	for(nr=0,size=0;nr<view->list_wnd.GetItemCount();nr++)
		{
		if(Dlg->IsStoped())break;
		size+=view->list_wnd.GetFileLength(nr);
		}

	if(size<=0)size=1;

	for(nr=0,pos=0;nr<view->list_wnd.GetItemCount();nr++)
		{
		if(Dlg->IsStoped())break;

		path =view->list_wnd.GetFileName(nr,1);
		temp =path;
		temp+=".datafinder.tmp";
		error=0;

		if(!fin .Open(path))continue;
		if(!fout.Open(temp,CFB_CREATE))continue;

		bytes=0;
		last =0;

		for(;;)
			{
			   x=fin.ReadLine(text,10000);
			if(x<0)break;

			if(Dlg->IsStoped()){error=1;break;}

			akt=anf=0;

			for(w=0,z=0,anf=0;z<x;)
				{
				if(w>9900)break;

				if(text[z]=='\t')					// TAB gefunden
					{
					z++;
					akt+=	 tab_a;
					akt-=akt%tab_a;
					continue;
					}
				if(space && text[z]==' ' )			// space gefunden
					{
					z++;
					akt++;
					continue;
					}
				if(akt!=anf)						// Einen Leerraum einfgen
					{
					if(neu && akt-anf>1)			// TAB's anhngen
						{
						len=(akt/tab_n)-(anf/tab_n);
						if(len>0)
							{
							memset(puffer+w,'\t',len);
							w+=len;
							anf=((anf/tab_n)+len)*tab_n;
							}
						}
					if(anf<akt)						// SPACE's anhngen
						{
						len=akt-anf;
						memset(puffer+w,' ',len);
						w+=len;
						}
					}


				puffer[w]=text[z];
				akt++;
				anf=akt;
				w++;z++;
				}

			puffer[w]=0;

			if(fout.Write(puffer,w)!=w || fout.Write("\r\n",2)!=2)
				{
				error=1;
				break;
				}

			bytes+=x+1;

			if(bytes>last+0x2000)					// Verlaufs anzeige
				{
				range=(((__int64)1024)*(pos+(__int64)bytes))/size;
				Dlg->SetPos((int)range);
				last=bytes;
				}
			}

		fin .Close();
		fout.Close();

		if(!error)									// Datei tauschen
			{
			name =path;
			name+=".__bak";
			RemoveFile(name);

			if(MoveFile(path,name))
				{
				if(MoveFile(temp,path))
					   {RemoveFile(name);anz++;}
				else	MoveFile(name,path);
				}
			}

		RemoveFile(temp);

		pos+=view->list_wnd.GetFileLength(nr);		// Verlaufs anzeige
		range=(((__int64)1024)*pos)/size;
		Dlg->SetPos((int)range);
		}


	delete text;
	delete puffer;

return anz;
}


//*****************************************************************************
//*
//*		OnFindSame
//*
//*****************************************************************************
void CDataFinderView::OnFindSame()
{
CFindSameDlg	dlg;
LPCTSTR			ptr;
int				len;
int				nr;


	for(nr=0;nr<list_wnd.GetItemCount();nr++)
		{
		len=list_wnd.GetFileLength(nr);
		ptr=list_wnd.GetFileName(nr,1);
		dlg.AddFile(ptr,len);
		}

	dlg.DoModal();

}



//*****************************************************************************
//*
//*		OnReload
//*
//*****************************************************************************
void CDataFinderView::OnReload()
{
	file_wnd.Reload();
}



//*****************************************************************************
//*
//*		OnAsciiAnsi
//*
//*****************************************************************************
//	Kovertiert den Text von der ASCII zu ANSI oder umgekert
void CDataFinderView::OnAsciiAnsi()
{
CString			text;
CProgressDlg	pdlg;
CAsciiAnsiDlg	dlg;



	if(list_wnd.GetItemCount()<=0)
		{
		MessageBox("Es sind keine Dateien ausgewhlt !","DataFinder");
		return;
		}


	if(dlg.DoModal()!=IDOK)return;

	pdlg.SetPriority(-2);
	pdlg.SetTitle("ASCII ANSI Konvertierung");
	pdlg.SetProc (AsciiAnsiProc,this,(void*)dlg.m_mode);
	pdlg.SetText ("Konvertiere :  ",list_wnd.GetFileName(0,1));
	pdlg.SetRange(1024);
	pdlg.DoModal();

	text.Format("Es wurden %i von %i Dateien konvertiert.",pdlg.GetExitCode(),list_wnd.GetItemCount());
	MessageBox(text,"DataFinder");


}

//*****************************************************************************
//*
//*		AsciiAnsiProc
//*
//*****************************************************************************
int  _cdecl CDataFinderView::AsciiAnsiProc(CProgressDlg *Dlg)
{
__int64			 size,pos,range;
int				 nr,len,anz=0;
int				 mode,error;
char		    *ptr;
CDataFinderView *view;
CMapFile		 map;
CString			 path;



	view=(CDataFinderView*)Dlg->GetVoid1();
	mode=Dlg->GetInt2();


	for(nr=0,size=0;nr<view->list_wnd.GetItemCount();nr++)
		{
		if(Dlg->IsStoped())break;
		size+=view->list_wnd.GetFileLength(nr);
		}

	if(size<=0)size=1;

	for(nr=0,pos=0;nr<view->list_wnd.GetItemCount();nr++)
		{
		if(Dlg->IsStoped())break;

		path=view->list_wnd.GetFileName(nr,1);
		error=0;

		   ptr=map.Open(path,CMF_WRITE);
		if(ptr)
			{
			len=map.GetLength();
			if(mode)CharToOemBuff(ptr,ptr,len);
			else    OemToCharBuff(ptr,ptr,len);
			anz++;
			}

		pos+=view->list_wnd.GetFileLength(nr);		// Verlaufs Anzeige
		range=(((__int64)1024)*pos)/size;
		Dlg->SetPos((int)range);
		}


return anz;
}


//*****************************************************************************
//*
//*		OnTxtEditor
//*
//*****************************************************************************
void CDataFinderView::OnTxtEditor()
{
char	   *file,pfad[MAX_PATH];
CRegKeys	key;


	if(!file_name[0])return;

	if(!prog_text.IsRunning())
		{
		for(;;)
			{
			if(key.Open())
			if(key.Get (pfad,sizeof(pfad),"Editor"))
				{
				file=pfad;
				if(ExistFile(file)==1)break;
				}

			GetExePath(pfad);
			AddFileName(pfad,"..\\Editor\\Editor.exe",sizeof(pfad));
			file=pfad;
			if(ExistFile(file)==1)break;

			GetExePath(pfad);
			AddFileName(pfad,"Editor.exe",sizeof(pfad));
			file=pfad;
			if(ExistFile(file)==1)break;

			file="D:\\MyProjects\\Editor\\Release\\Editor.exe";
			if(ExistFile(file)==1)break;

			GetWindowsDirectory(pfad,sizeof(pfad));
			AddFileName(pfad,"Notepad.exe",sizeof(pfad));
			file=pfad;
			if(ExistFile(file)==1)break;

			return;
			}

		prog_text.SetFilename(file);
		prog_text.Start(CSP_NOWAIT,"-F:0x%08X",AfxGetMainWnd()->m_hWnd);
		prog_text.WaitForInit();
		}

	if(!APPWND_CMPDOCNAME(&prog_text,file_name))
		{
		APPWND_LOADFILE(&prog_text,file_name);
		}

	prog_text.SetFocus();
	file_name[0]=0;


}

//*****************************************************************************
//*
//*		OnCopyPath
//*
//*****************************************************************************
//	Pfad aus der Dateiliste kopiern
void CDataFinderView::OnCopyPath()
{

	if(!file_name[0])return;

	SetClipboardText(file_name,FilePathLen(file_name));

	file_name[0]=0;

}


//*****************************************************************************
//*
//*		OnCopyName
//*
//*****************************************************************************
//	Dateiname aus der Dateiliste kopiern
void CDataFinderView::OnCopyName()
{

	if(!file_name[0])return;

	SetClipboardText(file_name);

	file_name[0]=0;

}

//*****************************************************************************
//*
//*		OnCopyFull
//*
//*****************************************************************************
//	Dateipfad aus der Dateiliste oder Verzeichniss kopiern
void CDataFinderView::OnCopyFull()
{

	if(!file_full[0])return;

	SetClipboardText(file_full);

	file_full[0]=0;

}


//*****************************************************************************
//*
//*		OnCopyLast
//*
//*****************************************************************************
//	Dateinamen aus einem Pfad kopiern
void CDataFinderView::OnCopyLast()
{

	if(!file_name[0])return;

	SetClipboardText(GetFileName(file_name));

	file_name[0]=0;

}


//*****************************************************************************
//*
//*		OnCopyList
//*
//*****************************************************************************
//	Die Dateiliste aus dem Dateilistenfenster kopieren
void CDataFinderView::OnCopyList()
{
POSITION	filepos;
CString		files;
LPTSTR		buffer;
LPCTSTR		name;
int			count;
int			size;
int			item;
int			now;
int			len;


	count = list_wnd.GetSelectedCount();
	now	  = 0;

	if(count>1)										// Nur ausgewhlte Dateien
		{
		count   = list_wnd.Count();
		size    = count*64+4096;
		buffer  = files.GetBuffer(size);
		filepos = list_wnd.GetFirstSelectedItemPosition();

		while(filepos)
			{
			item = list_wnd.GetNextSelectedItem(filepos);
			name = list_wnd.GetFileName(item,1,&len);

			if(!name)continue;

			if(now+len+16>size)
				{
				files.ReleaseBuffer(now);
				size   = now+now/2+1024;
				buffer = files.GetBuffer(size);
				}

			memcpy(buffer+now,name,len);
			now        += len;
			buffer[now] = '\n';
			now        += 1;
			}
		}
	else{											// Alle Dateien
		count   = list_wnd.Count();
		size    = count*64+4096;
		buffer  = files.GetBuffer(size);

		for(item=0;item<count;item++)
			{
			name = list_wnd.GetFileName(item,1,&len);

			if(!name)continue;

			if(now+len+16>size)
				{
				files.ReleaseBuffer(now);
				size   = now+now/2+1024;
				buffer = files.GetBuffer(size);
				}

			memcpy(buffer+now,name,len);
			now        += len;
			buffer[now] = '\n';
			now        += 1;
			}
		}

	files.ReleaseBuffer(now);
	SetClipboardText(files);

}


//*****************************************************************************
//*
//*		OnHexEditor
//*
//*****************************************************************************
void CDataFinderView::OnHexEditor()
{
char	   *file,pfad[MAX_PATH];
CRegKeys	key;


	if(!file_name[0])return;

	if(!prog_hex.IsRunning())
		{
		for(;;)
			{
			if(key.Open())
			if(key.Get (pfad,sizeof(pfad),"HexEditor"))
				{
				file=pfad;
				if(ExistFile(file)==1)break;
				}

			file="C:\\Windows\\HexEditor.exe";
			if(ExistFile(file)==1)break;

			GetExePath(pfad);
			AddFileName(pfad,"HexEditor.exe",sizeof(pfad));
			file=pfad;
			if(ExistFile(file)==1)break;

			GetWindowsDirectory(pfad,sizeof(pfad));
			AddFileName(pfad,"HexEditor.exe",sizeof(pfad));
			file=pfad;
			if(ExistFile(file)==1)break;

			file="D:\\MyProjects\\HexEditor\\HexEditor.exe";
			if(ExistFile(file)==1)break;

			return;
			}

		prog_hex.SetFilename(file);
		prog_hex.Start();
		prog_hex.WaitForInit();
		prog_on[1] = TRUE;
		SetTimer(ID_SCAN_PROG,2000,NULL);
		SetProgPos(&prog_hex,prog_pos+1);
		}

	if(!APPWND_CMPDOCNAME(&prog_hex,file_name))
		{
		APPWND_LOADFILE(&prog_hex,file_name);
		}

	prog_hex.SetFocus();
	file_name[0]=0;

}

//*****************************************************************************
//*
//*		OnShellOpen
//*
//*****************************************************************************
void CDataFinderView::OnShellOpen()
{
DWORD	dwRet;

	if(!file_name[0])return;

	dwRet=(DWORD)ShellExecute(0,"open",file_name,0,0,SW_SHOWNORMAL);
	if(dwRet<32) ShellExecute(0,"edit",file_name,0,0,SW_SHOWNORMAL);


	file_name[0]=0;

}

//*****************************************************************************
//*
//*		StartMenu
//*
//*****************************************************************************
void CDataFinderView::StartMenu(const char *Filename,LPPOINT Point)
{
CPoint		 point;
CMenu		 menu;


	if(!Filename || !*Filename){file_name[0]=0;return;}
	if( ExistFile(Filename)!=1){file_name[0]=0;return;}

	strlcpy(file_name,Filename,sizeof(file_name));

	menu.CreatePopupMenu();
	menu.AppendMenu(MF_STRING,ID_SHELLOPEN, "&ffnen");
	menu.AppendMenu(MF_STRING,ID_TXT_EDITOR,"&Editor");
	menu.AppendMenu(MF_STRING,ID_HEX_EDITOR,"&HexEditor");
	menu.AppendMenu(MF_SEPARATOR);
	menu.AppendMenu(MF_STRING,ID_COPY_PATH ,"&Pfad kopieren");
	menu.AppendMenu(MF_STRING,ID_COPY_NAME ,"&Name kopieren");
	menu.AppendMenu(MF_STRING,ID_COPY_LIST ,"&Dateiliste kopieren");

	AddMenuBitmap(menu,ID_SHELLOPEN  ,IDB_TOOLICONS,10);
	AddMenuBitmap(menu,ID_TXT_EDITOR ,IDB_TOOLICONS, 4);
	AddMenuBitmap(menu,ID_HEX_EDITOR ,IDB_TOOLICONS, 5);
	AddMenuBitmap(menu,ID_COPY_PATH  ,IDB_TOOLICONS, 1);
	AddMenuBitmap(menu,ID_COPY_NAME  ,IDB_TOOLICONS, 9);
	AddMenuBitmap(menu,ID_COPY_LIST  ,IDB_TOOLICONS, 1);

	if(!Point)
		{
		Point=&point;
		GetCursorPos(Point);
		}

	menu.TrackPopupMenu(TPM_LEFTALIGN,Point->x,Point->y,this);
	menu.DestroyMenu();

}




//*****************************************************************************
//*
//*		OnLfCrConvert
//*
//*****************************************************************************
void CDataFinderView::OnLfCrConvert()
{
CString			text;
CProgressDlg	pdlg;
CLfCrConvertDlg	dlg;



	if(list_wnd.GetItemCount()<=0)
		{
		MessageBox("Es sind keine Dateien ausgewhlt !","DataFinder");
		return;
		}


	if(dlg.DoModal()!=IDOK)return;

	pdlg.SetPriority(-2);
	pdlg.SetTitle("LF-CR Konvertierung");
	pdlg.SetProc (LfCrConvertProc,this,(void*)dlg.m_iMode);
	pdlg.SetText ("Konvertiere :  ",list_wnd.GetFileName(0,1));
	pdlg.SetRange(1024);
	pdlg.DoModal ();

	text.Format("Es wurden %i von %i Dateien konvertiert.",pdlg.GetExitCode(),list_wnd.GetItemCount());
	MessageBox(text,"DataFinder");


}

//*****************************************************************************
//*
//*		LfCrConvertProc
//*
//*****************************************************************************
int  _cdecl CDataFinderView::LfCrConvertProc(CProgressDlg *Dlg)
{
__int64			 size,pos,range;
int				 x,nr,last=0,len,anz=0;
int				 mode,error,wo,changes;
int				 mem_max;
char		    *ptr,*mem;
CDataFinderView *view;
FILE			*file;
CMapFile		 map;
CString			 path;



	view=(CDataFinderView*)Dlg->GetVoid1();
	mode=Dlg->GetInt2();

	mem_max=0x40000;
	mem=new char[mem_max];

	for(nr=0,size=0;nr<view->list_wnd.GetItemCount();nr++)
		{
		if(Dlg->IsStoped())break;
		size+=view->list_wnd.GetFileLength(nr);
		}

	if(size<=0)size=1;

	for(nr=0,pos=0;nr<view->list_wnd.GetItemCount();nr++)
		{
		if(Dlg->IsStoped())break;

		path=view->list_wnd.GetFileName(nr,1);
		error=0;

		   ptr=map.Open(path,CMF_READ);
		if(ptr)
			{
			len=map.GetLength();
			if(len>0x400000)continue;
			if(len*2>mem_max)
				{
				delete mem;
				mem_max=len*2;
				mem=new char[mem_max];
				}

			changes=0;

			if(mode==1)							// CR entfernen
				{
				for(x=0,wo=0,last=0;x<len;x++)
					{
					if(ptr[x]!=0x0D)continue;

					memcpy(mem+wo,ptr+last,x-last);
					wo+=x-last;
					changes++;
					x++;
					last=x;

					if(x>=len || ptr[x]!=0x0A)
						{

						mem[wo]=0x0A;
						wo++;
						continue;
						}
					}
				if(last>len)last=len;
				memcpy(mem+wo,ptr+last,x-last);
				wo+=x-last;
				}
			else{								// CR einfgen
				for(x=0,wo=0,last=0;x<len;x++)
					{
					if(ptr[x]==0x0D)
						{
						if(x+1<len && ptr[x+1]==0x0A)
							{
							x++;
							continue;
							}
						}
					else{
						if(ptr[x]!=0x0A)continue;
						}

					memcpy(mem+wo,ptr+last,x-last);
					wo+=x-last;
					changes++;
					last=x+1;


					mem[wo]=0x0D;wo++;
					mem[wo]=0x0A;wo++;
					}

				if(last>len)last=len;
				memcpy(mem+wo,ptr+last,x-last);
				wo+=x-last;
				}

			if(changes)
				{
				map.Close();
				file=fopen(path,"wb");
				if(file)
					{
					fwrite(mem,1,wo,file);
					fclose(file);
					anz++;
					}
				}
			}

		pos+=view->list_wnd.GetFileLength(nr);		// Verlaufs Anzeige
		range=(((__int64)1024)*pos)/size;
		Dlg->SetPos((int)range);
		}


	delete mem;

return anz;
}

//*****************************************************************************
//*
//*		OnCompareText
//*
//*****************************************************************************
//	Vergleicht den Text der ersten zwei Dateien
void CDataFinderView::OnCompareText()
{
char	   *file,pfad[MAX_PATH];
CStartProg	prog_cmp;
CRegKeys	key;


	if(list_wnd.GetItemCount()<2)
		{
		MessageBox("Es mssen mindestens zwei Dateien in der Dateiliste sein !","Fehler",MB_OK|MB_ICONERROR);
		return;
		}


	for(;;)
		{
		if(key.Open())
		if(key.Get (pfad,sizeof(pfad),"TextCompare"))
			{
			file=pfad;
			if(ExistFile(file)==1)break;
			}
		file="D:\\MyProjects\\TextCompare\\Release\\TextCompare.exe";
		if(ExistFile(file)==1)break;
		GetExePath(pfad);
		AddFileName(pfad,"TextCompare.exe",sizeof(pfad));
		file=pfad;
		if(ExistFile(file)==1)break;
		GetWindowsDirectory(pfad,sizeof(pfad));
		AddFileName(pfad,"TextCompare.exe",sizeof(pfad));
		file=pfad;
		if(ExistFile(file)==1)break;
		return;
		}


	prog_cmp.SetFilename(file);
	prog_cmp.SetParam(list_wnd.GetFileName(0,1));
	prog_cmp.SetParam(list_wnd.GetFileName(1,1));
	prog_cmp.Start();
	prog_cmp.WaitForInit();
	prog_on[2] = TRUE;
	SetTimer(ID_SCAN_PROG,2000,NULL);
	SetProgPos(&prog_cmp,prog_pos+2);

}


//*****************************************************************************
//*
//*		OnCompareDirectory
//*
//*****************************************************************************
//	Vergleich alle Dateien der Liste mit einem Verzeichnis
void CDataFinderView::OnCompareDirectory()
{
CStringChain	files(sizeof(int));
CMainFrame     *wnd;
CCmpPathDlg		dlg;
CProgressDlg	pdlg;
CString			text;
const char     *path;
char			buffer[MAX_PATH+128],temp;
int				i,max,size,flags;
int				j,len,num,anz;
__int64			all;


	max = list_wnd.GetItemCount();
	buffer[0] = 0;

	if(max>=0)											// Lngesten gemeinsamen Pfad suchen
		{
		path = list_wnd.GetPathName(0);
		len  = strlcpy(buffer,path,sizeof(buffer));

		for(i=1;i<max;i++)
			{
			if(len<=0)break;

			path = list_wnd.GetPathName(i);

			if(!strnicmp(buffer,path,len) && path[len-1]=='\\')
				{
				continue;
				}

			for(len--;len>0;len--)
				{
				if(buffer[len-1]!='\\')continue;
				i--;
				break;
				}
			}

		buffer[len] = 0;
		}



	dlg.sPath =(find_path=="")? buffer:find_path;
	dlg.sPcmp =(find_last=="")? file_wnd.GetPath():find_last;

	AddBackSlash(dlg.sPath);
	AddBackSlash(dlg.sPcmp);

	if(!CmpFileName(dlg.sPcmp,dlg.sPath))
		{
		dlg.sPcmp.Empty();
		}


	if(buffer[0] && CmpFileName(buffer,dlg.sPath))
		{
		text.Format("Die Dateien aus der Dateiliste haben als Basis den Pfad :    \n\n\t%s    \n\nsoll dieser statt :\n\n\t%s    \n\nals Basispfad benutzt werden ?",buffer,(LPCSTR)dlg.sPath);
		i = MessageBox(text,"Frage",MB_YESNOCANCEL|MB_ICONQUESTION);
		if(i==IDCANCEL)return;
		if(i==IDYES)dlg.sPath=buffer;
		}


	if(dlg.DoModal()!=IDOK)return;

	DelBackSlash(dlg.sPcmp);
	DelBackSlash(dlg.sPath);

	if(!CmpFileName(dlg.sPcmp,dlg.sPath))
		{
		MessageBox("Quellpfad und Vergleichspfad sind gleich !","Fehler");
		return;
		}

	if(!dlg.bChangeFile)
	if(!dlg.bChangeAttrib)
	if(!dlg.bChangeDelete)
	if(!dlg.bChangeInsert)
		{
		MessageBox("Es ist keine Vergleichsoption ausgewhlt !","Fehler");
		return;
		}

	if(ExistFile(dlg.sPath)<2)
		{
		text.Format("Das Verzeichnis %s existiert nicht !",(LPCSTR)dlg.sPath);
		MessageBox(text,"Fehler");
		return;
		}

	if(ExistFile(dlg.sPcmp)<2)
		{
		text.Format("Das Verzeichnis %s existiert nicht !",(LPCSTR)dlg.sPcmp);
		MessageBox(text,"Fehler");
		return;
		}

	find_last = dlg.sPcmp;
	SetCursor(IDC_WAIT);

	AddBackSlash(dlg.sPath);
	AddBackSlash(dlg.sPcmp);

	sort_mode = -1;
	sort_dir  =  0;
	cmp_return.Del();
	max=list_wnd.GetItemCount();
	len=dlg.sPath.GetLength();
	all=0;

	files.Add(dlg.sPath);
	files.Add(dlg.sPcmp);
	files.Add(dlg.sPlus);
	files.Add(dlg.sMinus);

	cmp_path1=dlg.sPath;
	cmp_path2=dlg.sPcmp;

	AddBackSlash(cmp_path1);
	AddBackSlash(cmp_path2);

	for(i=0;i<max;i++)								// Hole Dateinamen
		{
		   num=strlcpy(buffer,list_wnd.GetFileName(i,1),sizeof(buffer));
		if(num<=len || num<=0)continue;
		if(buffer[len-1]!='\\' && buffer[len-1]!='/')continue;


		temp=buffer[len];
		buffer[len]=0;
		if(CmpFileNameN(buffer,dlg.sPath))continue;

		buffer[len]=temp;
		size=list_wnd.GetFileLength(i);

		for(j=0;buffer[j];j++)if(buffer[j]=='/')buffer[j]='\\';
		files.Add(buffer,-1,&size);
		all+=size;
		}

	SetCursor(IDC_ARROW);

	if(files.Count()<max)							// Passten alle Pfade
		{
		text.Format("Es werden %i Datei nicht verglichen weil sie im falschen Verzeichnis liegen !",max-files.Count());
		if(MessageBox(text,"Warnung",MB_OKCANCEL|MB_ICONWARNING)!=IDOK)return;
		}

	find_wnd .ResetContent();
	find_hex. Delete();
	find_text.Delete();


						    flags =0x00;
	if(dlg.bChangeFile     )flags|=0x01;
	if(dlg.bChangeAttrib   )flags|=0x02;
	if(dlg.bChangeDelete   )flags|=0x04;
	if(dlg.bChangeInsert   )flags|=0x08;
	if(dlg.bIgnoreLinefeeds)flags|=0x10;

	pdlg.SetPriority(-2);
	pdlg.SetRange(all);
	pdlg.SetTitle("Dateien vergleichen");
	pdlg.SetProc (CmpFilesProc,this,&files,max,flags);
	pdlg.DoModal ();


	anz  = cmp_return.Count();
	cmp_mode = 0;

	if(pdlg.GetExitCode()==2 && anz==0)
		{
		MessageBox("Es wurde keine Datei im Vergleichsverzeichniss gefunden !","Warnung");
		cmp_mode = 1;
		}
	else if(anz>=MAX_DIFF)
		{
		MessageBox("Es wurden zuviele Unterschiede gefunden.");
		}


	   wnd =(CMainFrame*)AfxGetMainWnd();
	if(wnd && IsWindow(wnd->m_hWnd))
		{
		sprintf(buffer,"%i Eintrge",anz);
		wnd->StatusbarSet( 0, buffer );
		}

	SetCmpResult();
	SetFindWnd(1);
}

//*****************************************************************************
//*
//*		SetCmpResult
//*
//*****************************************************************************
void CDataFinderView::SetCmpResult()
{
unsigned char	color [MAX_PATH+128];
char			buffer[MAX_PATH+128];
int				j,len,anz;
int				i,p1,p2;


	anz =cmp_return.Count();

	for(i=0;i<anz;i++)
		{
		len=strlcpy(buffer,cmp_return.Get(i),sizeof(buffer));
		for(j=0;buffer[j];j++)if(buffer[j]=='\t')buffer[j]=' ';
		len=j;

		for(j=2;j<len;j++)if(buffer[j]==':')break;	p2=j+1;
		for(j--;j>0  ;j--)if(buffer[j]!=' ')break;	p1=j+1;

		memset(color   ,4,p1    );
		memset(color+p1,6,p2-p1 );
		memset(color+p2,0,len-p2);
		color[p2-1]=6;

		for(j=0;j<p1;j++)
			{
			if(buffer[j]!='\\')continue;
			color[j]=0;
			}

		find_wnd.AddString(buffer,color);
		}

	list_mode	=2;					// 0=Text 1=Hex 2=Cmp
	list_count	=anz;				// Anzahl der gefunden Eintrge

	if(anz==0)
		{
		if(cmp_mode==1)
				find_wnd.AddString("Es wurden keine Dateien gefunden.");
		else	find_wnd.AddString("Keine Unterschiede gefunden.");
		}

}


//*****************************************************************************
//*
//*		OnCopyFiles
//*
//*****************************************************************************
//	Kopiert Dateien rekursiv in ein anderes Verzeichniss
void CDataFinderView::OnCopyFiles()
{
CStringChain	files(sizeof(int));
CCopyFilesDlg	dlg;
CProgressDlg	pdlg;
CString			text;
const char     *path;
char			buffer[MAX_PATH+128],temp;
int				i,max,size,flags;
int				j,len,num,anz;
__int64			all;


	max = list_wnd.GetItemCount();
	buffer[0] = 0;

	if(max>=0)											// Lngesten gemeinsamen Pfad suchen
		{
		path = list_wnd.GetPathName(0);
		len  = strlcpy(buffer,path,sizeof(buffer));

		for(i=1;i<max;i++)
			{
			if(len<=0)break;

			path = list_wnd.GetPathName(i);

			if(!strnicmp(buffer,path,len) && path[len-1]=='\\')
				{
				continue;
				}

			for(len--;len>0;len--)
				{
				if(buffer[len-1]!='\\')continue;
				i--;
				break;
				}
			}

		buffer[len] = 0;
		}


	dlg.sSource =(find_path=="")? buffer:find_path;
	dlg.sTarget =(find_last=="")? file_wnd.GetPath():find_last;

	AddBackSlash(dlg.sSource);
	AddBackSlash(dlg.sTarget);

	if(!CmpFileName(dlg.sTarget,dlg.sSource))
		{
		dlg.sTarget.Empty();
		}


	if(buffer[0] && CmpFileName(buffer,dlg.sSource))
		{
		text.Format("Die Dateien aus der Dateiliste haben als Basis den Pfad :    \n\n\t%s    \n\nsoll dieser statt :\n\n\t%s    \n\nals Basispfad benutzt werden ?",buffer,(LPCSTR)dlg.sSource);
		i = MessageBox(text,"Frage",MB_YESNOCANCEL|MB_ICONQUESTION);
		if(i==IDCANCEL)return;
		if(i==IDYES)dlg.sSource=buffer;
		}


	if(dlg.DoModal()!=IDOK)return;

	DelBackSlash(dlg.sTarget);
	DelBackSlash(dlg.sSource);

	if(!CmpFileName(dlg.sTarget,dlg.sSource))
		{
		MessageBox("Quellpfad und Vergleichspfad sind gleich !","Fehler");
		return;
		}

	if(ExistFile(dlg.sSource)<2)
		{
		text.Format("Das Verzeichnis %s existiert nicht !",(LPCSTR)dlg.sSource);
		MessageBox(text,"Fehler");
		return;
		}

	if(ExistFile(dlg.sTarget)<2)
		{
		text.Format("Das Verzeichnis %s existiert nicht !",(LPCSTR)dlg.sTarget);
		MessageBox(text,"Fehler");
		return;
		}

	find_last = dlg.sTarget;
	SetCursor(IDC_WAIT);

	AddBackSlash(dlg.sSource);
	AddBackSlash(dlg.sTarget);

	sort_mode = -1;
	sort_dir  =  0;
	cmp_return.Del();
	max=list_wnd.GetItemCount();
	len=dlg.sSource.GetLength();
	all=0;

	files.Add(dlg.sSource);
	files.Add(dlg.sTarget);

	cmp_path1=dlg.sSource;
	cmp_path2=dlg.sTarget;

	AddBackSlash(cmp_path1);
	AddBackSlash(cmp_path2);

	for(i=0;i<max;i++)								// Hole Dateinamen
		{
		   num=strlcpy(buffer,list_wnd.GetFileName(i,1),sizeof(buffer));
		if(num<=len || num<=0)continue;
		if(buffer[len-1]!='\\' && buffer[len-1]!='/')continue;


		temp=buffer[len];
		buffer[len]=0;
		if(CmpFileNameN(buffer,dlg.sSource))continue;

		buffer[len]=temp;
		size=list_wnd.GetFileLength(i);

		for(j=0;buffer[j];j++)if(buffer[j]=='/')buffer[j]='\\';
		files.Add(buffer,-1,&size);
		all+=size;
		}

	SetCursor(IDC_ARROW);

	if(files.Count()<max)							// Passten alle Pfade
		{
		text.Format("Es werden %i Datei nicht verglichen weil sie im falschen Verzeichnis liegen !",max-files.Count());
		if(MessageBox(text,"Warnung",MB_OKCANCEL|MB_ICONWARNING)!=IDOK)return;
		}


						 flags =0;
	if(dlg.bNoOverWrite )flags|=1;
	if(dlg.bRemoveWr    )flags|=2;
	if(dlg.bAskReadOnly )flags|=4;
	if(dlg.bAskAlways  )flags|=8;

	pdlg.SetPriority(-2);
	pdlg.SetRange(all);
	pdlg.SetTitle("Dateien kopieren");
	pdlg.SetProc (CopyFilesProc,this,&files,max,flags);
	pdlg.DoModal ();


	anz = pdlg.GetExitCode();
	sprintf(buffer,"Es wurden %i Dateien kopiert.",anz);
	MessageBox(buffer);


}

//*****************************************************************************
//*
//*		OnZipFiles
//*
//*****************************************************************************
//	Zippt alle Dateien aus dem Auswahlfenster
void CDataFinderView::OnZipFiles()
{
CZipDlg		dlg;


	if(list_wnd.GetItemCount()<1)
		{
		MessageBox("Es mssen Dateien in der Dateiliste sein.","DataFinder",MB_OK|MB_ICONERROR);
		return;
		}

	dlg.m_sBaseChanged	= file_wnd.GetPath();
	dlg.m_pFileList		= &list_wnd;
	dlg.DoModal();

}

//*****************************************************************************
//*
//*		CppBeatifyProc
//*
//*****************************************************************************
int _cdecl CDataFinderView::CppBeatifyProc(CProgressDlg *Dlg)
{
CStartProg		 start;
CDataFinderView	*view  =(CDataFinderView*)Dlg->GetVoid1();
CStringChain	*files =(CStringChain   *)Dlg->GetVoid2();
const char	    *path  =				  Dlg->GetChar3();
const char	    *name  =				  Dlg->GetChar4();
const char	    *text;
CString			 msg;
int				 pos;
int				 off;
int				 ret;



	off	= 0;

	for(pos=0;pos<files->Count();pos++)
		{
		if(Dlg->IsStoped())break;

		text=view->list_wnd.GetFileName(pos,1);
		Dlg->SetText("Bearbeite :  ",text);

		start.Reset();
		start.SetParam("-h");
		start.SetParam("-m");
		start.SetParam(name);
		start.SetParam(files->Get(pos));
		start.Start(path,CSP_WAIT);

		switch(start.GetExitCode())
			{
		case -1:	msg.Format("Die Datei '%s' konnte nicht geffnet werden !",GetFileName(files->Get(pos)));
					ret=Dlg->MessageBox(msg,"Fehler",MB_ABORTRETRYIGNORE);
					break;
		case -2:	msg.Format("Die Datei '%s' konnte nicht gespeichert werden !",GetFileName(files->Get(pos)));
					ret=Dlg->MessageBox(msg,"Fehler",MB_ABORTRETRYIGNORE);
					break;
		default:	ret=MB_OK;
			}

		if(ret==IDABORT )break;
		if(ret==IDIGNORE)
			{
			pos--;
			continue;
			}

		off+=files->DataGet(pos);
		Dlg->SetPos(off);
		}


return 0;
}



//*****************************************************************************
//*
//*		OnCppBeatify
//*
//*****************************************************************************
//	Alle C-Dateien formatieren
void CDataFinderView::OnCppBeatify()
{
const char	   *name;
const char	   *path;
char			pfad[MAX_PATH];
CStringChain	files;
CProgressDlg	pdlg;
CComboDlg		cdlg;
CString			mode;
CRegKeys		key;
int				bytes;
int				size;
int				anz;
int				i;



	key.Open("Software\\AZ\\CppBeautifier\\Modes");
	cdlg.AddString("<Standard>");

	for(i=0;i<64;i++)										// Laden der Module
		{
			name=key.ValueName(i);
		if(!name)break;

		cdlg.AddString(name);
		}


	key.Open();
	key.Up("CppBeatifyDlg");
	key.Get(mode,"LastMode");


	   cdlg.SetTitle("Modus auswhlen");
	   cdlg.SetTextTitle("Modi:");
	   cdlg.SetSelect(mode);
	if(cdlg.DoModal()!=IDOK)return;							// Modus whlen

	mode=cdlg.GetText();
	key.Set(mode,"LastMode");


	files.DataLength(sizeof(int));
	anz=list_wnd.GetItemCount();

	for(i=0,bytes=0;i<anz;i++)								// Dateien einfgen
		{
		name  =	list_wnd.GetFileName(i,1);
		size  =	list_wnd.GetFileLength(i);

		if(!CmpFileType(name,"c;cc;cpp;h;hh;hpp"))continue;

		files.Add(name,CSC_END,&size);
		bytes += size;
		}

	if(files.Count()<=0)
		{
		MessageBox("Es sind keine C-Dateien in der Auswahl !","Fehler",MB_OK|MB_ICONERROR);
		return;
		}


	do	{													// Suche CppBeautifier.exe
		if(key.Open())
		if(key.Get (pfad,sizeof(pfad),"CppBeautifier"))
			{
			path=pfad;
			if(ExistFile(path)==1)break;
			}

		GetExePath(pfad);
		AddFileName(pfad,"..\\Tools\\CppBeautifier.exe",sizeof(pfad));
		path=pfad;
		if(ExistFile(path)==1)break;

		GetExePath(pfad);
		AddFileName(pfad,"CppBeautifier.exe",sizeof(pfad));
		path=pfad;
		if(ExistFile(path)==1)break;

		path="D:\\MyProjects\\Tools\\CppBeautifier\\Release\\CppBeautifier.exe";
		if(ExistFile(path)==1)break;

		MessageBox("Das Programm CppBeautifier.exe konnte nicht gefunden werdm !","Fehler",MB_OK|MB_ICONERROR);
		return;
		}while(0);



	pdlg.SetRange(bytes);
	pdlg.SetTitle("C-Dateien formatieren");
	pdlg.SetProc (CppBeatifyProc,this,&files,path,mode);
	pdlg.DoModal ();



}


//*****************************************************************************
//*
//*		OnExecMenus
//*
//*****************************************************************************
//	Bearbeiten der Mens fr die Ausfgrungskommandos
void CDataFinderView::OnExecMenus()
{
CExecConfigDlg	dlg;


	dlg.DoModal();
	ExecCount();

}


//*****************************************************************************
//*
//*		OnExecFiles
//*
//*****************************************************************************
//	Fhrt die Ausfgrungsmens auf alle Dateien aus
void CDataFinderView::OnExecFiles()
{
CComboDlg		dlg(this);
CStartProg	    start;
CProgressDlg	pdlg;
CRegKeys		key;
CString			text;
CString			last;
char			name[64];
int				from=1;
int				num;
int				i,j;



	key.Open(0,CRK_WRITE);
	key.Get(last,"LastExec");
	key.Get(from,"LastExecWnd");


	dlg.SetTitle("Fenster whlen");
	dlg.SetTextTitle("Aus welchem Fenster sollen die Dateien genommen werden ?");
	dlg.AddString("Aus Dateiliste");
	dlg.AddString("Aus Ergebnisliste");
	dlg.SetSelect((from)? 1:0);

	if(dlg.DoModal()!=IDOK)return;

	from=dlg.GetSelect();

	key.Set(from,"LastExecWnd");


	if(from==0)											// Welches Fenster benutzen
		{
		from = -1;
		num  = list_wnd.GetItemCount();
		}
	else{
		from = list_mode;

		switch(from)
			{
		case 2:	num = find_wnd .GetCount();	break;		// Daten
		case 1:	num = find_hex .Count();	break;		// Hex Daten
		case 0:	num = find_text.Count();	break;		// Text Daten
			}
		}


	if(num<=0)
		{
		MessageBox("Es sind keine Eintge im Fenster vorhanden !","Fehler",MB_OK|MB_ICONERROR);
		return;
		}


	dlg.ResetContent();


	if(key.Up(MENU_REG_PATH))
		{
		for(i=1;i<32;i++)								// Suche Meneintrge
			{
			sprintf(name,"Menu%i",i);
			if(!key.Up(name))break;
			if(!key.Get(text,"Name"))break;
			if(!key.Down())break;

			text.Remove('&');
			j=dlg.AddString(text);
			  dlg.SetData(j,i);
			}
		}

	if(dlg.GetCount()<=0)
		{
		MessageBox("Es sind keine Ausfhrungsmens definiert !","Information",MB_OK|MB_ICONINFORMATION);
		return;
		}


	text.Format("Ausfhrungsmen %s",dlg.GetText());

	dlg.SetMode(FALSE);
	dlg.SetTitle(text);
	dlg.SetTextTitle("Bitte das Ausfhrungsmen auswhlen.");
	dlg.SetSelect(last);

	if(dlg.DoModal()!=IDOK)return;

	key.Set(dlg.GetText(),"LastExec");
	sprintf(name,"Menu%i",dlg.GetData());


	pdlg.SetRange(num);
	pdlg.SetPriority(-2);
	pdlg.SetTitle("Ausfhrungsmen");
	pdlg.SetBreak(ExecBreak);
	pdlg.SetProc (ExecFiles,this,&start,name,from,num);
	pdlg.DoModal ();

}

//*****************************************************************************
//*
//*		OnExecFilesUpdate
//*
//*****************************************************************************
void CDataFinderView::OnExecFilesUpdate(CCmdUI *pCmdUI)
{
int		count;


	switch(list_mode)
		{
	case 0:	count = find_text .Count();	break;
	case 1:	count = find_hex  .Count();	break;
	case 2:	count = cmp_return.Count();	break;
	default:count = 0;					break;
		}

	pCmdUI->Enable(menu_count>0 && (list_wnd.Count() || count));


}

//*****************************************************************************
//*
//*		ExecCount
//*
//*****************************************************************************
//	Zhlt die Ausfgrungsmens
void CDataFinderView::ExecCount()
{
char			name[64];
CString			text;
CRegKeys		key;
int				i;


	menu_count = 0;

	key.Open(0,CRK_WRITE);

	if(key.Up(MENU_REG_PATH))
		{
		for(i=1;i<32;i++)								// Suche Meneintrge
			{
			sprintf(name,"Menu%i",i);
			if(!key.Up(name))break;
			if(!key.Get(text,"Name"))break;
			if(!key.Down())break;

			menu_count++;
			}
		}
}

//*****************************************************************************
//*
//*		ExecBreak
//*
//*****************************************************************************
//	Wird aufgerufen bei einem Benutzerabbruch in den Ausfgrungsmens
void _cdecl CDataFinderView::ExecBreak(CProgressDlg *Dlg)
{
CStartProg	    *start =(CStartProg*)Dlg->GetVoid2();


	if(start)start->Terminate();


}

//*****************************************************************************
//*
//*		ExecFiles
//*
//*****************************************************************************
//	Fhrt die Ausfgrungsmens auf alle Dateien aus
int _cdecl CDataFinderView::ExecFiles(CProgressDlg *Dlg)
{
char			 name[32],exe[256],param[256],edir[256],exet[256];
char			 env[256],puffer[1024],output[1024],mode[32],stream[256];
int				 j,k,ignore=0;
CRegKeys		 key;
CDataFinderView	*view  =(CDataFinderView*)Dlg->GetVoid1();
CStartProg	    *start =(CStartProg*     )Dlg->GetVoid2();
const char	    *menu  =				  Dlg->GetChar3();
int				 from  =				  Dlg->GetInt4();
int				 num   =				  Dlg->GetInt5();
const char	    *text;
char			 temp[MAX_PATH];
char			 file[MAX_PATH];
char			 last[MAX_PATH];
int				 line;
int				 size;
int				 cmp;
int				 pos;
int				 off;
int				 i;



	if(!key.Open(0,CRK_READ  ))return 0;
	if(!key.Up (MENU_REG_PATH))return 0;
	if(!key.Up (menu         ))return 0;


	cmp     = 0;
	last[0] = 0;

	for(pos=0;pos<num;pos++)
		{
		if(Dlg->IsStoped())break;

		text  = 0;
		line  = 0;
		size  = 0;
		off   = 0;

		switch(from)
			{
		case -1:											// Aus Dateiliste

			text = view->list_wnd.GetFileName(pos,TRUE);
			break;

		case 2:												// Cmp Daten

			   i = view->find_wnd.GetText(pos,file,sizeof(file));
			if(i>2)
				{
				i = strchar(file+2,':')+2;
				file[i]=0;
				}

			text = file;
			break;

		case 1:												// Hex Daten

			off  = view->find_hex.GetPos     (pos);
			size = view->find_hex.GetLength  (pos);
			text = view->find_hex.GetFileName(pos);
			break;

		case 0:												// Text Daten

			off  = view->find_text.GetPos     (pos);
			size = view->find_text.GetLength  (pos);
			line = view->find_text.GetLineNr  (pos);
			text = view->find_text.GetFileName(pos);
			break;
			}


		if(!text)continue;

		if(cmp && !CmpFileName(last,text))
			{
			continue;
			}


		Dlg->SetText("",text);


		//************ Programme ausfhren ************************************

		cmp = 1;


		do	{
			int			nowait,usepath,command,show,len,sub,ok=1;
			CString		path,body,file,dir,dir_,ext;
			const char *ptr;


			if(Dlg->IsStoped())break;


			MakeLongPath(path,text);						// Verzeichnisnamen
			GetFileName(file,path);
			GetFilePath(dir ,path);
			GetFileType(ext ,path);
			len =file.GetLength();
			len-=ext .GetLength();
			if(len>0 && file[len-1]=='.')len--;
			body=file.Left(len);

			dir_=dir;
			DelBackSlash(dir_);

			for(i=1;i<20;i++)								// Befehle laden
				{
				if(Dlg->IsStoped())break;

				exe   [0] = 0;
				edir  [0] = 0;
				mode  [0] = 0;
				param [0] = 0;
				command	  = 0;
				usepath	  = 0;
				nowait    = 0;
				show      = 0;

				sprintf(name,"Execute%i",i);
				if(!key.Get(exe,sizeof(exe),name))continue;
				sprintf(name,"Param%i",i);param[0]=0;
				key.Get(param,sizeof(param),name);
				sprintf(name,"Dir%i",i);edir[0]=0;
				key.Get(edir,sizeof(edir),name);
				sprintf(name,"Stream%i",i);stream[0]=0;
				key.Get(stream,sizeof(stream),name);
				sprintf(name,"ShellMode%i",i);mode[0]=0;
				key.Get(mode,sizeof(mode),name);
				sprintf(name,"UsePath%i",i);
				key.Get(usepath,name);
				sprintf(name,"Command%i",i);
				key.Get(command,name);
				sprintf(name,"NoWait%i",i);
				key.Get(nowait,name);
				sprintf(name,"Show%i",i);
				key.Get(show,name);


				if(edir[0]=='%')							// Pfad von Datei nehmen
					{
					j=strlen(edir);

					if(edir[1]=='D' && j+dir_.GetLength()<sizeof(edir))
						{
						memmove(edir+dir_.GetLength(),edir+2,j-1);
						memcpy (edir,(LPCSTR)dir_,dir_.GetLength());
						}

					if(edir[1]=='d' && j+dir.GetLength()<sizeof(edir))
						{
						memmove(edir+dir.GetLength(),edir+2,j-1);
						memcpy (edir,(LPCSTR)dir,dir.GetLength());
						}
					}


				switch(show)								// Welche Anzeige
						{
				case 0:	show=SW_HIDE;			break;
				case 2:	show=SW_MAXIMIZE;		break;
				case 3:	show=SW_MINIMIZE;		break;
				default:show=SW_SHOWNORMAL;		break;
						}

				for(j=0,k=0;k<sizeof(puffer);j++)			// Parameter erstellen
					{
					if(param[j]== 0 )break;
					if(param[j]!='%')
						{
						puffer[k]=param[j];k++;
						continue;
						}

					j++;
					sub=0;
					if(param[j]=='-'){j++;sub=1;}

					switch(param[j])
							{
					case'p':ptr=path;len=path.GetLength();			break;// Dateiname mit  Pfad
					case'f':ptr=file;len=file.GetLength();			break;// Dateiname ohne Pfad
					case'd':ptr=dir ;len=dir .GetLength();			break;// Nur Dateipfad mit  '\'
					case'D':ptr=dir_;len=dir_.GetLength();			break;// Nur Dateipfad onhe '\'
					case'b':ptr=body;len=body.GetLength();			break;// Dateiname ohne Suffix
					case'e':ptr=ext ;len=ext .GetLength();			break;// Suffix des Dateinamens
					case'l':ptr=temp;len=itostr(line,temp);cmp=0;	break;// Zeilennummer
					case's':ptr=temp;len=itostr(size,temp);cmp=0;	break;// Bereichsgre
					case'o':ptr=temp;len=itostr(off ,temp);cmp=0;	break;// Offset in Datei
					case 0 :ptr=name;len=1;name[0]='%';j--;			break;// Ende des Parameters
					case'%':ptr=name;len=1;name[0]='%';				break;// %% Angabe
					case'(':len=strchar( param+j+1,')');				  // Enviroment Variabel
							strlcpy(name,param+j+1,len+1);
							j+=len+1;
							len=GetEnvironmentVariable(name,env+1,sizeof(env)-2);
							env[0]='"';env[1+len]='"';env[2+len]=0;len+=2;
							ptr=env;
							break;
					default:ptr=name;len=1;name[0]='%';j--;			break;// Unbekanter Parameter
							}

					if(sub && ptr[0]=='"'){ptr++;len-=2;}

					if((int)sizeof(puffer)-k-1<=len)break;
					memcpy(puffer+k,ptr,len);
					k+=len;
					}

				puffer[k]=0;

				for(j=0,k=0;k<sizeof(output);j++)			// Ausgabe-Stream erstellen
					{
					if(stream[j]== 0 )break;
					if(stream[j]!='\\')
						{
						output[k]=strtoc(stream+j,&len);
						k++;
						j+=len-1;
						continue;
						}

					if(stream[j]!='%')
						{
						output[k]=stream[j];k++;
						continue;
						}

					j++;
					sub=0;
					if(stream[j]=='-'){j++;sub=1;}

					switch(stream[j])
							{
					case'p':ptr=path;len=path.GetLength();			break;// Dateiname mit  Pfad
					case'f':ptr=file;len=file.GetLength();			break;// Dateiname ohne Pfad
					case'd':ptr=dir ;len=dir .GetLength();			break;// Nur Dateipfad mit  '\'
					case'D':ptr=dir_;len=dir_.GetLength();			break;// Nur Dateipfad onhe '\'
					case'b':ptr=body;len=body.GetLength();			break;// Dateiname ohne Suffix
					case'e':ptr=ext ;len=ext .GetLength();			break;// Suffix des Dateinamens
					case'l':ptr=temp;len=itostr(line,temp);cmp=0;	break;// Zeilennummer
					case's':ptr=temp;len=itostr(size,temp);cmp=0;	break;// Bereichsgre
					case'o':ptr=temp;len=itostr(off ,temp);cmp=0;	break;// Offset in Datei
					case 0 :ptr=name;len=1;name[0]='%';j--;			break;// Ende des Parameters
					case'%':ptr=name;len=1;name[0]='%';				break;// %% Angabe
					case'(':len=strchar( stream+j+1,')');				  // Enviroment Variabel
							strlcpy(name,stream+j+1,len+1);
							j+=len+1;
							len=GetEnvironmentVariable(name,env+1,sizeof(env)-2);
							env[0]='"';env[1+len]='"';env[2+len]=0;len+=2;
							ptr=env;
							break;
					default:ptr=name;len=1;name[0]='%';j--;			break;// Unbekanter Parameter
							}

					if(sub && ptr[0]=='"'){ptr++;len-=2;}

					if((int)sizeof(output)-k-1<=len)break;
					memcpy(output+k,ptr,len);
					k+=len;
					}

				output[k]=0;

				if(command)									// Eine Kommandozeile ausfhren
					{
					if(!stricmp(param,"del \"%p\""))
						{
						DeleteFile(path);
						}
					else if(!stricmp(param,"attrib \"%p\" -R"))
						{
						   i = GetFileAttributes(path);
						if(i!=0xFFFFFFFF && (i&FILE_ATTRIBUTE_READONLY))
							{
							i &= ~FILE_ATTRIBUTE_READONLY;
							SetFileAttributes(path,i);
							}
						}
					else{
						i = GetTempPath(sizeof(exe),exe);
						sprintf(exe+i,"CMD%08X.bat",GetCurrentProcessId());

						SaveMemory(exe,puffer);

									 start->Reset();
									 start->SetFilename(exe);
						if(edir  [0])start->SetDirectory(edir);

						if(show!=SW_SHOWNORMAL)start->SetShow(show);

						ok = start->Start((nowait)? CSP_NOWAIT:CSP_WAIT);

						DeleteFile(exe);
						}
					}
				else if(stricmp(exe,"SHELL"))				// Exe-Datei oder Shell-Aufruf
					{
					if(usepath)
						{
						if(FindPathFile(exet,exe,sizeof(exet),";exe;com;bat"))
							{
							strlcpy(exe,exet,sizeof(exe));
							}
						}

								 start->Reset();
								 start->SetFilename(exe);
					if(puffer[0])start->SetParamMulti(puffer);
					if(edir  [0])start->SetDirectory(edir);

					if(show!=SW_SHOWNORMAL)start->SetShow(show);

					if(stream[0])							// Einen Text an STDIN bergeben
						{
						HANDLE	handle;
						DWORD	bytes=0;

						len=strlen(output);
						start->SetStdOutPipe(handle,sizeof(output+16));

						if(Dlg->IsStoped())break;
						if(start->Start(CSP_NOWAIT))
							{
							ok=1;
							WriteFile(handle,output,len,&bytes,NULL);
							if(len!=(int)bytes)ok=0;
							if(ok && !nowait)start->Wait();
							}
						else{
							ok=0;
							}
						}
					else{									// Ohne Stram zu STDIN ausfhen
						if(Dlg->IsStoped())break;
						ok = start->Start((nowait)? CSP_NOWAIT:CSP_WAIT);
						}

					}
				else{
					if(puffer[0]=='"')
							{j=1;k=strchar(puffer+1,'"')+1;	}
					else	{j=0;k=strchar(puffer  ,' ');	}

					puffer[k]=0;
					if(!*mode || !stricmp(mode,"SHELL"))strcpy(mode,"open");
					i=(int)ShellExecute(0,mode,puffer+j,puffer+k+1,(*edir)? edir:0,show);
					ok = (i>=0 && i<=32)? 0:1;
					}

				if(!ok && !ignore)							// Gab es einen Fehler bei der Ausfhrung
					{
					sprintf(temp,"Fehler beim Ausfhren von '%s' !\nWeiter machen ?",(LPCSTR)exe);
					ok=Dlg->MessageBox(temp,"Fehler",MB_ABORTRETRYIGNORE|MB_ICONERROR);
					if(ok==IDABORT){num=0;break;}
					if(ok==IDIGNORE)ignore=1;
					last[0]=0;
					i--;
					}
				}


			}while(0);


		Dlg->SetPos(pos);

		strlcpy(last,text,sizeof(last));
		}


return 0;
}

//*****************************************************************************
//*
//*		OnChacheSize
//*
//*****************************************************************************
//	Einstellen der maximalen Datei-Chache-Gre
void CDataFinderView::OnChacheSize()
{
CValueDlg	dlg;
int			max;
int			num;


	max = cache_max>>20;

	dlg.SetValue(max);
	dlg.SetTitle("Datei-Chache-Gre");
	dlg.SetTextTitle("Bitte die Gre in MB angeben :");


	if(dlg.DoModal()!=IDOK)return;

	   max = dlg.GetValue();
	if(max>1000)max=1000;
	if(max<0)max=0;


	cache_max = max<<20;

	num = cache_max/2;
	if(num<32<<20)num=32<<20;

	SetProcessWorkingSetSize(GetCurrentProcess(),num,num*3);

}


//*****************************************************************************
//*
//*		OnMaxFind
//*
//*****************************************************************************
//	Einstellen der maximalen Anzahl an gefunden Eintrgen
void CDataFinderView::OnMaxFind()
{
CValueDlg	dlg;
int			max;



	max = find_text.GetMaxCount();

	dlg.SetTitle("Ergebnislimith");
	dlg.SetTextTitle("Bitte das neue Linith eingeben :");


	if(dlg.DoModal()!=IDOK)return;

	   max = dlg.GetValue();
	if(max>1000000)max=1000000;
	if(max<10)max=10;

	find_hex .SetMaxCount(max);
	find_text.SetMaxCount(max);


}

//*****************************************************************************
//*
//*		OnContextMenu
//*
//*****************************************************************************
void CDataFinderView::OnContextMenu(CWnd *Wnd,CPoint Point)
{

	if(Wnd->m_hWnd==find_wnd.m_hWnd)
		{
		CMenu	menu;
		UINT	flag;

		menu.CreatePopupMenu();

		flag = (find_wnd.IsSeleced())? 0:MF_GRAYED;
		menu.AppendMenu(MF_STRING|flag,ID_LISTCOPY,"&Kopieren");
		flag = (find_wnd.GetCurSel()>=0)? 0:MF_GRAYED;
		menu.AppendMenu(MF_STRING|flag,ID_PATHCOPY,"&Pfad Kopieren");
		flag = (find_wnd.GetCount ())? 0:MF_GRAYED;
		menu.AppendMenu(MF_STRING|flag,ID_LISTMARK,"&Alles markieren");
		flag = (find_wnd.IsSeleced()==1)? 0:MF_GRAYED;
		menu.AppendMenu(MF_STRING|flag,ID_FINDWORD,"Suche markierten Text");

		switch(list_mode)
			{
		case 0:		flag = (find_text .Count())? 0:MF_GRAYED;	break;
		case 1:		flag = (find_hex  .Count())? 0:MF_GRAYED;	break;
		case 2:		flag = (cmp_return.Count())? 0:MF_GRAYED;	break;
		default:	flag = MF_GRAYED;							break;
			}

		menu.AppendMenu(MF_SEPARATOR);
		menu.AppendMenu(MF_STRING|flag,ID_SORTPATH  ,"Nach Datei&pfad sortieren");
		menu.AppendMenu(MF_STRING|flag,ID_SORTNAME  ,"Nach Datei&name sortieren");
		menu.AppendMenu(MF_STRING|flag,ID_SORTTYPE  ,"Nach Datei&typ sortieren");

		AddMenuBitmap(menu,ID_LISTCOPY ,IDB_TOOLICONS, 1);
		AddMenuBitmap(menu,ID_FINDWORD ,IDB_TOOLICONS, 6);
		AddMenuBitmap(menu,ID_SORTPATH ,IDB_TOOLICONS, 7);
		AddMenuBitmap(menu,ID_SORTNAME ,IDB_TOOLICONS, 8);
		AddMenuBitmap(menu,ID_SORTTYPE ,IDB_TOOLICONS,11);

		menu.TrackPopupMenu(TPM_LEFTALIGN,Point.x,Point.y,this);

		menu.DestroyMenu();

		return;
		}


	if(Wnd->m_hWnd==file_wnd.m_hWnd)
		{
		LPVOID	handle;
		CMenu	menu;
		UINT	flag;
		int		ret;
		int		row;

			ret = file_wnd.HitTest(Point,&handle,&row);
		if(!ret)return;

		file_wnd.GetPath(ret,handle,file_name,sizeof(file_name),   1);
		file_wnd.GetPath(ret,handle,file_full,sizeof(file_full),-row);

		menu.CreatePopupMenu();

		flag = (file_name[0]          )? 0:MF_GRAYED;
		menu.AppendMenu(MF_STRING|flag,ID_COPY_LAST,"&Namen kopieren" );
		flag = (file_name[0]          )? 0:MF_GRAYED;
		menu.AppendMenu(MF_STRING|flag,ID_COPY_NAME,"&Pfad kopieren"  );
		flag = (file_full[0] && ret==2)? 0:MF_GRAYED;
		menu.AppendMenu(MF_STRING|flag,ID_COPY_FULL,"&Spalte kopieren");

		AddMenuBitmap(menu,ID_COPY_LAST ,IDB_TOOLICONS, 1);
		AddMenuBitmap(menu,ID_COPY_NAME ,IDB_TOOLICONS, 9);

		menu.TrackPopupMenu(TPM_LEFTALIGN,Point.x,Point.y,this);

		menu.DestroyMenu();

		return;
		}

}

//*****************************************************************************
//*
//*		OnListCopy
//*
//*****************************************************************************
//	Text in Ergebnisliste kopieren
void CDataFinderView::OnListCopy()
{
	find_wnd.Copy();
}

//*****************************************************************************
//*
//*		OnPathCopy
//*
//*****************************************************************************
//	Den Pfad eines Suchergebnisses in der Ergebnisliste kopieren.
void CDataFinderView::OnPathCopy()
{
char	path[MAX_PATH];
int 	sel;
int		pos;
	


	   sel = find_wnd.GetCurSel();
	if(sel<0)return;

	find_wnd.GetText(sel,path,MAX_PATH);


	if(strwchar(path[0],0x06) && path[1]==':')
		{
		pos = 2;
		}
	else{
		pos = 0;
		}

	pos += strchar(path+pos,':');

	if(path[pos] && pos>0 && list_mode==2)
		{
		pos -= strbwlen(path+pos,0xE0,pos);
		}

	if(path[pos] && pos>0 && path[pos-1]==')')
		{
		pos -= 1;
		pos -= strbwlen(path+pos,0x01,pos);
		
		if(pos>0 && path[pos-1]=='(')pos--;
		}


	if(pos)SetClipboardText(path,pos);


}

//*****************************************************************************
//*
//*		OnListMark
//*
//*****************************************************************************
//	Gesamten Text in Ergebnisliste auswhlen
void CDataFinderView::OnListMark()
{
	find_wnd.MarkAll();
}

//*****************************************************************************
//*
//*		SortPath
//*
//*****************************************************************************
//	Dateivergleich nach Dateipfad sortieren
int CDataFinderView::SortPath(CStringChain *pList,int iPos1,int iPos2)
{
const char *pPath1;
const char *pPath2;
const char *pName1;
const char *pName2;
int			iOff1;
int			iOff2;
int			iLen1;
int			iLen2;
int			iLen;
int			iCmp;


	pPath1	= pList->Get(iPos1);
	pPath2	= pList->Get(iPos2);
	iLen1	= strchar(pPath1+2,':')+2;
	iLen2	= strchar(pPath2+2,':')+2;
	pName1	= GetFileName(iLen1,pPath1);
	pName2	= GetFileName(iLen2,pPath2);
	iOff1	= pName1-pPath1;
	iOff2	= pName2-pPath2;
	iLen1  -= iOff1;
	iLen2  -= iOff2;
	iLen1  -= strbwlen(pName1,0xE0,iLen1);
	iLen2  -= strbwlen(pName2,0xE0,iLen2);

	   iLen	= (iOff1<iOff2)? iOff1:iOff2;
	   iCmp	= strnvicmp(pPath1,pPath2,iLen);
	if(iCmp)return iCmp;
	if(iOff1!=iOff2)return iOff1-iOff2;

	   iLen	= (iLen1<iLen2)? iLen1:iLen2;
	   iCmp	= strnvicmp(pName1,pName2,iLen);
	if(iCmp)return iCmp;
	if(iLen1!=iLen2)return iLen1-iLen2;



return strvcmp(pPath1+iOff1+iLen1,pPath2+iOff2+iLen2);
}

//*****************************************************************************
//*
//*		SortName
//*
//*****************************************************************************
//	Dateivergleich nach Dateinamen sortieren
int CDataFinderView::SortName(CStringChain *pList,int iPos1,int iPos2)
{
const char *pPath1;
const char *pPath2;
const char *pName1;
const char *pName2;
int			iOff1;
int			iOff2;
int			iLen1;
int			iLen2;
int			iLen;
int			iCmp;


	pPath1	= pList->Get(iPos1);
	pPath2	= pList->Get(iPos2);
	iLen1	= strchar(pPath1+2,':')+2;
	iLen2	= strchar(pPath2+2,':')+2;
	pName1	= GetFileName(iLen1,pPath1);
	pName2	= GetFileName(iLen2,pPath2);
	iOff1	= pName1-pPath1;
	iOff2	= pName2-pPath2;
	iLen1  -= iOff1;
	iLen2  -= iOff2;
	iLen1  -= strbwlen(pName1,0xE0,iLen1);
	iLen2  -= strbwlen(pName2,0xE0,iLen2);


	   iLen	= (iLen1<iLen2)? iLen1:iLen2;
	   iCmp	= strnvicmp(pName1,pName2,iLen);
	if(iCmp)return iCmp;
	if(iLen1!=iLen2)return iLen1-iLen2;

	   iLen	= (iOff1<iOff2)? iOff1:iOff2;
	   iCmp	= strnvicmp(pPath1,pPath2,iLen);
	if(iCmp)return iCmp;
	if(iOff1!=iOff2)return iOff1-iOff2;


return strvcmp(pPath1+iOff1+iLen1,pPath2+iOff2+iLen2);
}

//*****************************************************************************
//*
//*		SortType
//*
//*****************************************************************************
//	Dateivergleich nach Dateintyp sortieren
int CDataFinderView::SortType(CStringChain *pList,int iPos1,int iPos2)
{
const char *pPath1;
const char *pPath2;
const char *pName1;
const char *pName2;
const char *pType1;
const char *pType2;
int			iOff1;
int			iOff2;
int			iNum1;
int			iNum2;
int			iLen1;
int			iLen2;
int			iLen;
int			iCmp;


	pPath1	= pList->Get(iPos1);
	pPath2	= pList->Get(iPos2);
	iLen1	= strchar(pPath1+2,':')+2;
	iLen2	= strchar(pPath2+2,':')+2;
	pName1	= GetFileName(iLen1,pPath1);
	pName2	= GetFileName(iLen2,pPath2);
	iOff1	= pName1-pPath1;
	iOff2	= pName2-pPath2;
	iLen1  -= iOff1;
	iLen2  -= iOff2;
	iLen1  -= strbwlen(pName1,0xE0,iLen1);
	iLen2  -= strbwlen(pName2,0xE0,iLen2);
	pType1	= GetFileType(iLen1,pName1);
	pType2	= GetFileType(iLen2,pName2);
	iNum1	= iLen1-(pType1-pName1);
	iNum2	= iLen2-(pType2-pName2);

	   iLen	= (iNum1<iNum2)? iNum1:iNum2;
	   iCmp	= strnvicmp(pType1,pType2,iLen);
	if(iCmp)return iCmp;
	if(iNum1!=iNum2)return iNum1-iNum2;

	   iLen	= (iOff1<iOff2)? iOff1:iOff2;
	   iCmp	= strnvicmp(pPath1,pPath2,iLen);
	if(iCmp)return iCmp;
	if(iOff1!=iOff2)return iOff1-iOff2;

	   iLen	= (iLen1<iLen2)? iLen1:iLen2;
	   iCmp	= strnvicmp(pName1,pName2,iLen);
	if(iCmp)return iCmp;
	if(iLen1!=iLen2)return iLen1-iLen2;


return strvcmp(pPath1+iOff1+iLen1,pPath2+iOff2+iLen2);
}

//*****************************************************************************
//*
//*		OnFindWord
//*
//*****************************************************************************
//	Suche nach dem markierten Wort in der Ergebnisliste
void CDataFinderView::OnFindWord()
{
CString		text;


	if(find_wnd.GetSelectedText(text)!=1)return;

	FindText(text);

}

//*****************************************************************************
//*
//*		OnSort??
//*
//*****************************************************************************
//	Sortieren der Ergebnisliste
void CDataFinderView::OnSortPath(){OnSortFind(0);}
void CDataFinderView::OnSortName(){OnSortFind(1);}
void CDataFinderView::OnSortType(){OnSortFind(2);}
void CDataFinderView::OnSortFind(int Mode)
{


	SetCursor(IDC_WAIT);

	if(list_mode==2)						// Cmp Daten
		{
		if(sort_mode==Mode)
			{
			sort_dir  = !sort_dir;
			}
		else{
			sort_mode = Mode;
			sort_dir  = 0;
			}

		switch(Mode)
			{
		case 0:	cmp_return.Sort(0,-1,SortPath,sort_dir);	break;
		case 1:	cmp_return.Sort(0,-1,SortName,sort_dir);	break;
		case 2:	cmp_return.Sort(0,-1,SortType,sort_dir);	break;
			}

		find_wnd.ResetContent();
		SetCmpResult();
		}
	else if(list_mode==1)					// Hex Daten
		{
		if(find_hex.Sort(Mode,-1))
			{
			find_wnd.ResetContent();
			SetHexResult();
			}
		}
	else if(list_mode==0)					// Txt Daten
		{
		if(find_text.Sort(Mode,-1))
			{
			find_wnd.ResetContent();
			SetTextResult();
			}
		}

	SetCursor(IDC_ARROW);


}

//*****************************************************************************
//*
//*		Destruktor
//*
//*****************************************************************************
//	Unbenutze Dateien aus dem Cache lschen
void CDataFinderView::CheckCache()
{
CacheItem  *item;
int			pos;
int			len;


	pos = cache_data.Count();
	len = 0;

	while(pos>0)
		{
		pos--;
		item = (CacheItem*)cache_data.Data(pos);
		if(item->flag)
			{
			len += item->len;
			continue;
			}

		delete item->mem;
		cache_data.Del(pos);
		}


	cache_data.SetUserData(len);


}

//*****************************************************************************
//*
//*		GetFileList
//*
//*****************************************************************************
//	Eine Liste alle Dateien aus der Datei- oder Ergebnisliste holen
//	List		: Zeiger auf die Liste
//	Mode		: 0=Dateiliste 1=Ergebnisliste 
//	Ergibt die Anzahl der gefundenen Dateien
int	CDataFinderView::GetFileList(CStringChain *List,int Mode)
{
char		file[256];	
LPCTSTR		path;
int			pos;
int			num;
int			idx;


	List->Del();


	if(!Mode)											// Aus Dateiliste
		{
		for(pos=0;;pos++)
			{
				path = list_wnd.GetFileName(pos,TRUE);
			if(!path)

			List->Add(path,CSC_ABCG);
			}

		
		return List->Count();
		}


	if(!list_count)	
		{
		return 0;
		}

	switch(list_mode)
		{
	case 2:												// Cmp Daten

		for(pos=0;pos<list_count;pos++)
			{
			   num = find_wnd.GetText(pos,file,sizeof(file));
			if(num>2)
				{
				num = strchar(file+2,':')+2;
				idx = List->FindFast(num,file,0,-1,0x01);
				if(idx>=0)continue;
				List->Add(num,file,CSC_ABCG);
				}
			}
		
		break;

	case 1:												// Hex Daten

		for(pos=0;pos<list_count;pos++)
			{
			path = find_hex.GetFileName(pos,num);
			idx  = List->FindFast(num,path,0,-1,0x01);
			if(idx>=0)continue;
			List->Add(num,path,CSC_ABCG);
			}
		
		break;

	case 0:												// Text Daten

		for(pos=0;pos<list_count;pos++)
			{
			path = find_text.GetFileName(pos,num);
			idx  = List->FindFast(num,path,0,-1,0x01);
			if(idx>=0)continue;
			List->Add(num,path,CSC_ABCG);
			}
		break;
		}



return List->Count();
}

//*****************************************************************************
//*
//*		OnDelLines
//*
//*****************************************************************************
//	Lscht Zeilen in einer Textdatei
void CDataFinderView::OnDelLines()
{
CLinesDlg		sDlg;


	if(list_mode!=0)
		{
		MessageBox("Es muss vorab eine Textsuche fr die Zeilen gemacht werden !","Fehler",MB_OK|MB_ICONWARNING);
		return;
		}

	if(find_text.Count()<=0)
		{
		MessageBox("Es sind Keine Zeilen gefunden worden !","Fehler",MB_OK|MB_ICONWARNING);
		return;
		}

	sDlg.m_bDelete = TRUE;
	sDlg.m_pList   = &find_text;
	sDlg.DoModal();

	find_text.Delete();
	SetTextResult();
	SetFindWnd(0);

}


//*****************************************************************************
//*
//*		OnAddLines
//*
//*****************************************************************************
//	Fgt Zeile in eine Textdatei ein.
void CDataFinderView::OnAddLines()
{
CLinesDlg		sDlg;


	if(list_mode!=0)
		{
		MessageBox("Es muss vorab eine Textsuche fr die Zeilen gemacht werden !","Fehler",MB_OK|MB_ICONWARNING);
		return;
		}

	if(find_text.Count()<=0)
		{
		MessageBox("Es sind Keine Zeilen gefunden worden !","Fehler",MB_OK|MB_ICONWARNING);
		return;
		}

	sDlg.m_bDelete = FALSE;
	sDlg.m_pList   = &find_text;
	sDlg.DoModal();

	find_text.Delete();
	SetTextResult();
	SetFindWnd(0);

}