//*****************************************************************************
//*
//*
//*		DataFinderView.h : Schnittstelle der Klasse CDataFinderView
//*
//*
//*****************************************************************************
#if !defined(AFX_DATAFINDERVIEW_H__6B7D16FA_148A_11D5_9043_00E07D86939E__INCLUDED_)
#define		 AFX_DATAFINDERVIEW_H__6B7D16FA_148A_11D5_9043_00E07D86939E__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif

#include	"TextFind.h"
#include	"HexFind.h"
#include	"FileListCtrl.h"
#include	"BrowserCtrl.h"
#include	"StartProg.h"
#include	"ProgressDlg.h"
#include	"ColorListBox.h"

//*****************************************************************************
//*
//*		KLASSE	CDataFinderView
//*
//*****************************************************************************
class CDataFinderView : public CView
{
protected:

	CDataFinderView();
	DECLARE_DYNCREATE(CDataFinderView)


public:
	CDataFinderDoc* GetDocument();

public:

	//{{AFX_VIRTUAL(CDataFinderView)
	public:
	virtual void OnDraw(CDC *pDC);  // berladen zum Zeichnen dieser Ansicht
	virtual BOOL PreCreateWindow(CREATESTRUCT& cs);
	virtual BOOL Create(LPCTSTR lpszClassName, LPCTSTR lpszWindowName, DWORD dwStyle, const RECT& rect, CWnd* pParentWnd, UINT nID, CCreateContext* pContext = NULL);
	protected:
	virtual void OnUpdate(CView* pSender, LPARAM lHint, CObject* pHint);
	//}}AFX_VIRTUAL

protected:

	void	SetSize();

public:

	void	OnCompareText();
	void    OnCompareFiles();
	void    OnRenameFiles();
	void	OnDelete();
	void	OnChange();
	void	OnAddFiles();
	void	OnFindText();
	void	OnFindHex();
	void	OnCut();
	void	OnCopy();
	void	OnPaste();
	void	OnTabConvert();
	void	OnAsciiAnsi();
	void	OnLfCrConvert();
	void	OnInsertAllFiles();
	void	OnDeleteAllFiles();
	void	OnAddLines();
	void	OnDelLines();
	void	OnFindSame();
	void	OnReload();
	void	OnZipFiles();
	void	OnExecFiles();
	void	OnCppBeatify();
	void	OnSortFind(int Mode);
	void	FindText(const char *Text=0);
	void	SetFindWnd(BOOL On);
	void	SetPath(const char *Pfad);
	void	AddNetPath(const char *Pfad);
	void	StartMenu(const char *Filename,LPPOINT Point=0);
	void	AddFiles(const char *pPath,const char *pPlus=0,const char *pMinus=0,int iSubDir=1,int iProtect=0,int iTimeMode=0,time_t iTimeValue=0);
	int		GetFileList(CStringChain *List,int Mode);

	virtual ~CDataFinderView();
#ifdef _DEBUG
	virtual void AssertValid() const;
	virtual void Dump(CDumpContext& dc) const;
#endif

	static	LRESULT CALLBACK ListBoxProc(HWND hwnd,UINT uMsg,WPARAM wParam,LPARAM lParam);
	static	int  _cdecl AsciiAnsiProc  (CProgressDlg *Dlg);
	static	int  _cdecl CppBeatifyProc (CProgressDlg *Dlg);
	static	int  _cdecl LfCrConvertProc(CProgressDlg *Dlg);
	static	int  _cdecl TabConvertProc (CProgressDlg *Dlg);
	static	int  _cdecl CopyFilesProc  (CProgressDlg *Dlg);
	static	int  _cdecl CmpFilesProc   (CProgressDlg *Dlg);
	static	int  _cdecl AddFilesProc   (CProgressDlg *Dlg);
	static	int  _cdecl FindTextProc   (CProgressDlg *Dlg);
	static	int  _cdecl FindHexProc    (CProgressDlg *Dlg);
	static	int  _cdecl ExecFiles      (CProgressDlg *Dlg);
	static	void _cdecl AddFilesTime   (CProgressDlg *Dlg);
	static	void _cdecl FindTextTime   (CProgressDlg *Dlg);
	static	void _cdecl FindHexTime    (CProgressDlg *Dlg);
	static	void _cdecl ExecBreak      (CProgressDlg *Dlg);
	static	int		    SortPath       (CStringChain *pList,int iPos1,int iPos2);
	static	int		    SortName       (CStringChain *pList,int iPos1,int iPos2);
	static	int		    SortType       (CStringChain *pList,int iPos1,int iPos2);
	static	int  _cdecl SortWords      (const void *pPtr1,const void *pPtr2);
	static	int  _cdecl CmpLineFeeds   (const char *File1,const char *File2);


protected:

	void	SetTextResult();
	void	SetHexResult();
	void	SetCmpResult();
	void	SetProgPos(CStartProg *start,WINDOWPLACEMENT *place);


protected:

	typedef	struct											// Daten fr Suchergebnis
		{
		int			len;									// Lnge der Cache-Daten
		int			flag;									// Wurde die Datei benutzt
		unsigned 	time;									// nderungszeit der Datei
		char	   *mem;									// Zeiger auf die Daten
		}CacheItem;

	CStartProg		prog_text;
	CStartProg		prog_hex;
	CStartProg		prog_cmp;
	CColorListBox	find_wnd;
	CHexFind		find_hex;
	CTextFind		find_text;
	CBrowserCtrl	file_wnd;
	CFileListCtrl	list_wnd;
	CString			find_path;
	CStringChain	cache_data;
	CStringChain	cmp_return;
	CString			cmp_path1;
	CString			cmp_path2;
	CString			find_last;
	int				teilung;
	int 			cmp_mode;			// Ergebnis fr Verzeichnissvergeich (0=keine Unterschiede 1=keine Dateien)
	int				cache_max;			// Maximale Gre des Datei-Caches
	int				menu_count;			// Anzahl der Ausfhrungsmens
	int				sort_dir;			// Sortierrichtung fr Dateivergleich
	int				sort_mode;			// Sortiermodus fr Dateivergleich (-1=keine 0=Pfad 1=Name 2=Typ)
	int				sort_list;			// Sortiermodus fr die Dazeiliste 
	int				file_sort;			// Sortiermodus fr das Listfenster
	int				drag_on;			// Ist ein Text-Drag aktiv
	int				list_brt;			// Hhe des Listfenster
	int				list_on;			// Ist Listfenster eingeschalten
	int				list_mode;			// 0=Text 1=Hex 2=Cmp
	int				list_count;			// Anzahl der gefunden Eintrge
	int				last_count;			// Letzte ausgegeben Zahl an gefundenen Eintrgen
	int				last_focus;			// 0=tree 1=files 2=list 3=find
	__int64			file_bytes;			// Gesamtlnge der zu durchsuchenden Dateien
	char			file_name[MAX_PATH];// Dateiname fr RClick
	char			file_full[MAX_PATH];// Dateiname fr RClick
	WINDOWPLACEMENT	prog_pos[3];		// Positionen der Fenster
	BOOL			prog_on [3];		// Sind die Programme aktiv
	static LPCTSTR  cpp_words[];		// Sind die C++ Schlsserwrter

	int		StatusbarInit();
	int		StatusbarExit();
	void	CheckCache();
	void	ExecCount();

protected:
	//{{AFX_MSG(CDataFinderView)
	afx_msg void OnSize(UINT nType, int cx, int cy);
	afx_msg void OnLButtonDown(UINT nFlags, CPoint point);
	afx_msg void OnSetFocus(CWnd  *pOldWnd);
	afx_msg void OnContextMenu    (CWnd *pWnd,CPoint sPoint);
	afx_msg void OnBrowserRButton (NMHDR *pNmHdr, LRESULT *pResult);
	afx_msg void OnMouseRButton   (NMHDR *pNmHdr, LRESULT *pResult);
	afx_msg void OnListKeyDown    (NMHDR *pNmHdr, LRESULT *pResult);
	afx_msg void OnListStatus     (NMHDR *pNmHdr, LRESULT *pResult);
	afx_msg void OnFileStatus     (NMHDR *pNmHdr, LRESULT *pResult);
	afx_msg void OnFolderSelect   (NMHDR *pNmHdr, LRESULT *pResult);
	afx_msg void OnBeginDrag	  (NMHDR *pNmHdr, LRESULT *pResult);
	afx_msg void OnFocusList      (NMHDR *pNmHdr, LRESULT *pResult);
	afx_msg void OnFocusFiles     (NMHDR *pNmHdr, LRESULT *pResult);
	afx_msg void OnExecFilesUpdate(CCmdUI *pCmdUI);
	afx_msg void OnChangeUpdate	  (CCmdUI *pCmdUI);
	afx_msg void OnFilesUpdate    (CCmdUI *pCmdUI);
	afx_msg void OnTimer          (UINT_PTR nIDEvent);
	afx_msg void OnFindDblClk();
	afx_msg void OnDestroy();
	afx_msg void OnCopyLast();
	afx_msg void OnCopyList();
	afx_msg void OnCopyPath();
	afx_msg void OnCopyFull();
	afx_msg void OnCopyName();
	afx_msg void OnTxtEditor();
	afx_msg void OnHexEditor();
	afx_msg void OnShellOpen();
	afx_msg void OnFocusFind();
	afx_msg void OnCopyFiles();
	afx_msg void OnCompareDirectory();
	afx_msg void OnChacheSize();
	afx_msg void OnExecMenus();
	afx_msg void OnMaxFind();
	afx_msg void OnListCopy();
	afx_msg void OnPathCopy();
	afx_msg void OnListMark();
	afx_msg void OnFindWord();
	afx_msg void OnSortPath();
	afx_msg void OnSortName();
	afx_msg void OnSortType();
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

#ifndef _DEBUG
inline CDataFinderDoc* CDataFinderView::GetDocument()
   { return (CDataFinderDoc*)m_pDocument; }
#endif

//{{AFX_INSERT_LOCATION}}

#endif
