//*****************************************************************************
//*
//*
//*		ExecConfigDlg.cpp: Implementierungsdatei
//*
//*
//*****************************************************************************
#include	"StdAfx.h"
#include	"DataFinder.h"
#include	"ExecConfigDlg.h"
#include	"AfxUtility.h"
#include	"AfxDialog.h"
#include	"PathDlg.h"



#ifdef		_DEBUG
#define new	 DEBUG_NEW
#undef		 THIS_FILE
static char	 THIS_FILE[] = __FILE__;
#endif


#define 	 ID_PARAM	0x1100
#define 	 ID_STREAM	0x1200


BEGIN_MESSAGE_MAP(CExecConfigDlg, CDialog)
	//{{AFX_MSG_MAP(CExecConfigDlg)
	ON_BN_CLICKED(IDC_CHECK4,    OnCheck)
	ON_BN_CLICKED(IDC_NEWMENU,   OnNewMenu)
	ON_BN_CLICKED(IDC_NEWENTRY,  OnNewEntry)
	ON_BN_CLICKED(IDC_DELETE,    OnDelete)
	ON_BN_CLICKED(IDC_ENTRYUP,   OnEntryUp)
	ON_BN_CLICKED(IDC_BUTTON1,   OnPath)
	ON_BN_CLICKED(IDC_BUTTON3,   OnDir)
	ON_BN_CLICKED(IDC_BUTTON2,   OnParam)
	ON_BN_CLICKED(IDC_BUTTON4,   OnStream)
	ON_LBN_SELCHANGE(IDC_LIST1,  OnSelChange)
	ON_CBN_SELCHANGE(IDC_COMBO1, OnSelChangeCombo)
	ON_BN_CLICKED(IDC_ENTRYDOWN, OnEntryDown)
	ON_BN_CLICKED(IDC_DELMENU,   OnDeleteMenu)
	ON_WM_DESTROY()
	//}}AFX_MSG_MAP
	ON_COMMAND_RANGE(ID_PARAM ,ID_PARAM +10,OnParamMenu)
	ON_COMMAND_RANGE(ID_STREAM,ID_STREAM+10,OnStreamMenu)
END_MESSAGE_MAP()


DLG_OLDPOS(CExecConfigDlg)




//*****************************************************************************
//*
//*		Konstruktor
//*
//*****************************************************************************
// Dialogfeld CExecConfigDlg
CExecConfigDlg::CExecConfigDlg(CWnd *pParent)	: CDialog(CExecConfigDlg::IDD,pParent)
{
	//{{AFX_DATA_INIT(CExecConfigDlg)
	m_shell       = FALSE;
	m_nowait      = FALSE;
	m_usepath	  = FALSE;
	m_command	  = FALSE;		
	m_menuentry   = -1;
	m_program     = _T("");
	m_parameter   = _T("");
	m_directory   = _T("");
	m_outstream	  = _T("");
	m_selectentry = -1;
	m_show = 0;
	//}}AFX_DATA_INIT
}



//*****************************************************************************
//*
//*		DoDataExchange
//*
//*****************************************************************************
void CExecConfigDlg::DoDataExchange(CDataExchange *pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CExecConfigDlg)
	DDX_Check(pDX, IDC_CHECK1,   m_shell);
	DDX_Check(pDX, IDC_CHECK2,   m_nowait);
	DDX_Check(pDX, IDC_CHECK3,   m_usepath);
	DDX_Check(pDX, IDC_CHECK4,   m_command);
	DDX_Text (pDX, IDC_EDIT1,    m_program);
	DDX_Text (pDX, IDC_EDIT2,    m_parameter);
	DDX_Text (pDX, IDC_EDIT3,    m_directory);
	DDX_Text (pDX, IDC_EDIT4,    m_outstream);
	DDX_Radio(pDX, IDC_RADIO1,   m_show);
	DDX_LBIndex(pDX, IDC_LIST1,  m_selectentry);
	DDX_CBIndex(pDX, IDC_COMBO1, m_menuentry);
	//}}AFX_DATA_MAP
}





//*****************************************************************************
//*
//*		OnNewMenu
//*
//*****************************************************************************
//	Ein Neues Men einfgen
void CExecConfigDlg::OnNewMenu()
{
CTextDlg	dlg;
CComboBox  *cb;




	dlg.SetTitle("Neuer Meneintrag");
	dlg.SetTextTitle("Menname (&& fr Hotkey) :");

	if(dlg.DoModal()!=IDOK)return;
	if(dlg.m_sText=="")
		{
		MessageBox("Es wurde kein Menname angegeben !");
		return;
		}

	cb=(CComboBox*)GetDlgItem(IDC_COMBO1);
	menu_items.Add(dlg.m_sText);
	dlg.m_sText.Remove('&');
	cb->AddString(dlg.m_sText);

	SelectEntry(-1);
	ScanEntry(menu_items.Count()-1);

}

//*****************************************************************************
//*
//*		OnDeleteMenu
//*
//*****************************************************************************
//	Ein Men lschen
void CExecConfigDlg::OnDeleteMenu()
{
CComboBox  *cb;
CRegKeys 	key;
int			x,sel;


	if(menu_sel<0)return;
	if(menu_sel>=menu_items.Count())return;
	if(MessageBox("Das Men wiklich lschen ?",0,MB_YESNO)!=IDYES)return;


	SelectEntry(-1);

	sel=menu_sel;
	for(x=menu_sel;;x++)
		{
		DelMenu(x);
		if(x+1>=menu_items.Count())break;
		ScanEntry(x+1);
		SaveMenu(x);
		}

	cb=(CComboBox*)GetDlgItem(IDC_COMBO1);
	menu_items.Del(sel);
	cb->DeleteString(sel);

	menu_sel=menu_items.Count()-1;
	ScanEntry(menu_sel);
	cb->SetCurSel(menu_sel);
	m_menuentry=menu_sel;
	SelectEntry(0);

}

//*****************************************************************************
//*
//*		OnNewEntry
//*
//*****************************************************************************
//	Einen neuen Eintrag in einem Men einfgen
void CExecConfigDlg::OnNewEntry()
{
CListBox	*lb;



	if(menu_items.Count()<=0)
		{
		MessageBox("Zuerst ein Men erstellen.");
		return;
		}

	if(entry_count>=32)
		{
		MessageBox("Es gibt zuvile Eintrge.");
		return;
		}

	memset(entrys+entry_count,0,sizeof(entrys[entry_count]));
	entrys[entry_count].m_show=1;

	lb=(CListBox*)GetDlgItem(IDC_LIST1);
	lb->AddString("<neuer Eintrag>");

	if(entry_count<=0)entry_sel=-1;
	entry_count++;
	SelectEntry(entry_count-1);

}


//*****************************************************************************
//*
//*		OnDelete
//*
//*****************************************************************************
//	Einen Eintrag aus einem Men lschen
void CExecConfigDlg::OnDelete()
{
int        sel;
CListBox  *lb;



	sel=entry_sel;
	SelectEntry(-1);
	if(sel>=0 && sel<32)
		{
		memmove(entrys+sel,entrys+sel+1,sizeof(entrys[0])*(32-sel));
		}

	lb=(CListBox*)GetDlgItem(IDC_LIST1);
	lb->DeleteString(sel);

	entry_count--;
	if(sel>=entry_count)sel--;
	SelectEntry(sel);

}


//*****************************************************************************
//*
//*		OnEntryDown
//*
//*****************************************************************************
void CExecConfigDlg::OnEntryDown()
{
int        sel;
char	  *mem;
CListBox  *lb;
CString	   text;



	if(entry_sel<0 || entry_sel+1>=entry_count)return;

	sel=entry_sel;
	SelectEntry(-1);

	if(sel<32)
		{
		mem = new char[sizeof(entrys[0])];
		memmove(mem         ,entrys+sel+1,sizeof(entrys[0]));
		memmove(entrys+sel+1,entrys+sel  ,sizeof(entrys[0]));
		memmove(entrys+sel  ,mem         ,sizeof(entrys[0]));
		delete mem;
		}

	lb=(CListBox*)GetDlgItem(IDC_LIST1);
	lb->GetText(sel+1,text);
	lb->DeleteString(sel+1);
	lb->InsertString(sel,text);

	SelectEntry(sel+1);

}

//*****************************************************************************
//*
//*		OnEntryUp
//*
//*****************************************************************************
void CExecConfigDlg::OnEntryUp()
{
int        sel;
char	  *mem;
CListBox  *lb;
CString	   text;



	if(entry_sel<=0)return;

	sel=entry_sel;
	SelectEntry(-1);

	if(sel<32)
		{
		mem = new char[sizeof(entrys[0])];
		memmove(mem         ,entrys+sel-1,sizeof(entrys[0]));
		memmove(entrys+sel-1,entrys+sel  ,sizeof(entrys[0]));
		memmove(entrys+sel  ,mem         ,sizeof(entrys[0]));
		delete mem;
		}

	lb=(CListBox*)GetDlgItem(IDC_LIST1);
	lb->GetText(sel-1,text);
	lb->DeleteString(sel-1);
	lb->InsertString(sel,text);

	SelectEntry(sel-1);

}


//*****************************************************************************
//*
//*		OnPath
//*
//*****************************************************************************
void CExecConfigDlg::OnPath()
{
char	memory[8192];


	UpdateData();
	CFileDialog	dlg(TRUE,"*.exe",m_program,OFN_ALLOWMULTISELECT,"Programme|*.exe;*.com;*.bat|Alle Dateien (*.*)|*.*|");

	strcpy(memory,dlg.m_ofn.lpstrFile);
	dlg.m_ofn.lpstrFile = memory;
	dlg.m_ofn.nMaxFile  = sizeof(memory);

	if(dlg.DoModal()!=IDOK)return;
	m_program=dlg.GetPathName();
	m_shell=0;
	m_command=0;
	UpdateData(FALSE);


}


//*****************************************************************************
//*
//*		OnDir
//*
//*****************************************************************************
void CExecConfigDlg::OnDir()
{
CPathDlg	dlg;


	UpdateData();
	dlg.SetPath(m_directory);
	if(dlg.DoModal()!=IDOK)return;
	m_directory=dlg.GetPath();
	UpdateData(FALSE);

}


//*****************************************************************************
//*
//*		OnParam
//*
//*****************************************************************************
void CExecConfigDlg::OnParam()
{
CMenu	menu;
CPoint	pt;


	pt=GetWindowPt(GetDlgItem(IDC_BUTTON2));

	menu.CreatePopupMenu();

	menu.AppendMenu(MF_STRING,ID_PARAM+0,"Dateiname mit Pfad");
	menu.AppendMenu(MF_STRING,ID_PARAM+1,"Dateiname ohne Pfad");
	menu.AppendMenu(MF_STRING,ID_PARAM+2,"Nur Dateipfad mit '\\'");
	menu.AppendMenu(MF_STRING,ID_PARAM+3,"Nur Dateipfad onhe '\\'");
	menu.AppendMenu(MF_STRING,ID_PARAM+4,"Dateiname ohne Suffix");
	menu.AppendMenu(MF_STRING,ID_PARAM+5,"Suffix des Dateinamens");
	menu.AppendMenu(MF_STRING,ID_PARAM+6,"Byte-Position des Textes");
	menu.AppendMenu(MF_STRING,ID_PARAM+7,"Zeillennummer des Textes");
	menu.AppendMenu(MF_STRING,ID_PARAM+8,"Textlnge");
	menu.AppendMenu(MF_STRING,ID_PARAM+9,"Enviroment Variabel");

	menu.TrackPopupMenu(TPM_LEFTALIGN,pt.x,pt.y,this);
	menu.DestroyMenu();

}


//*****************************************************************************
//*
//*		OnParam
//*
//*****************************************************************************
void CExecConfigDlg::OnStream()
{
CMenu	menu;
CPoint	pt;


	pt=GetWindowPt(GetDlgItem(IDC_BUTTON4));

	menu.CreatePopupMenu();

	menu.AppendMenu(MF_STRING,ID_STREAM+0,"Dateiname mit Pfad");
	menu.AppendMenu(MF_STRING,ID_STREAM+1,"Dateiname ohne Pfad");
	menu.AppendMenu(MF_STRING,ID_STREAM+2,"Nur Dateipfad mit '\\'");
	menu.AppendMenu(MF_STRING,ID_STREAM+3,"Nur Dateipfad onhe '\\'");
	menu.AppendMenu(MF_STRING,ID_STREAM+4,"Dateiname ohne Suffix");
	menu.AppendMenu(MF_STRING,ID_STREAM+5,"Suffix des Dateinamens");
	menu.AppendMenu(MF_STRING,ID_STREAM+6,"Byte-Position des Textes");
	menu.AppendMenu(MF_STRING,ID_STREAM+7,"Zeillennummer des Textes");
	menu.AppendMenu(MF_STRING,ID_STREAM+8,"Textlnge");
	menu.AppendMenu(MF_STRING,ID_STREAM+9,"Enviroment Variabel");

	menu.TrackPopupMenu(TPM_LEFTALIGN,pt.x,pt.y,this);
	menu.DestroyMenu();

}


//*****************************************************************************
//*
//*		OnParamMenu
//*
//*****************************************************************************
void CExecConfigDlg::OnParamMenu(UINT nID)
{
CEdit	*edit;
char	 puffer[256],text[256];
int		 pos,len,pos1;


	nID-=ID_PARAM;
	edit=(CEdit*)GetDlgItem(IDC_EDIT2);



	edit->GetWindowText(puffer,255);puffer[255]=0;
	edit->GetSel(pos,pos1);
	   len=strlen(puffer);
	if(len<pos)pos=len;


	memcpy(text,puffer,pos);

	switch(nID)
			{
	case 0:	strcpy(text+pos,"%p");			break;
	case 1:	strcpy(text+pos,"%f");			break;
	case 2:	strcpy(text+pos,"%d");			break;
	case 3:	strcpy(text+pos,"%D");			break;
	case 4:	strcpy(text+pos,"%b");			break;
	case 5:	strcpy(text+pos,"%e");			break;
	case 6:	strcpy(text+pos,"%o");			break;
	case 7:	strcpy(text+pos,"%l");			break;
	case 8:	strcpy(text+pos,"%s");			break;
	case 9:	strcpy(text+pos,"%()");			break;
			}

	len =strlen(text+pos)+pos;
		 strcpy(text+len,puffer+pos);

	if(nID==5)len--;

	UpdateData(FALSE);
	edit->SetWindowText(text);
	edit->SetFocus();
	edit->SetSel(len,len);

}

//*****************************************************************************
//*
//*		OnStreamMenu
//*
//*****************************************************************************
void CExecConfigDlg::OnStreamMenu(UINT nID)
{
CEdit	*edit;
char	 puffer[256],text[256];
int		 pos,len,pos1;


	nID-=ID_STREAM;
	edit=(CEdit*)GetDlgItem(IDC_EDIT4);



	edit->GetWindowText(puffer,255);puffer[255]=0;
	edit->GetSel(pos,pos1);
	   len=strlen(puffer);
	if(len<pos)pos=len;


	memcpy(text,puffer,pos);

	switch(nID)
			{
	case 0:	strcpy(text+pos,"%p");			break;
	case 1:	strcpy(text+pos,"%f");			break;
	case 2:	strcpy(text+pos,"%d");			break;
	case 3:	strcpy(text+pos,"%D");			break;
	case 4:	strcpy(text+pos,"%b");			break;
	case 5:	strcpy(text+pos,"%e");			break;
	case 6:	strcpy(text+pos,"%o");			break;
	case 7:	strcpy(text+pos,"%l");			break;
	case 8:	strcpy(text+pos,"%s");			break;
	case 9:	strcpy(text+pos,"%()");			break;
			}

	len =strlen(text+pos)+pos;
		 strcpy(text+len,puffer+pos);

	if(nID==5)len--;

	UpdateData(FALSE);
	edit->SetWindowText(text);
	edit->SetFocus();
	edit->SetSel(len,len);

}

//*****************************************************************************
//*
//*		OnOK
//*
//*****************************************************************************
void CExecConfigDlg::OnOK()
{

	GET_DLG_OLDPOS()
	SelectEntry(-1);
	SaveMenu(menu_sel);
	CDialog::OnOK();
}

//*****************************************************************************
//*
//*		OnCancel
//*
//*****************************************************************************
void CExecConfigDlg::OnCancel()
{

	GET_DLG_OLDPOS()
	CDialog::OnCancel();

}


//*****************************************************************************
//*
//*		OnSelChange
//*
//*****************************************************************************
void CExecConfigDlg::OnSelChange()
{

	UpdateData();
	SelectEntry(m_selectentry);
}



//*****************************************************************************
//*
//*		OnInitDialog
//*
//*****************************************************************************
BOOL CExecConfigDlg::OnInitDialog()
{

	SET_DLG_OLDPOS()

	SetButtonBitmap(this,IDC_BUTTON1,IDB_OPEN);
	SetButtonBitmap(this,IDC_BUTTON2,IDB_TYPE);
	SetButtonBitmap(this,IDC_BUTTON3,IDB_OPEN);
	SetButtonBitmap(this,IDC_BUTTON4,IDB_TYPE);


	ScanMenus();

	if(menu_items.Count())
		{
		ScanEntry(0);
		SelectEntry(0);
		}

	OnCheck();

	CDialog::OnInitDialog();


	return TRUE;
}


//*****************************************************************************
//*
//*		OnDestroy
//*
//*****************************************************************************
void CExecConfigDlg::OnDestroy()
{

	DelButtonBitmap(this,IDC_BUTTON1);
	DelButtonBitmap(this,IDC_BUTTON2);
	DelButtonBitmap(this,IDC_BUTTON3);
	DelButtonBitmap(this,IDC_BUTTON4);

	CDialog::OnDestroy();

}

//*****************************************************************************
//*
//*		ScanMenus
//*
//*****************************************************************************
void CExecConfigDlg::ScanMenus()
{
CComboBox		*cb;
CRegKeys		 key;
CString			 text;
int				 x;
char			 name[64];


	menu_sel=-1;
	menu_items.Del();
	cb=(CComboBox*)GetDlgItem(IDC_COMBO1);


	if(!key.Open(0,CRK_READ ))return;
	if(!key.Up(MENU_REG_PATH))return;

	for(x=1;x<32;x++)								// Suche Meneintrge
		{
		sprintf(name,"Menu%i",x);
		if(!key.Up(name))break;
		if(!key.Get(text,"Name"))break;
		if(!key.Down())break;

		menu_items.Add(text);
		text.Remove('&');
		cb->AddString(text);
		}

}

//*****************************************************************************
//*
//*		ScanEntry
//*
//*****************************************************************************
//	Die Eintrge fr das Men Nr einlesen
void CExecConfigDlg::ScanEntry(int Nr)
{
int				 x;
char			 menu[8]="Menu",name[16],mode[64];
CRegKeys		 key;
CListBox	    *lb;
CComboBox		*cb;

	
	if(menu_sel==Nr)return;

	cb=(CComboBox*)GetDlgItem(IDC_COMBO1);
	lb=(CListBox *)GetDlgItem(IDC_LIST1);
	lb->ResetContent();

	menu_sel=Nr;
	m_menuentry=Nr;
	memset(entrys,0,sizeof(entrys));
	cb->SetCurSel(menu_sel);
	entry_count=0;

	itoa(Nr+1,menu+4,10);

	if(!key.Open(0,CRK_READ ))return;
	if(!key.Up(MENU_REG_PATH))return;
	if(!key.Up(menu         ))return;


	for(x=0;x<32;x++)								// Suche Meneintrge
		{
		sprintf(name,"Execute%i",x+1);
		if(!key.Get(entrys[x].m_program,sizeof(entrys[x].m_program),name))break;
		sprintf(name,"Param%i",x+1);
		key.Get(entrys[x].m_parameter,sizeof(entrys[x].m_parameter),name);
		sprintf(name,"Dir%i",x+1);
		key.Get(entrys[x].m_directory,sizeof(entrys[x].m_directory),name);
		sprintf(name,"Stream%i",x+1);
		key.Get(entrys[x].m_outstream,sizeof(entrys[x].m_outstream),name);
		sprintf(name,"ShellMode%i",x+1);mode[0]=0;
		key.Get(mode,sizeof(mode),name);
		sprintf(name,"UsePath%i",x+1);entrys[x].m_usepath=0;
		key.Get(entrys[x].m_usepath,name);
		sprintf(name,"NoWait%i",x+1);entrys[x].m_nowait=0;
		key.Get(entrys[x].m_nowait,name);
		sprintf(name,"Show%i",x+1);entrys[x].m_show=1;
		key.Get(entrys[x].m_show,name);
		sprintf(name,"Command%i",x+1);
		key.Get(entrys[x].m_command,name);

		if(!stricmp(entrys[x].m_program,"COMMAND"))
			{
			entrys[x].m_shell   = 0;
			entrys[x].m_command = 1;
			}

		if(!stricmp(entrys[x].m_program,"SHELL"))
			{
			strcpy(entrys[x].m_program,mode);
			entrys[x].m_shell   = 1;
			entrys[x].m_command = 0;
			}
		
		if(entrys[x].m_command)
			{
			strcpy(entrys[x].m_program,"COMMAND");
			}

		lb->AddString(entrys[x].m_program);
		}

	OnCheck();

	entry_count=x;
	entry_sel=-1;

}

//*****************************************************************************
//*
//*		SelectEntry
//*
//*****************************************************************************
//	Den Eintrag Nr in einem Mne whlen
void CExecConfigDlg::SelectEntry(int Nr)
{
CListBox	*lb;
int			 ok;


	if(entry_sel==Nr)return;

	lb=(CListBox*)GetDlgItem(IDC_LIST1);

	if(entry_sel>=0)
		{
		UpdateData();
		strlcpy(entrys[entry_sel].m_program  ,m_program  ,sizeof(entrys[0].m_program  ));
		strlcpy(entrys[entry_sel].m_parameter,m_parameter,sizeof(entrys[0].m_parameter));
		strlcpy(entrys[entry_sel].m_directory,m_directory,sizeof(entrys[0].m_directory));
		strlcpy(entrys[entry_sel].m_outstream,m_outstream,sizeof(entrys[0].m_outstream));
		entrys[entry_sel].m_usepath = m_usepath;
		entrys[entry_sel].m_command = m_command;
		entrys[entry_sel].m_nowait  = m_nowait;
		entrys[entry_sel].m_show    = m_show;
		entrys[entry_sel].m_shell   = m_shell;

		if(m_program!="" || m_shell)
			{
			lb->DeleteString(entry_sel);
			lb->InsertString(entry_sel,(m_shell)? "SHELL":m_program);
			}
		
		if(m_command && m_program!="COMMAND")
			{
			lb->DeleteString(entry_sel);
			lb->InsertString(entry_sel,"COMMAND");
			}
		}

	entry_sel=Nr;

	if(entry_sel>=0)
		{
		m_program   = entrys[entry_sel].m_program;
		m_parameter = entrys[entry_sel].m_parameter;
		m_directory = entrys[entry_sel].m_directory;
		m_outstream	= entrys[entry_sel].m_outstream;
		m_usepath	= entrys[entry_sel].m_usepath;
		m_command	= entrys[entry_sel].m_command;
		m_nowait    = entrys[entry_sel].m_nowait;
		m_show      = entrys[entry_sel].m_show;
		m_shell     = entrys[entry_sel].m_shell;

		if(m_shell  )m_command=0;
		if(m_command)m_program=_T("COMMAND");

		UpdateData(FALSE);
		lb->SetCurSel(entry_sel);
		m_selectentry=entry_sel;
		}
	else{
		m_selectentry=-1;
		m_shell     = FALSE;
		m_nowait    = FALSE;
		m_usepath	= FALSE;
		m_command	= FALSE;
		m_program   = _T("");
		m_parameter = _T("");
		m_directory = _T("");
		m_outstream	= _T("");
		m_show      = 1;
		UpdateData(FALSE);
		}

	ok = entry_count && m_selectentry>=0;

	EnableDlgItem(IDC_BUTTON1	, ok );
	EnableDlgItem(IDC_BUTTON2	, ok );
	EnableDlgItem(IDC_BUTTON3	, ok );
	EnableDlgItem(IDC_BUTTON4	, ok );
	EnableDlgItem(IDC_DELETE	, ok );
	EnableDlgItem(IDC_ENTRYUP	, ok );
	EnableDlgItem(IDC_ENTRYDOWN	, ok );
	EnableDlgItem(IDC_CHECK1	, ok );
	EnableDlgItem(IDC_CHECK2	, ok );
	EnableDlgItem(IDC_CHECK3	, ok );
	EnableDlgItem(IDC_EDIT1 	, ok );
	EnableDlgItem(IDC_EDIT2 	, ok );
	EnableDlgItem(IDC_EDIT3 	, ok );
	EnableDlgItem(IDC_EDIT4 	, ok );
	EnableDlgItem(IDC_LIST1 	, ok );
	EnableDlgItem(IDC_RADIO1	, ok );
	EnableDlgItem(IDC_RADIO2	, ok );
	EnableDlgItem(IDC_RADIO3	, ok );
	EnableDlgItem(IDC_RADIO4	, ok );


}



//*****************************************************************************
//*
//*		OnSelChangeCombo
//*
//*****************************************************************************
//	Ein anderes Men wurde gewhlt
void CExecConfigDlg::OnSelChangeCombo()
{

	UpdateData();
	if(m_menuentry==menu_sel)return;

	SelectEntry(-1);
	SaveMenu(menu_sel);

	if(menu_items.Count())
		{
		ScanEntry(m_menuentry);
		SelectEntry(0);
		menu_sel=m_menuentry;
		}

	OnCheck();

}

//*****************************************************************************
//*
//*		OnCheck
//*
//*****************************************************************************
void CExecConfigDlg::OnCheck()
{

	UpdateData();

	if(m_command)
		{
		m_program = "COMMAND";
		SetDlgItemText(IDC_EDIT1,"COMMAND");
		}

	GetDlgItem(IDC_EDIT1)->EnableWindow(!m_command);
	GetDlgItem(IDC_EDIT4)->EnableWindow(!m_command);


}

//*****************************************************************************
//*
//*		DelMenu
//*
//*****************************************************************************
//	Das Men Nr aus der Registry lschen
void CExecConfigDlg::DelMenu(int Nr)
{
char		menu[8]="Menu";
CRegKeys	key;


	if(Nr<0)return;

	itoa(Nr+1,menu+4,10);

	if(!key.Open(0,CRK_CREATE))return;
	if(!key.Up(MENU_REG_PATH ))return;
		key.DelKey(menu);

}

//*****************************************************************************
//*
//*		SaveMenu
//*
//*****************************************************************************
//	Das Men Nr in der Registry speichern
void CExecConfigDlg::SaveMenu(int Nr)
{
int				 x;
char			 menu[8]="Menu",name[16];
CRegKeys		 key;


	if(menu_sel<0)return;

	DelMenu(Nr);

	itoa(Nr+1,menu+4,10);

	if(!key.Open(0,CRK_CREATE))return;
	if(!key.Up(MENU_REG_PATH ))return;
	if(!key.Up(menu          ))return;
	if(!key.Set(menu_items[menu_sel],"Name"))return;

	for(x=0;x<entry_count;x++)						// Suche Meneintrge
		{
		sprintf(name,"Execute%i",x+1);

		if(entrys[x].m_shell)
			{
			key.Set("SHELL",name);
			sprintf(name,"ShellMode%i",x+1);
			}

		key.Set(entrys[x].m_program,name);
		sprintf(name,"Param%i",x+1);
		key.Set(entrys[x].m_parameter,name);
		sprintf(name,"Dir%i",x+1);
		key.Set(entrys[x].m_directory,name);
		sprintf(name,"Stream%i",x+1);
		key.Set(entrys[x].m_outstream,name);
		sprintf(name,"UsePath%i",x+1);
		key.Set(entrys[x].m_usepath,name);
		sprintf(name,"NoWait%i",x+1);
		key.Set(entrys[x].m_nowait,name);
		sprintf(name,"Show%i",x+1);
		key.Set(entrys[x].m_show,name);
		sprintf(name,"Command%i",x+1);
		key.Set(entrys[x].m_command,name);
		}

}

