//*****************************************************************************
//*
//*
//*		FindSameDlg.cpp: Implementierungsdatei
//*
//*
//*****************************************************************************
#include "StdAfx.h"
#include "DataFinder.h"
#include "FindSameDlg.h"

#ifdef		_DEBUG
#define new	 DEBUG_NEW
#undef		 THIS_FILE
static char	 THIS_FILE[] = __FILE__;
#endif



BEGIN_MESSAGE_MAP(CFindSameDlg, CDialog)
	//{{AFX_MSG_MAP(CFindSameDlg)
	ON_BN_CLICKED(IDC_DELETE1, OnDelete1)
	ON_BN_CLICKED(IDC_DELETE2, OnDelete2)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

DLG_OLDPOS(CFindSameDlg)


#define 	ID_OKON		0x1953
#define 	ID_ENDDLG	0x1954
#define 	ID_SETPOS	0x1955
#define 	ID_SETTEXT	0x1956
#define 	ID_SETNAME	0x1957
#define 	ID_SETICON	0x1958
#define 	ID_ERROR	0x1959

//*****************************************************************************
//*
//*		Konstruktor
//*
//*****************************************************************************
CFindSameDlg::CFindSameDlg(CWnd *pParent)
	: CDialog(CFindSameDlg::IDD,pParent)
{
	//{{AFX_DATA_INIT(CFindSameDlg)
	//}}AFX_DATA_INIT

	files.DataLength(sizeof(int));
}



//*****************************************************************************
//*
//*		DoDataExchange
//*
//*****************************************************************************
void CFindSameDlg::DoDataExchange(CDataExchange *pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CFindSameDlg)
	//}}AFX_DATA_MAP
}


//*****************************************************************************
//*
//*		OnInitDialog
//*
//*****************************************************************************
BOOL CFindSameDlg::OnInitDialog()
{
int		x,len;
HFONT	font;
CRect	rect;
CWnd   *wnd;


	SET_DLG_OLDPOS()

	wnd = GetDlgItem(IDC_FILE1);
	wnd->GetClientRect(&rect);

	max_x = rect.Width()-3;

	font = (HFONT)wnd->SendMessage(WM_GETFONT,0,0);
	if(font)GetCharWidths(csize,font);
	else	GetCharWidths(csize);
	

	if(files.Count()<=0)
		{
		MessageBox("Es sind keine Dateien ausgewhlt !","Fehler");
		EndDialog(IDCANCEL);
		return FALSE;
		}

	CDialog::OnInitDialog();

	for(x=0;x<files.Count();x++)				// Hole Datei lngen
		{
		   len=files.DataGet(x);
		if(len>=0)continue;

		   len=LengthFile(files[x]);
		if(len<0){files.Del(x);continue;}

		files.DataSet(x,len);
		}

	image.Attach(GetIconList(1));

	EnableDlgItem(IDOK,0);
	EnableDlgItem(IDC_DELETE1,0);
	EnableDlgItem(IDC_DELETE2,0);

	GetDlgProgressCtrl(IDC_PROGRESS1)->SetRange(0,files.Count());

	find_count=0;
	exit_code=0;
	exit=0;
	next=0;
	files.Sort(0,-1,CSC_SORT_INT);
	AfxBeginThread(ThreadProc,this);

	return TRUE;
}


//*****************************************************************************
//*
//*		GetFileInfo
//*
//*****************************************************************************
void CFindSameDlg::GetFileInfo(LPCSTR File, LPSTR Info)
{
_finddata_t	find;
int			f,x;

	x=strlcpy(Info,"Zuletzt gendert: ",128);

	f=_findfirst(File,&find);
	if(f==-1)
		{
		strcpy(Info+x,"---");
		return;
		}

	_findclose(f);
	strtimeset(Info+x,find.time_write,STR_ALL);

	if(find.time_create!=(int)-1)
		{
		x=strlcat(Info,"   erstellt am: ",128);
		strtimeset(Info+x,find.time_create,STR_ALL);
		}


}

//*****************************************************************************
//*
//*		AddFile
//*
//*****************************************************************************
//	Fgt eine Datei in die liste ein
//	Size	: Ist die Gre der Datei (-1 wenn unbekannt)
//	Ergibt die Anzahl der eingefgten Dateien
int CFindSameDlg::AddFile(LPCSTR File,int Size)
{

	files.Add(File,CSC_END,&Size);

return files.Count();
}

//*****************************************************************************
//*
//*		OnDelete1
//*
//*****************************************************************************
void CFindSameDlg::OnDelete1()
{
	next=2;
	EnableDlgItem(IDOK,0);
	EnableDlgItem(IDC_DELETE1,0);
	EnableDlgItem(IDC_DELETE2,0);
}


//*****************************************************************************
//*
//*		OnDelete2
//*
//*****************************************************************************
void CFindSameDlg::OnDelete2()
{
	next=3;
	EnableDlgItem(IDOK,0);
	EnableDlgItem(IDC_DELETE1,0);
	EnableDlgItem(IDC_DELETE2,0);

}


//*****************************************************************************
//*
//*		OnOK
//*
//*****************************************************************************
void CFindSameDlg::OnOK()
{

	GET_DLG_OLDPOS()
	next=1;
	EnableDlgItem(IDOK,0);
	EnableDlgItem(IDC_DELETE1,0);
	EnableDlgItem(IDC_DELETE2,0);
}


//*****************************************************************************
//*
//*		OnCancel
//*
//*****************************************************************************
void CFindSameDlg::OnCancel()
{

	GET_DLG_OLDPOS()
	exit=2;
	EnableDlgItem(IDCANCEL,0);

}


//*****************************************************************************
//*
//*		ThreadProc
//*
//*****************************************************************************
UINT _cdecl CFindSameDlg::ThreadProc(void *Param){return ((CFindSameDlg*)Param)->ThreadProc();}
UINT        CFindSameDlg::ThreadProc()
{
CMapFile	mem1,mem2;
int			pos1,pos2;
int			len1,len2;
int			x,xchg,add=0;
char	   *ptr1,*ptr2;
static char info1[128]="";
static char info2[128]="";
static char info [128]="";;



	for(pos1=0;pos1<files.Count();pos1++)
		{
		if(exit)break;

		    ptr1=mem1.Open(files[pos1]);
		if(!ptr1){pos1++;continue;}

		   len1=files.DataGet(pos1);
		if(len1!=mem1.GetLength()){pos1++;continue;}

		sprintf(info,"Datei %i von %i",pos1+1+add,files.Count()+add);
		PostMessage(WM_COMMAND,ID_SETTEXT|(IDC_TEXT<<16),(int)info);

		for(pos2=pos1+1;pos2<files.Count();pos2++)
			{
			if(exit)break;

			   len2=files.DataGet(pos2);
			if(len2!=len1)break;

				ptr2=mem2.Open(files[pos2]);
			if(!ptr2)continue;
			if( len2!=mem2.GetLength())pos2++;
			if( memcmp(ptr1,ptr2,len1))continue;

			GetFileInfo(files[pos1],info1);
			GetFileInfo(files[pos2],info2);

			xchg = CmpFileNameN(files[pos1],files[pos2]);

			PostMessage(WM_COMMAND,ID_SETNAME|(IDC_FILE1<<16),(LPARAM)((xchg<0)? files[pos1]:files[pos2]));
			PostMessage(WM_COMMAND,ID_SETNAME|(IDC_FILE2<<16),(LPARAM)((xchg<0)? files[pos2]:files[pos1]));
			PostMessage(WM_COMMAND,ID_SETTEXT|(IDC_INFO1<<16),(LPARAM)((xchg<0)? info1:info2));
			PostMessage(WM_COMMAND,ID_SETTEXT|(IDC_INFO2<<16),(LPARAM)((xchg<0)? info2:info1));

			find_count++;
			x=GetLargeIcon((xchg<0)? files[pos1]:files[pos2]);
			PostMessage(WM_COMMAND,ID_SETICON|(IDC_ICON1<<16),x);
			x=GetLargeIcon((xchg<0)? files[pos2]:files[pos1]);
			PostMessage(WM_COMMAND,ID_SETICON|(IDC_ICON2<<16),x);
			next=0;
			PostMessage(WM_COMMAND,ID_OKON);


			while(!next && !exit)Sleep(100);

			if((next==2 && xchg<0) || (next==3 && xchg>=0))	// Lsche Datei 1
				{
				mem1.Close();
				if(!RemoveFile(files[pos1]))
					{
					PostMessage(WM_COMMAND,ID_ERROR,(int)"Fehler beim Lschen");
					while(!next)Sleep(100);
					}
				files.Del(pos1);
				pos1--;
				add++;
				break;
				}

			if((next==3 && xchg<0) || (next==2 && xchg>=0))	// Lsche Datei 1
				{
				mem2.Close();
				if(!RemoveFile(files[pos2]))
					{
					PostMessage(WM_COMMAND,ID_ERROR,(int)"Fehler beim Lschen");
					while(!next)Sleep(100);
					}
				files.Del(pos2);
				pos2--;
				add++;
				}
			}


		PostMessage(WM_COMMAND,ID_SETPOS,pos1+1);
		}

	if(!exit)exit=1;
	PostMessage(WM_COMMAND,ID_ENDDLG);

return 0;
}


//*****************************************************************************
//*
//*		OnCommand
//*
//*****************************************************************************
BOOL CFindSameDlg::OnCommand(WPARAM wParam, LPARAM lParam)
{

	if(wParam==ID_OKON)
		{
		if(exit!=2 && !find_count)MessageBox("Es wurden keine gleichen Dateien gefunden.","Meldung");
		EnableDlgItem(IDC_DELETE1,1);
		EnableDlgItem(IDC_DELETE2,1);
		EnableDlgItem(IDOK,1);
		return TRUE;
		}

	if(wParam==ID_ERROR)
		{
		if(MessageBox((char*)lParam,"Fehler",MB_OKCANCEL|MB_ICONERROR)==IDCANCEL)exit=1;
		next=1;
		return TRUE;
		}

	if(wParam==ID_SETPOS)
		{
		GetDlgProgressCtrl(IDC_PROGRESS1)->SetPos(lParam);
		return TRUE;
		}

	if(wParam==ID_ENDDLG)
		{
		files.Del();
		image.Detach();
		EndDialog(exit_code);
		return TRUE;
		}

	if((wParam&0xFFFF)==ID_SETTEXT)
		{
		SetDlgItemText(wParam>>16,(char*)lParam);
		return TRUE;
		}

	if((wParam&0xFFFF)==ID_SETNAME)
		{
		char	temp[512];
		CommpressFileName((char*)lParam,temp,sizeof(temp),max_x,csize);
		SetDlgItemText(wParam>>16,temp);
		return TRUE;
		}

	if((wParam&0xFFFF)==ID_SETICON)
		{
		CStatic	*cs;
		HICON	 icon;
		icon=image.ExtractIcon(lParam);
		cs=GetDlgStatic(wParam>>16);
		cs->SetIcon(icon);
		return TRUE;
		}

	return CDialog::OnCommand(wParam,lParam);
}


