//*****************************************************************************
//*
//*
//*		DIALOGFELD FR TEXT SUCHEN
//*
//*
//*****************************************************************************
#if !defined(AFX_HEXDLG_H__85678888_F5DA_1451_9231_174553540044__INCLUDED_)
#define      AFX_HEXDLG_H__85678888_F5DA_1451_9231_174553540044__INCLUDED_


#if				_MSC_VER >= 1000
#pragma once
#endif		//  _MSC_VER >= 1000


#include	"Resource.h"

//*****************************************************************************
//*
//*		Globale Funktionen
//*
//*****************************************************************************

char   *ChainStr    (char **Kette,int Nr);
int		ChainFind	(char **Kette,char *Str);
int		ChainLength (char **Kette);
int		ChainCount  (char **Kette);
int		ChainInsert (char **Kette,char *Str,int Nr);
int		ChainDelete (char **Kette,int Nr);
void	ChainClear  (char **Kette);

int		StrMode (const char *Str);
int		StrToBin(const char *Str ,void *Mem,int   Len);
int		BinToStr(const void *Mem ,int   Len,char *Str,int Art=4);

//*****************************************************************************
//*
//*		Klasse fr Suchen-Dialog
//*
//*****************************************************************************
class CHexFindDlg : public CDialog
{
public:


#define		HEX_FIND_UPWARDS	0x0001	// Bei Suche nach oben suchen
#define		HEX_FIND_IN_SEL		0x0002	// Bei Suche nach oben suchen
#define		HEX_FIND_IN_ALL		0x0004	// Die ganzer Datei durchsuchen
#define		HEX_FIND_NO_CASE	0x0008	// Gro-Kleinschreibung ignorieren
#define		HEX_FIND_GROUP		0x0010	// Suche nach einer Gruppe
#define		HEX_FIND_IN_ORDER	0x0020	// Bei Gruppen-Suche Reihenfolge beachten
#define		HEX_FIND_BEGIN		0x0040	// Bei Gruppen-Suche Reihenfolge beachten
#define 	HEX_FIND_UNICODE	0x0080	// Text als Unicode suchen
#define 	HEX_FIND_BIGENDIAN  0x0100	// Zahlen ins Modorola Format umwandeln
#define		HEX_FIND_SELLECTED  0x8000	// Ein Bereich ist Makiert


#define		SUCHEN_MAX	16				// Maximale Zahl der Suchen  Eintrge
#define		GRUPPE_MAX	16				// Maximale Zahl der Gruppen Eintrge

	int			variabel_art;			// Variabel art
static int		variabel_alt;			// Variabel alt
	int			eingabe_art;			// Eingabe  art
	int			auf;					// Aufwrts/abwrts suchen
	int			grosklein;				// Gros/Kleinschreibung ignorieren
	int			alles;					// Den ganzen Text durchsuchen
	int			unicode;				// Unicode Text suchen
	int			bigendian;				// Zahlen ins Modoroa Format umwandeln
	int			marke;					// Den markierten Bereich durchsuchen
	int			marke_ein;				// Ist Marke eingeschaltet
	int			anfang;					// Von Anfang an suchen
	int			analyse;				// Den Text im Suchenfeld analysieren
	int			gruppe_ein;				// Gruppen Suche ein
	int			gruppe_alt; 			// Gruppen Suche alter Wert
	int			gruppe_len;		    	// Gruppen Suche ein
	int			gruppe_reihe;			// Gruppen Suche ein
	int			text_len;				// Lnge des Texte im Suchen Feld
	int			exit;					// Exit-Flags
	char	   *text;					// Anfangs Text

static	int		x_pos,y_pos;			// Fenster Position

	char      **suchen_str;				// Suche Texte
	char      **gruppe_str;				// Gruppen-Suche Texte
	char      **ergebnis;				// Ergebnis-Kette

	//{{AFX_DATA(CTextFindDlg)
	enum { IDD = IDD_HEX_FIND };		// Dialog ID-Nummer
	//}}AFX_DATA(CTextFindDlg)

			CHexFindDlg(CWnd *pParent = NULL);
   	INT_PTR	DoModal      (int  *Flags,char **Suchen_str,
									  char **Gruppe_str,
									  char **Ergebnis,
									  char	*Text=0);

protected:

	void	AddFindText();
	void	StringMode(char *Str,int Max);
	void	EndDialog(int   Wert);


	//{{AFX_VIRTUAL(CHexFindDlg)
	virtual void OnOK();
	virtual void OnCancel();
	virtual BOOL OnInitDialog();
	virtual void DoDataExchange(CDataExchange *pDX);
	afx_msg void OnFind();
	afx_msg void OnNext();
	afx_msg void Eingabe();
	afx_msg void OnInputCheck();
	afx_msg void OnInputConvert();
	afx_msg void OnGroupInsert();
	afx_msg void OnGroupDelete();
	afx_msg void OnGroupClearAll();
	afx_msg void GruppeHolen();
	afx_msg void OnGroupUp();
	afx_msg void OnGroupDown();
	//}}AFX_VIRTUAL

protected:

	//{{AFX_MSG(CHexFindDlg)
	//}}AFX_MSG

	DECLARE_MESSAGE_MAP()
	DECLARE_DLG_OLDPOS()

};


#endif
