//*****************************************************************************
//*
//*
//*		Html.cpp
//*
//*
//*****************************************************************************
#include	"StdAfx.h"
#include	"Html.h"

extern CTextBuffer	hhk_file;
extern CTextBuffer	hhc_file;
extern CTextBuffer	hhp_file;
extern CTextBuffer	htm_file;
extern CTextBuffer	rtf_file;
extern char			html_path[];

static char html_header[]=
	{
	"<!DOCTYPE HTML>\n"
	"<HTML>\n"
	"<HEAD>\n"
	"<META HTTP-EQUIV=\"Content-Type\" Content=\"text/html; charset=Windows-1252\">\n"
	"<STYLE>\n"
	"\t\tTD {font-size: x-small; }\n"
	"</STYLE>\n"
	"<TITLE>%s</TITLE>\n"
	"</HEAD>\n"
	"<BODY>\n"
	"<FONT face=\"verdana,arial,helvetica\" size=\"2\">\n"
	};

static char html_tail[]=
	{
	"</FONT>\n"
	"</BODY>\n"
	"</HEAD>\n"
	};

static char hhk_header[]=
	{
	"<HTML>\n"
	"<!-- Sitemap 1.0 -->\n"
	"<OBJECT type=\"text/site properties\">\n"
	"</OBJECT>\n"
	"<UL>\n"
	};

static char hhk_tail[]=
	{
	"</UL>\n"
	"</HTML>\n"
	};

static char hhc_header[]=
	{
	"<!DOCTYPE HTML PUBLIC \"-//IETF//DTD HTML//GE\">\n"
	"<HTML>\n"
	"<HEAD>\n"
	"<meta name=\"GENERATOR\" content=\"Microsoft&reg; HTML Help Workshop 4.1\">\n"
	"<!-- Sitemap 1.0 -->\n"
	"</HEAD>\n"
	"<BODY>\n"
		//"<UL>\n"
		//"\t<LI> <OBJECT type=\"text/sitemap\">\n"
		//"\t\t<param name=\"Name\" value=\"%s\">\n"
		//"\t\t</OBJECT>\n"
	"\t<UL>\n"
	};

static char hhc_tail[]=
	{
		//"\t\t</UL>\n"
	"\t</UL>\n"
	"</UL>\n"
	"</BODY>\n"
	};

static char hhp_header[]=
	{
	"[OPTIONS]\n"
	"Binary TOC=Yes\n"
	"Create CHI file=No\n"
	"Compatibility=1.1 or later\n"
	"Compiled file=%s.chm\n"
	"Contents file=%s.hhc\n"
	"Default Font=MS Sans Serif,9,0\n"
	"Default topic=%s\\%s.html\n"
	"Display compile progress=No\n"
	"Full-text search=Yes\n"
	"Index file=%s.hhk\n"
	"Language=0x407 Deutsch (Standard)\n"
	"Title=%s\n\n\n"
	"[FILES]\n"
	};

static char hhp_tail[]=
	{
	"\n\n[INFOTYPES]\n"
	};

extern int		multi_space;
static int		zeilen_len	= 0;
static char		last_char	= 0;

//*****************************************************************************
//*
//*		CreateHtml
//*
//*****************************************************************************
int CreateHtml(const char *Base,const char *Add,const char *Title)
{
char		buffer[MAX_PATH];
int			len;
static int	nr=0;
	last_char	= 0;
	zeilen_len	= 0;

	len 		= strlcpy(buffer,Base,sizeof(buffer));
	sprintf(buffer+len,"%s.html",Add);

	if(!htm_file.Open(buffer,CFB_CREATE))
		{
		printf("\n\nKann Datei '%s' nicht erzeugen.\n\n",buffer);
		exit(-1);
		}

	if(!Title || !Title)Title=Add;

	htm_file.WriteFormat(html_header,Title);
	printf("\n%s",buffer);
	hhp_file.WriteFormat("%s/%s.html\n",html_path,Add);

return 0;
}



//*****************************************************************************
//*
//*		CloseHtml
//*
//*****************************************************************************
int CloseHtml()
{

	htm_file.Write(html_tail);
	htm_file.Close();

return 1;
}

//*****************************************************************************
//*
//*		HtmlSetLast
//*
//*****************************************************************************
void HtmlSetLast(char Zeichen)
{
	last_char=Zeichen;
}

//*****************************************************************************
//*
//*		HtmlGetLast
//*
//*****************************************************************************
int HtmlGetLast()
{

return last_char;
}


//*****************************************************************************
//*
//*		WriteHtml
//*
//*****************************************************************************
int WriteHtml(char Zeichen)
{
char		puffer[16];
int			y;



	if(Zeichen==' ' && last_char==' ')
		{
		if(multi_space)
			{
			htm_file.Write("&#160;");
			last_char=0;
			}

		return 1;
		}

	last_char=Zeichen;

	if(zeilen_len>70 && Zeichen <=' ' && Zeichen>=0)
		{
		htm_file.Write("\n",1);
		zeilen_len=0;
		}

	switch(Zeichen)
		{
	case '\t':	y=htm_file.Write("&nbsp;&nbsp;&nbsp;&nbsp;",24)==24;zeilen_len+=24;break;
	case '<' :	y=htm_file.Write("&lt;"	  ,4)==4;	zeilen_len+=4;break;
	case '>' :	y=htm_file.Write("&gt;"	  ,4)==4;	zeilen_len+=4;break;
	case '&' :	y=htm_file.Write("&amp;"  ,5)==5;	zeilen_len+=5;break;
	case '"' :	y=htm_file.Write("&quot;" ,6)==6;	zeilen_len+=6;break;
	case '' :	y=htm_file.Write("&Auml;" ,6)==6;	zeilen_len+=6;break;
	case '' :	y=htm_file.Write("&Ouml;" ,6)==6;	zeilen_len+=6;break;
	case '' :	y=htm_file.Write("&Uuml;" ,6)==6;	zeilen_len+=6;break;
	case '' :	y=htm_file.Write("&auml;" ,6)==6;	zeilen_len+=6;break;
	case '' :	y=htm_file.Write("&ouml;" ,6)==6;	zeilen_len+=6;break;
	case '' :	y=htm_file.Write("&uuml;" ,6)==6;	zeilen_len+=6;break;
	case '' :	y=htm_file.Write("&szlig;",7)==7;	zeilen_len+=7;break;
	default	 :	if(Zeichen<' ')
			{
			sprintf(puffer,"&#%i",Zeichen&0xFF);
			y			= htm_file.Write(puffer,4)==4;
			zeilen_len += 4;
			break;
			}

		y=htm_file.Write(&Zeichen,1)==1;
		zeilen_len++;
		}


return y;
}



//*****************************************************************************
//*
//*		WriteHtml
//*
//*****************************************************************************
int WriteHtml(char *String)
{
int			y=0;


	while(*String)
		{
		WriteHtml(*String);
		String++;
		y++;
		}


return y;
}


//*****************************************************************************
//*
//*		CreateHhk
//*
//*****************************************************************************
int CreateHhk(const char *Base,const char *Name,const char *Lib)
{
char		buffer[MAX_PATH];
int			len;
static int	nr=0;



	len=strlcpy(buffer,Base,sizeof(buffer));
	sprintf(buffer+len,"%s",Name);
	SetFileType(buffer,"hhk");


	if(!hhk_file.Open(buffer,CFB_CREATE))
		{
		printf("\n\nKann Datei '%s' nicht erzeugen.\n\n",buffer);
		exit(-1);
		}

	SetFileType(buffer,"hhc");

	if(!hhc_file.Open(buffer,CFB_CREATE))
		{
		printf("\n\nKann Datei '%s' nicht erzeugen.\n\n",buffer);
		exit(-1);
		}

	SetFileType(buffer,"hhp");

	if(!hhp_file.Open(buffer,CFB_CREATE))
		{
		printf("\n\nKann Datei '%s' nicht erzeugen.\n\n",buffer);
		exit(-1);
		}


	hhk_file.Write(hhk_header);
	hhc_file.WriteFormat(hhc_header,Lib);

	strcpy(buffer,Name);
	SetFileType(buffer,"");

	hhp_file.WriteFormat(hhp_header,buffer,buffer,html_path,buffer,buffer,buffer);


return 0;
}


//*****************************************************************************
//*
//*		CloseHhk
//*
//*****************************************************************************
int CloseHhk()
{

	hhk_file.Write(hhk_tail);
	hhk_file.Close();
	hhc_file.Write(hhc_tail);
	hhc_file.Close();
	hhp_file.Write(hhp_tail);
	hhp_file.Close();

return 1;
}


//*****************************************************************************
//*
//*		WriteHhk
//*
//*****************************************************************************
int WriteHhk(const char *Name,const char *File,const char *Key)
{
static int	first=0;

	if(!Key)
		{
			Key=strstr(Name,"::");
		if(!Key)Key=Name;
		else Key+=2;
		}

	if(!first)
		{
		first=1;
		hhc_file.Write("\t<UL>\n");
		hhc_file.Write("\t\t<LI> <OBJECT type=\"text/sitemap\">\n");
		hhc_file.WriteFormat("\t\t\t<param name=\"Name\" value=\"%s\">\n",Name);
		hhc_file.Write("\t\t\t</OBJECT>\n");
		}

	hhc_file.Write("\t\t\t<LI> <OBJECT type=\"text/sitemap\">\n");
	hhc_file.WriteFormat("\t\t\t\t<param name=\"Name\"	  value=\"%s\">\n",Name);
	hhc_file.WriteFormat("\t\t\t\t<param name=\"Local\"	  value=\"%s/%s.html\">\n",html_path,File);
	hhc_file.Write("\t\t\t\t</OBJECT>\n");

	if(strstr(Key," "))return 0;

	hhk_file.Write("\t<LI> <OBJECT type=\"text/sitemap\">\n");
	hhk_file.WriteFormat("\t\t<param name=\"Keyword\" value=\"%s\">\n",Key);
	hhk_file.WriteFormat("\t\t<param name=\"Name\"	  value=\"%s\">\n",Name);
	hhk_file.WriteFormat("\t\t<param name=\"Local\"	  value=\"%s/%s.html\">\n",html_path,File);
	hhk_file.Write("\t\t</OBJECT>\n");

return 1;
}
