//*****************************************************************************
//*
//*
//*		LinesDlg.cpp
//*
//*
//*****************************************************************************
#include	"StdAfx.h"
#include	"DataFinder.h"
#include	"TextFind.h"
#include	"LinesDlg.h"

#ifdef		_DEBUG
#define new	 DEBUG_NEW
#undef		 THIS_FILE
static char	 THIS_FILE[] = __FILE__;
#endif

#define 	 ID_SETPOS	0x6283
#define 	 ID_ERROR	0x6284

BEGIN_MESSAGE_MAP(CLinesDlg, CDialog)
	//{{AFX_MSG_MAP(CLinesDlg)
	ON_COMMAND(ID_SETPOS,	OnSetProgress)
	ON_COMMAND(ID_ERROR,	OnError)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()


DLG_OLDPOS(CLinesDlg)


//*****************************************************************************
//*
//*		CDialog
//*
//*****************************************************************************
//  CLinesDlg Dialog
CLinesDlg::CLinesDlg(CWnd *pParent): CDialog(CLinesDlg::IDD,pParent)
{
	//{{AFX_DATA_INIT(CLinesDlg)
	//}}AFX_DATA_INIT

	m_bDelete = FALSE;
}


//*****************************************************************************
//*
//*		DoDataExchange
//*
//*****************************************************************************
void CLinesDlg::DoDataExchange(CDataExchange *pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CLinesDlg)
	//}}AFX_DATA_MAP
}


//*****************************************************************************
//*
//*		OnInitDialog
//*
//*****************************************************************************
//  CLinesDlg message handlers
BOOL CLinesDlg::OnInitDialog()
{
CString		sText;
CRegKeys	sKey;
int			iVal;


	SET_DLG_OLDPOS()

	m_cSuffix[0] = 0;
	m_bRunning	 = FALSE;
	m_bDone		 = FALSE;
	m_bStop		 = FALSE;


	if(m_bDelete)
		{
		SetDlgItemText(IDC_TEXT1,"Offset der Zeile : (0=aktuelle Zeile)");
		EnableDlgItem (IDC_EDIT3,FALSE);

		if(sKey.Open(0,CRK_READ))
		if(sKey.Up("ZipDialog"))
			{
			if(sKey.Get(iVal ,"DelPos"  ))SetDlgItemInt (IDC_EDIT1,iVal,TRUE);
			if(sKey.Get(iVal ,"DelCount"))SetDlgItemInt (IDC_EDIT2,iVal,TRUE);
			if(sKey.Get(sText,"Suffix"  ))SetDlgItemText(IDC_EDIT4,sText);
			}
		}
	else{
		EnableDlgItem (IDC_EDIT2,FALSE);

		if(sKey.Open(0,CRK_READ))
		if(sKey.Up("ZipDialog"))
			{
			if(sKey.Get(iVal ,"AddPos"  ))SetDlgItemInt (IDC_EDIT1,iVal,TRUE);
			if(sKey.Get(sText,"AddLines"))SetDlgItemText(IDC_EDIT3,sText);
			if(sKey.Get(sText,"Suffix"  ))SetDlgItemText(IDC_EDIT4,sText);
			}
		}


	CDialog::OnInitDialog();


	return TRUE;
				
}

//*****************************************************************************
//*
//*		OnSetProgress
//*
//*****************************************************************************
void CLinesDlg::OnSetProgress()
{
const char *pPath;

	
	if(m_iCurPos<m_pList->Count())
		{
			pPath = m_pList->GetFileName(m_iCurPos);
		if(!pPath)pPath="";
			{
			pPath = GetFileName(pPath);
			SetDlgItemText(IDC_TEXT2,pPath);
			}
		}


	GetDlgProgressCtrl(IDC_PROGRESS1)->SetPos(m_iCurPos);
}

//*****************************************************************************
//*
//*		OnError
//*
//*****************************************************************************
void CLinesDlg::OnError()
{
int		iRet;


	iRet = MessageBox(m_sError,"Fehler",MB_OKCANCEL|MB_ICONERROR);
	if(iRet==IDCANCEL)m_bStop=TRUE;

	m_bResult = 1;
	
}

//*****************************************************************************
//*
//*		OnCancel
//*
//*****************************************************************************
void CLinesDlg::OnCancel()
{

	if(m_bRunning)
		{
		EnableDlgItem(IDCANCEL,FALSE);
		m_bStop = TRUE;
		return;
		}

	GET_DLG_OLDPOS()

	CDialog::OnCancel();
}

//*****************************************************************************
//*
//*		OnOK
//*
//*****************************************************************************
void CLinesDlg::OnOK()
{
CString		sText;
CRegKeys	sKey;



	if(m_bRunning)
		{
		return;
		}

	if(m_bDone)
		{
		GET_DLG_OLDPOS();
		CDialog::OnOK();
		return;
		}


	GetDlgItemText(IDC_EDIT1,sText);	
	m_iStart = strtoi(sText);
	GetDlgItemText(IDC_EDIT2,sText);	
	m_iCount = strtoi(sText);
	GetDlgItemText(IDC_EDIT3,m_sLines);	
	GetDlgItemText(IDC_EDIT4,m_cSuffix,sizeof(m_cSuffix));	


	if(m_bDelete)
		{
		if(sKey.Open(0,CRK_CREATE))
		if(sKey.Up("ZipDialog"))
			{
			sKey.Set(m_iStart ,"DelPos"  );
			sKey.Set(m_iCount ,"DelCount");
			sKey.Set(m_cSuffix,"Suffix"  );
			}

		if(m_iCount<=0)
			{
			MessageBox("Die Anzahl der zu lschenden Zeilen muss Grer 0 sein !","Fehler",MB_OK|MB_ICONWARNING);
			return;
			}
		}
	else{
		if(sKey.Open(0,CRK_CREATE))
		if(sKey.Up("ZipDialog"))
			{
			sKey.Set(m_iStart ,"AddPos"  );
			sKey.Set(m_sLines ,"AddLines");
			sKey.Set(m_cSuffix,"Suffix"  );
			}

		if(m_sLines.IsEmpty())
			{
			MessageBox("Es muss ein Text zum Einfgen angegeben werden !","Fehler",MB_OK|MB_ICONWARNING);
			return;
			}
		}

	

	EnableDlgItem(IDOK,FALSE);

	m_bRunning = TRUE;
	m_bResult  = 0;

	GetDlgProgressCtrl(IDC_PROGRESS1)->SetRange(0,m_pList->Count());

	AfxBeginThread(WorkeProc,this);

}

//*****************************************************************************
//*
//*		SaveFile
//*
//*****************************************************************************
//	Speicher eine Datei
//	pPath		: Ist der Dateiname
//	pData		: Liste mit den Zeilen
//	Ergibt 0 wenn ok oder eine Fehlernummer
int CLinesDlg::SaveFile(const char *pPath,CStringChain *pData)
{
char	cName[MAX_PATH];
FILE   *pFile;
char   *pText;
int		iPos;
int		iLen;


	sprintf(cName,"%s%s",pPath,m_cSuffix);


		pFile = fopen(cName,"wb");
	if(!pFile)
		{
		m_sError.Format("Die Datei %s konnte nicht erstellt werden !",cName);
		m_bResult = 0;
		PostMessage(WM_COMMAND,ID_ERROR);
		while(!m_bResult)Sleep(2000);
		return 1;
		}


	for(iPos=0;iPos<pData->Count();iPos++)
		{
		pText = pData->Get(iPos,iLen);
		fwrite(pText,1,iLen,pFile);
		}

	fclose(pFile);


return 0;
}

//*****************************************************************************
//*
//*		WorkeProc
//*
//*****************************************************************************
UINT CLinesDlg::WorkeProc(LPVOID pParam){return ((CLinesDlg*)pParam)->WorkeProc();}
UINT CLinesDlg::WorkeProc()
{
char				cLine[4096];
CStringChain		sList(sizeof(int));
CString				sPath;
const char		   *pPath;
const char		   *pText;
const char		   *pLfCr;
FILE			   *pFile;
BOOL				bFlag;
int					iLine;
int					iLen;
int					iPos;
int					iOff;
int					iNum;


	pLfCr = "\r\n";
	bFlag = 0;
	pFile = 0;

	m_iCurPos = 0;
	PostMessage(WM_COMMAND,ID_SETPOS);
	
	
	for(iPos=0;iPos<m_pList->Count();iPos++)			// Gefundene Zeilen durchlaufen
		{
		if(m_bStop)break;

		pPath = m_pList->GetFileName(iPos);					
		iLine = m_pList->GetLineNr  (iPos);
		
		
		if(stricmp(sPath,pPath))						// Wurde eine neue Datei gefunden
			{
			if(pFile)
				{
				fclose(pFile);
				if(bFlag)
					{
					bFlag = 0;			
					SaveFile(sPath,&sList);				// Die nderungen speichern
					}
				}


				pFile = fopen(pPath,"rb");
			if(!pFile)
				{
				m_sError.Format("Die Datei %s konnte nicht geffmet werden !",pPath);
				m_bResult = 0;
				PostMessage(WM_COMMAND,ID_ERROR);
				while(!m_bResult)Sleep(2000);
				continue;
				}

			sPath = pPath;

			cLine[sizeof(cLine)-1] = 0;
			sList.Del();
			iLen = 0;

			while(fgets(cLine,sizeof(cLine)-1,pFile))
				{
				if(m_bStop)break;
				iLen++;
				sList.Add(cLine,CSC_END,&iLen);
				}
			
			pLfCr = "\r\n";
			pText = sList.Get(0,iLen);
														// Zeilen Abschluss holen
			if(iLen<2 || pText[iLen-1]!='\n' || pText[iLen-2]!='\r')
				{
				pLfCr = "\n";
				}
			}

		
		if(m_bStop)break;



		if(m_bDelete)									// Zeilen lschen
			{
			for(iOff=0;iOff<sList.Count();iOff++)
				{
				if(sList.DataGet(iOff)!=iLine)continue;
				if(sList.Del(iOff+m_iStart,iOff+m_iStart+m_iCount)>0)
					{
					bFlag = 1;
					}
				
				break;
				}
			}
		else{											// Zeilen einfgen
			for(iOff=0;iOff<sList.Count();iOff++)
				{
				if(sList.DataGet(iOff)!=iLine)continue;

				pText = m_sLines;

				for(iNum=0;*pText;iNum++)
					{
					iLen   = strcwlen(pText,0x40);
					sList.AddFormat(iOff+m_iStart+iNum,"%.*s%s",iLen,pText,pLfCr);
					bFlag  = 1;
					pText += iLen;
					if(*pText=='\r')pText++;
					if(*pText=='\n')pText++;
					}
				
				break;
				}
			}
		
		m_iCurPos = iPos+1;
		PostMessage(WM_COMMAND,ID_SETPOS);
		}


	if(pFile)											// Die nderungen speichern
		{
		fclose(pFile);
		
		if(bFlag && !m_bStop)
			{
			bFlag = 0;			
			SaveFile(sPath,&sList);
			}
		}



	m_bRunning = FALSE;
	m_bDone    = TRUE;

	PostMessage(WM_COMMAND,(m_bStop)? IDCANCEL:IDOK,0);


return 0;
}