//*****************************************************************************
//*
//*
//*		MainFrm.cpp : Implementierung der Klasse CMainFrame
//*
//*
//*****************************************************************************
#include	"StdAfx.h"
#include	"DataFinder.h"
#include	"DataFinderView.h"
#include	"AppMessage.h"
#include	"MainFrm.h"

#ifdef	   _DEBUG
#define new	DEBUG_NEW
#undef		THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif


IMPLEMENT_DYNCREATE(CMainFrame, CFrameWnd)

BEGIN_MESSAGE_MAP(CMainFrame, CFrameWnd)
	//{{AFX_MSG_MAP(CMainFrame)
	ON_WM_CREATE()
	ON_WM_COPYDATA()
	ON_COMMAND(ID_STATUS_BAR_FLAT,OnFlatBar)
	ON_UPDATE_COMMAND_UI(ID_STATUS_BAR_FLAT,OnFlatBarUI)
	//}}AFX_MSG_MAP
	ON_STATUSBAR()
	ON_MENUICON()
END_MESSAGE_MAP()

static UINT indicators[] =
{
	ID_SEPARATOR,           // Statusleistenanzeige
};

STATUSBAR_PROC(CMainFrame);
MENUICON_PROC(CMainFrame);

//*****************************************************************************
//*
//*		Konstruktor
//*
//*****************************************************************************
CMainFrame::CMainFrame()
{
CRegKeys	sKey;

	m_bFlatMode = TRUE;
	
	sKey.Open();
	sKey.Up("Settings");
	sKey.Get(m_bFlatMode,"FlatMode");

}


//*****************************************************************************
//*
//*		Destruktor
//*
//*****************************************************************************
CMainFrame::~CMainFrame()
{
CRegKeys	sKey;

	sKey.Open();
	sKey.Up("Settings");
	sKey.Set(m_bFlatMode,"FlatMode");
}


//*****************************************************************************
//*
//*		OnCreate
//*
//*****************************************************************************
int CMainFrame::OnCreate(LPCREATESTRUCT lpCreateStruct)
{
DWORD	dwStyle;


	if(CFrameWnd::OnCreate(lpCreateStruct) == -1)
		{
		return -1;
		}

	dwStyle = (m_bFlatMode)? TBSTYLE_FLAT:0;
	
	if(!m_wndToolBar.CreateEx(this,dwStyle,WS_CHILD|WS_VISIBLE|CBRS_TOP|CBRS_GRIPPER|CBRS_TOOLTIPS|CBRS_FLYBY|CBRS_SIZE_DYNAMIC,CRect(2,2,2,2)))
		{
		TRACE0("Symbolleiste konnte nicht erstellt werden\n");
		return -1;      // Fehler bei Erstellung
		}
	
	if(!m_wndToolBar.LoadToolBar(IDR_MAINFRAME))
		{
		TRACE0("Symbolleiste konnte nicht erstellt werden\n");
		return -1;      // Fehler bei Erstellung
		}

	if(!m_wndStatusBar.Create(this) ||	!m_wndStatusBar.SetIndicators(indicators,sizeof(indicators)/sizeof(UINT)))
		{
		TRACE0("Statusleiste konnte nicht erstellt werden\n");
		return -1;      // Fehler bei Erstellung
		}

	// ZU ERLEDIGEN: Entfernen, wenn Sie keine QuickInfos oder variable Symbolleiste wnschen
	m_wndToolBar.SetBarStyle(m_wndToolBar.GetBarStyle()|CBRS_TOOLTIPS|CBRS_FLYBY|CBRS_SIZE_DYNAMIC);
	m_wndToolBar.EnableDocking(CBRS_ALIGN_ANY);

	EnableDocking(CBRS_ALIGN_ANY);
	DockControlBar(&m_wndToolBar);
	MenuIconsInit(IDR_MAINFRAME);


return 0;
}


//*****************************************************************************
//*
//*		PreCreateWindow
//*
//*****************************************************************************
BOOL CMainFrame::PreCreateWindow(CREATESTRUCT& cs)
{
	if( !CFrameWnd::PreCreateWindow(cs) )
		return FALSE;
	return TRUE;
}


//*****************************************************************************
//*
//*		Debug Funktionen
//*
//*****************************************************************************
#ifdef _DEBUG
void CMainFrame::AssertValid() const
{
	CFrameWnd::AssertValid();
}

void CMainFrame::Dump(CDumpContext& dc) const
{
	CFrameWnd::Dump(dc);
}

#endif 


//*****************************************************************************
//*
//*		OnFlatBarUI
//*
//*****************************************************************************
void CMainFrame::OnFlatBarUI(CCmdUI *pCmdUI)
{
	pCmdUI->SetCheck(m_bFlatMode);
}


//*****************************************************************************
//*
//*		OnFlatBar
//*
//*****************************************************************************
void CMainFrame::OnFlatBar()
{
DWORD	dwStyle;


	dwStyle=(m_bFlatMode)? TBSTYLE_FLAT:0;
	m_wndToolBar.ModifyStyle(dwStyle,dwStyle^TBSTYLE_FLAT);
	m_bFlatMode=(dwStyle)? 0:1;

	if(m_wndToolBar.GetStyle()&WS_VISIBLE)
		{
		ShowControlBar(&m_wndToolBar,FALSE,FALSE);
		ShowControlBar(&m_wndToolBar,TRUE ,FALSE);
		}
	

}

//*****************************************************************************
//*
//*		OnCopyData
//*
//*****************************************************************************
BOOL CMainFrame::OnCopyData(CWnd *pWnd,COPYDATASTRUCT *pCopyData)
{																
TCHAR			  cText[MAX_PATH];										
CDataFinderView  *pView;


	#ifdef UNICODE
	if(!(pCopyData->dwData&APP_USEUNICODE))										
		{																		
		pCopyData->dwData |= APP_USEUNICODE;									
		MultiByteToWideChar(CP_ACP,MB_PRECOMPOSED,(char*)pCopyData->lpData,pCopyData->cbData,(TCHAR*)cText,sizeof(cText)/2-1);
		pCopyData->cbData *= 2;													
		pCopyData->lpData  = cText;												
		}																		
	else{																		
		pCopyData->dwData &= ~APP_USEUNICODE;									
		}																		
	#else																		
	if(pCopyData->dwData&APP_USEUNICODE)										
		{																		
		pCopyData->dwData &= ~APP_USEUNICODE;									
		WideCharToMultiByte(CP_ACP,0,(wchar_t*)pCopyData->lpData,pCopyData->cbData/2,(TCHAR*)cText,sizeof(cText)-1,NULL,NULL);
		pCopyData->cbData /= 2;													
		pCopyData->lpData  = cText;												
		}																		
	#endif																		


	if(pCopyData->dwData==((WM_APPINFO<<16)|APP_FINDTEXT))		
		{															
		   pView = (CDataFinderView*)GetActiveView();									
		if(pView)
			{
			ForceWindowToTop(m_hWnd);
			pView->FindText((LPCTSTR)pCopyData->lpData);
			}
		}																		


return TRUE;																
}																			

