//*****************************************************************************
//*
//*
//*		RenameDlg.cpp: Implementierungsdatei
//*
//*
//*****************************************************************************
#include "StdAfx.h"
#include "AfxUtility.h"
#include "DataFinder.h"
#include "RenameDlg.h"
#include "FileListCtrl.h"

#ifdef		_DEBUG
#define new	 DEBUG_NEW
#undef		 THIS_FILE
static char	 THIS_FILE[] = __FILE__;
#endif

#define 	IDNEXT	0x1947
#define 	IDERROR	0x1948


BEGIN_MESSAGE_MAP(CRenameDlg, CDialog)
	//{{AFX_MSG_MAP(CRenameDlg)
	ON_WM_CTLCOLOR()
	ON_WM_KEYDOWN()
	ON_BN_CLICKED(IDC_CHECK1,OnClickFilter)
	ON_BN_CLICKED(IDC_CHECK2,OnClickFilter)
	ON_BN_CLICKED(IDC_CHECK3,OnClickFilter)
	ON_BN_CLICKED(IDALL		,OnAll)
	ON_BN_CLICKED(IDIGNORE	,OnIgnore)
	ON_EN_CHANGE(IDC_EDIT1	,OnChangeFormat)
	ON_COMMAND(IDERROR		,OnError)
	ON_COMMAND(IDNEXT		,OnNext)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

DLG_OLDPOS(CRenameDlg)



#define 	ERROR_COLOR		RGB(255,128,128)


//*****************************************************************************
//*
//*		Konstruktor
//*
//*****************************************************************************
CRenameDlg::CRenameDlg(CWnd *pParent) : CDialog(CRenameDlg::IDD,pParent)
{
	//{{AFX_DATA_INIT(CRenameDlg)
	m_sFormat  = _T("");
	m_sNewName = _T("");
	m_sOldName = _T("");
	m_bOnlyFilter  = TRUE;
	m_bOutAsFilter = FALSE;
	m_bAllowPoints = FALSE;
	//}}AFX_DATA_INIT

	m_pFileList = 0;
	m_hBrush    = CreateSolidBrush(ERROR_COLOR);
}

//*****************************************************************************
//*
//*		Destruktor
//*
//*****************************************************************************
CRenameDlg::~CRenameDlg()
{
	DeleteObject(m_hBrush);
}

//*****************************************************************************
//*
//*		DoDataExchange
//*
//*****************************************************************************
void CRenameDlg::DoDataExchange(CDataExchange *pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CRenameDlg)
	DDX_Control(pDX, IDC_PROGRESS1, m_cProgress);
	DDX_Check(pDX,IDC_CHECK1,m_bOnlyFilter );
	DDX_Check(pDX,IDC_CHECK2,m_bOutAsFilter);
	DDX_Check(pDX,IDC_CHECK3,m_bAllowPoints);
	DDX_Text(pDX, IDC_EDIT1, m_sFormat);
	DDX_Text(pDX, IDC_EDIT2, m_sNewName);
	DDX_Text(pDX, IDC_EDIT3, m_sOldName);
	DDX_Text(pDX, IDC_PATHNAME, m_cPath,sizeof(m_cPath));
	//}}AFX_DATA_MAP
}

//*****************************************************************************
//*
//*		OnInitDialog
//*
//*****************************************************************************
BOOL CRenameDlg::OnInitDialog()
{
CWnd	   *pWnd;
CRegKeys	cKey;
CRect		cRect;
HFONT		hFont;


	SET_DLG_OLDPOS()

	pWnd = GetDlgItem(IDC_PATHNAME);
	pWnd->GetClientRect(&cRect);

	hFont = (HFONT)pWnd->SendMessage(WM_GETFONT,0,0);
	if(hFont)GetCharWidths(m_bFontSize,hFont);
	else	 GetCharWidths(m_bFontSize);

	m_iWndSize=cRect.Width()-8;
	m_cError[0] = 0;

	cKey.Open();
	cKey.Get(m_sFormat     ,"RenameFormat");
	cKey.Get(m_bOnlyFilter ,"OnlyFilter"  );
	cKey.Get(m_bOutAsFilter,"OutAsFilter" );
	cKey.Get(m_bAllowPoints,"AllowPoints" );


	CDialog::OnInitDialog();

	m_bAll	  = FALSE;
	m_bEnd	  = FALSE;
	m_bStop   = FALSE;
	m_bError  = FALSE;
	m_bIgnore = FALSE;

	m_iError		= 0;
	m_iErrForm		= 0;
	m_bUpdate		= 0;
	m_iSameCount	= 0;
	m_iRenameCount	= 0;

	m_cProgress.SetRange(0,m_pFileList->GetItemCount());
	m_hImageList	= GetIconList(1);
	m_hIconWnd		= GetDlgItem(IDC_ICONWND);

	m_cPath[0]=0;

	AfxBeginThread(RenameProc,this);

	OnChangeFormat();


return TRUE;
}


//*****************************************************************************
//*
//*		OnOK
//*
//*****************************************************************************
void CRenameDlg::OnOK()
{


	GET_DLG_OLDPOS()


	if(m_bEnd)
		{
		CRegKeys cKey;
		CString  sText;

		cKey.Open();
		cKey.Set(m_sFormat     ,"RenameFormat");
		cKey.Set(m_bOnlyFilter ,"OnlyFilter"  );
		cKey.Set(m_bOutAsFilter,"OutAsFilter" );
		cKey.Set(m_bAllowPoints,"AllowPoints" );

		sText.Format("Es wurden %i von %i Dateien umbenannt.\nBei %i Dateien gab es keine nderungen.",m_iRenameCount,m_pFileList->GetItemCount(),m_iSameCount);

		m_cProgress.SetPos(m_pFileList->GetItemCount());
		MessageBox(sText,"Information",MB_OK|MB_ICONINFORMATION);
		CDialog::OnOK();
		}

	UpdateData();

	EnableDlgItem(IDOK     ,0);					// Warte auf OK
	EnableDlgItem(IDALL    ,0);
	EnableDlgItem(IDIGNORE ,0);
	EnableDlgItem(IDC_EDIT1,0);
	EnableDlgItem(IDC_EDIT2,0);

	m_cWait.Unlock();

}

//*****************************************************************************
//*
//*		OnCancel
//*
//*****************************************************************************
void CRenameDlg::OnCancel()
{

	GET_DLG_OLDPOS()

	m_bStop=1;

	if(m_bEnd)
		{
		CRegKeys cKey;

		cKey.Open();
		cKey.Set(m_sFormat     ,"RenameFormat");
		cKey.Set(m_bOnlyFilter ,"OnlyFilter"  );
		cKey.Set(m_bOutAsFilter,"OutAsFilter" );
		cKey.Set(m_bAllowPoints,"AllowPoints" );

		CDialog::OnCancel();
		}

	UpdateData();
	m_cWait.Unlock();
}

//*****************************************************************************
//*
//*		OnAll
//*
//*****************************************************************************
void CRenameDlg::OnAll()
{
	m_bAll=1;
	OnOK();
}


//*****************************************************************************
//*
//*		OnNext
//*
//*****************************************************************************
void CRenameDlg::OnNext()
{
char	cText[128];

	sprintf(cText,"Datei %i von %i :",m_iPos,m_pFileList->GetItemCount());
	SetDlgItemText(IDC_INFO ,cText    );
	GetDlgItemText(IDC_EDIT1,m_sFormat);

	UpdateData(FALSE);
}

//*****************************************************************************
//*
//*		OnIgnore
//*
//*****************************************************************************
void CRenameDlg::OnIgnore()
{
	m_bIgnore=TRUE;
	OnOK();
}

//*****************************************************************************
//*
//*		OnClickFilter
//*
//*****************************************************************************
void CRenameDlg::OnClickFilter()
{
char	cBuffer[MAX_PATH];
int		iMode;
int		iLen;
int		iOld;


	UpdateData();

	iOld		= m_iErrForm;
	m_iErrForm	= CheckFormat(m_sFormat);

	if(m_iErrForm)
		{
		switch(m_iErrForm)
			{
		case 1:	SetDlgItemText(IDC_EDIT4,"< Punkte sind im ersten Tauschblock nicht erlaubt >");			break;
		case 4:	SetDlgItemText(IDC_EDIT4,"< Ein Tauschblock ist nicht mit '|' abgeschlossen >");			break;
		default:SetDlgItemText(IDC_EDIT4,"< Wildcards (*?) sind im  ersten Tauschblock nicht erlaubt >");	break;
			}
		}
	else if(m_bOutAsFilter)
		{
		                  iMode =0x01;
		if(m_bAllowPoints)iMode|=0x02;
		if(m_bOutAsFilter)iMode|=0x08;

		iLen=memtofind(m_sFormat,cBuffer,iMode);
		if(iLen==0)strcpy(cBuffer,"*.*");
		SetDlgItemText(IDC_EDIT4,cBuffer);
		}
	else{
		SetDlgItemText(IDC_EDIT4,"< kein Dateifilter ausgewhlt >");
		}

	if(iOld!=m_iErrForm)GetDlgItem(IDC_EDIT4)->RedrawWindow();

	m_bUpdate	= TRUE;
	OnOK();
}

//*****************************************************************************
//*
//*		OnError
//*
//*****************************************************************************
void CRenameDlg::OnError()
{
CString	sText;
int		iOk;


	sText.Format("Fehler beim Umbennen von %s%s !\n\nWiederholen ?%s",(LPCSTR)m_cPath,(LPCSTR)m_sOldName,m_cError);
	iOk = MessageBox(sText,"Fehler",MB_ABORTRETRYIGNORE|MB_ICONERROR);

	if(iOk==IDIGNORE)m_bIgnore=TRUE;
	if(iOk==IDABORT )m_bStop  =TRUE;

	m_cWait.Unlock();
}

//*****************************************************************************
//*
//*		RenameProc
//*
//*****************************************************************************
UINT _cdecl CRenameDlg::RenameProc(void *Param){return ((CRenameDlg*)Param)->RenameProc();}
UINT        CRenameDlg::RenameProc()
{
BOOL	bOk;
HICON	hIcon;
LPCTSTR	pPath;
LPCTSTR	pText;
char	cBuffer[MAX_PATH];
char	cFile  [MAX_PATH];
DWORD	dwLast=0;
int		iChanged;
int		iNoSet;
int		iLast;
int		iMode;
int		i;



	EnableDlgItem(IDOK     ,1);
	EnableDlgItem(IDALL    ,1);
	EnableDlgItem(IDIGNORE ,1);
	EnableDlgItem(IDC_EDIT1,1);
	PostMessage(WM_COMMAND ,IDNEXT);


	iLast		= 0;
	iNoSet		= 0;
	iChanged	= 0;


	for(m_iPos=0;;)
		{
		if(m_bStop)break;

		if(m_bOnlyFilter)							// Nchste Position	bestimmen
			{
			   m_iPos = FindFormatPosition(iLast);
			if(m_iPos>=m_pFileList->GetItemCount() && iLast && iNoSet==0)
				{
				break;
				}
			}
		else{
			m_iPos = iLast;
			}

		m_bIgnore  = FALSE;

		if(m_iPos>=m_pFileList->GetItemCount())		// Ist man am Listenende ?
			{
			m_sNewName	= "<keine Datei passt zum Format>";
			m_sOldName	= "";
			m_iError	= 1;
			}
		else{
			pText = m_sFormat;
			iMode = 0x01;

			if(!stricmp(pText,m_sNewName))			// Format ohne *?| und nur Groskleinunterscheidung
				{
				i = strcwlen(pText,0x01800000);
				
				if(pText[i]==0)
					{
					i = strchar(pText,'|');
					if(pText[i]==0)iMode=0;
					}
				}

			if(m_bAllowPoints)iMode|=0x02;
			if(m_bOutAsFilter)iMode|=0x08;

			CommpressFileName(m_pFileList->GetFileName(m_iPos,1),m_cPath,sizeof(m_cPath),m_iWndSize,m_bFontSize);
			m_sOldName = m_pFileList->GetFileName(m_iPos);
			memrename(m_sFormat,m_sOldName,cBuffer,sizeof(cBuffer),iMode);
			if(iMode&0x01)m_sNewName = cBuffer;			  

			if(m_sNewName=="")
				{
				m_sNewName=m_sOldName;
				m_iError=1;
				}
			else{
				m_iError=0;
				}
			}

		if(iNoSet==0)								// Den Focus auf OK setzen
			{
			SetFocus();
			GetDlgItem(IDC_EDIT2)->RedrawWindow();
			SetDlgDefID(IDOK);
			SetDlgFocus(IDOK);
			}
		else{
			iNoSet=0;
			}


		if(m_bAll)									// Alle ndern
			{
			if(m_iPos>=m_pFileList->GetItemCount())break;
			if(dwLast+300<GetTickCount())
				{
				i=GetLargeIcon(m_sOldName,SHGFI_USEFILEATTRIBUTES);
				hIcon=ImageList_ExtractIcon(NULL,m_hImageList,i);
				m_hIconWnd->SendMessage(STM_SETICON,(WPARAM)hIcon);
				m_cProgress.SetPos(m_iPos);
				dwLast=GetTickCount();
				PostMessage(WM_COMMAND,IDNEXT);
				}
			}
		else{
			bOk = m_iPos<m_pFileList->GetItemCount();
			EnableDlgItem(IDOK     ,bOk);
			EnableDlgItem(IDALL    ,bOk);
			EnableDlgItem(IDIGNORE ,bOk);
			EnableDlgItem(IDC_EDIT1,1  );
			EnableDlgItem(IDC_EDIT2,1  );

			i=GetLargeIcon(m_sOldName,SHGFI_USEFILEATTRIBUTES);
			hIcon=ImageList_ExtractIcon(NULL,m_hImageList,i);
			m_hIconWnd->SendMessage(STM_SETICON,(WPARAM)hIcon);
			m_cProgress.SetPos(m_iPos);
			PostMessage(WM_COMMAND,IDNEXT);

			m_cWait.Lock();							// Warte auf OK

			if(m_bUpdate)
				{
				m_bUpdate = 0;
				iNoSet	  = 1;
				continue;
				}

			if(m_bStop || m_iPos>=m_pFileList->GetItemCount())
				{
				break;
				}

			if(m_bIgnore)							// Datei auslassen
				{
				iLast = m_iPos+1;
				continue;
				}
			}


		if(m_sNewName==m_sOldName)					// Hat sich der Name verndert
			{
			m_iSameCount++;
			iLast = m_iPos+1;
			continue;
			}

		pPath=m_pFileList->GetPathName(m_iPos);

		i=strlcpy(cBuffer  ,pPath     ,sizeof(cBuffer));
		  strlcpy(cBuffer+i,m_sOldName,sizeof(cBuffer)-i);
		  strlcpy(cFile  +i,m_sNewName,sizeof(cFile)-i);
		  memcpy (cFile    ,cBuffer,i);
retry:

			bOk=MoveFile(cBuffer,cFile);
		if(!bOk)
			{
			m_bIgnore=FALSE;
			switch(GetLastError())
				{
			case ERROR_ALREADY_EXISTS:	strcpy(m_cError,"\n\nDer neue Dateiname existiert bereits !");	break;
			case ERROR_FILE_NOT_FOUND:	strcpy(m_cError,"\n\nDie Datei wurde nicht gefuneden !");		break;
			case ERROR_ACCESS_DENIED:	strcpy(m_cError,"\n\nDer Zugriff wurde verweigert !");			break;
			default:					strcpy(m_cError,"");											break;
				}

			PostMessage(WM_COMMAND,IDERROR);

			for(;;)									// Warte auf MessageBox
				{
				m_cWait.Lock();
				if(!m_bUpdate)break;
				m_bUpdate = 0;
				}

			if( m_bStop  )break;
			if(!m_bIgnore)goto retry;
			}
		else{
			m_pFileList->GetFiles()->Rename(m_iPos,m_sNewName);
			m_iRenameCount++;
			}

		iLast = m_iPos+1;
		}

	if(!m_bStop)m_cProgress.SetPos(m_iPos+1);
	m_bEnd = TRUE;

	PostMessage(WM_COMMAND,(m_bStop)? IDCANCEL:IDOK);


return 0;
}


//*****************************************************************************
//*
//*		OnChangeFormat
//*
//*****************************************************************************
void CRenameDlg::OnChangeFormat()
{
char	cBuffer[MAX_PATH];
int		iMode;
int		iLen;
int		iOld;


	UpdateData();

		              iMode =0x01;
	if(m_bAllowPoints)iMode|=0x02;
	if(m_bOutAsFilter)iMode|=0x08;

	memrename(m_sFormat,m_sOldName,cBuffer,sizeof(cBuffer),iMode);
	m_sNewName=cBuffer;

	iOld		= m_iErrForm;
	m_iErrForm	= CheckFormat(m_sFormat);

	if(m_iErrForm)
		{
		switch(m_iErrForm)
			{
		case 1:	SetDlgItemText(IDC_EDIT4,"< Punkte sind im ersten Tauschblock nicht erlaubt >");			break;
		case 4:	SetDlgItemText(IDC_EDIT4,"< Ein Tauschblock ist nicht mit '|' abgeschlossen >");			break;
		default:SetDlgItemText(IDC_EDIT4,"< Wildcards (*?) sind im  ersten Tauschblock nicht erlaubt >");	break;
			}
		}
	else if(m_bOutAsFilter)
		{
		iLen=memtofind(m_sFormat,cBuffer,iMode);
		if(iLen==0)strcpy(cBuffer,"*.*");
		SetDlgItemText(IDC_EDIT4,cBuffer);
		}
	else{
		SetDlgItemText(IDC_EDIT4,"< kein Dateifilter ausgewhlt >");
		}

	if(iOld!=m_iErrForm)GetDlgItem(IDC_EDIT4)->RedrawWindow();

	if(m_sNewName=="")
		{
		m_sNewName=m_sOldName;
		m_iError=1;
		}
	else{
		m_iError=0;
		}

	UpdateData(FALSE);
	GetDlgItem(IDC_EDIT2)->RedrawWindow();

	m_bUpdate = TRUE;
	UpdateData(FALSE);
	m_cWait.Unlock();

}


//*****************************************************************************
//*
//*		OnCtlColor
//*
//*****************************************************************************
HBRUSH CRenameDlg::OnCtlColor( CDC *pDC, CWnd *pWnd, UINT nCtlColor)
{

	if(m_iErrForm && GetWndId(pWnd)==IDC_EDIT4)
		{
		pDC->SetBkColor(ERROR_COLOR);
		return m_hBrush;
		}

	if(m_iError && GetWndId(pWnd)==IDC_EDIT2)
		{
		pDC->SetBkColor(ERROR_COLOR);
		return m_hBrush;
		}


return CDialog::OnCtlColor(pDC,pWnd,nCtlColor);
}


//*****************************************************************************
//*
//*		OnKeyDown
//*
//*****************************************************************************
void CRenameDlg::OnKeyDown( UINT nChar, UINT nRepCnt, UINT nFlags )
{
	CDialog::OnKeyDown(nChar,nRepCnt,nFlags);
}

//*****************************************************************************
//*
//*		FindFormatPosition
//*
//*****************************************************************************
int CRenameDlg::FindFormatPosition(int iPos)
{
char	cBuffer[MAX_PATH];
char   *pText;
int		iMode;



	for(;iPos<m_pFileList->GetItemCount();iPos++)
		{
		pText = m_pFileList->GetFiles()->Name(iPos);

		                  iMode =0x01;
		if(m_bAllowPoints)iMode|=0x02;
		if(m_bOutAsFilter)iMode|=0x08;

		memrename(m_sFormat,pText,cBuffer,sizeof(cBuffer),iMode);
		if(cBuffer[0] || m_bUpdate)break;
		}


return iPos;
}

//*****************************************************************************
//*
//*		CheckFormat
//*
//*****************************************************************************
int CRenameDlg::CheckFormat(LPCTSTR pFormat)
{
int		iStep;


	iStep = 0;

	for(;*pFormat;pFormat++)
		{
		if(*pFormat=='|'){iStep++;continue;}
		if(*pFormat=='.' && iStep%3==1 && m_bAllowPoints==0)return 1;
		if(*pFormat=='*' && iStep%3==2)return 2;
		if(*pFormat=='?' && iStep%3==2)return 3;
		}



return (iStep%3)? 4:0;
}
