//*****************************************************************************
//*
//*
//*		RtfToHtml.cpp : Definiert den Einsprungpunkt fr die Konsolenanwendung.
//*
//*
//*****************************************************************************
#include	"StdAfx.h"
#include	"Html.h"



#define		COLOR_MAX					32
#define		STACK_MAX					512
#define		STYLE_MAX					64
#define		FONT_MAX					64

long			color[COLOR_MAX];
int				color_count=0;


typedef struct
	{
	unsigned char	blood;
	unsigned char	unterline;
	unsigned char	itallic;
	unsigned char	color;
	unsigned char	size;
	unsigned char	font;
	}RtfStack;

typedef struct
	{
	char			type[16];
	char			name[32];
	unsigned char	nr;
	}RtfFont;


int				styles_count=0;
RtfStack		styles[STYLE_MAX];
char			styles_names[STYLE_MAX][32];

int			multi_space =0;

int				font_brt	= 2;
int				font_size = 0;
int				font_base = 18;
int				font_count= 0;
RtfFont			font [FONT_MAX];

RtfStack		stack[STACK_MAX];
RtfStack		stack_last,stack_now;
int				stack_pos=0;

char			html_path[MAX_PATH] = "Html/Test";
char			base_from[MAX_PATH] = "";
char			base_path[MAX_PATH] = "";
char			base_name[MAX_PATH] = "";
char			base_link[MAX_PATH] = "";
char			base_file[MAX_PATH] = "";
char			class_name[64];
char			class_lib [64]="AZ Library";

char			rtf_name[256]	= "";
char			rtf_link[256] = "";
char			rtf_keyn[256] = "";
char			rtf_keys[256] = "";

CTextBuffer		hhk_file;
CTextBuffer		hhp_file;
CTextBuffer		hhc_file;
CTextBuffer		htm_file;
CTextBuffer		rtf_file;
CTextBuffer		tab_file;

CStringChain	html_files;
CStringChain	html_topics(sizeof(int));
CStringChain	html_temp;
CStringChain	html_tabels(sizeof(int));

void		RtfPop();
void		RtfPush();
int			RtfStepTo(char Zeichen);
int			RtfStepOver(int Pos=1);
char	   *ReadToken(int  *Nr=0);
char	   *ReadText (char *EndChar,int Flags=3,int *Size=0);
char	   *ReadText (				int Flags=3,int *Size=0){return ReadText("",Flags,Size);}
char	   *ScanText (char *EndChar,int Flags=3,int *Size=0);
char	   *ScanText (				int Flags=3,int *Size=0){return ScanText("",Flags,Size);}



int			rtf_add 	= 0;
int			class_list=0;
int			class_ok=0;
int			class_first=0;


	char	   *stop_links[] ={ "HauptSeite",
	"BitFunctions",
	"FileFunctions",
	"MemFunctions",
	"StringFunctions",
	"CStringChain",
	"CFileFinder",
	"CShFind",
	"CShItem",
	"CDataList",
	"CDataField",
	"CMapFile",
	0
	};



//*****************************************************************************
//*
//*		RtfCheckType
//*
//*****************************************************************************
int RtfCheckType()
{
int			nr=0;


	if(stack_last.blood		!= stack_now.blood)nr=1;
	if(stack_last.unterline != stack_now.unterline)nr=2;
	if(stack_last.itallic	!= stack_now.itallic)nr=3;
	if(stack_last.size		!= stack_now.size)nr=4;
	if(stack_last.color		!= stack_now.color)nr=5;
	if(stack_last.font		!= stack_now.font)nr=6;

	if(!nr)return 0;


	if(nr>=1 && stack_last.blood)htm_file.Write("</b>");
	if(nr>=2 && stack_last.unterline)htm_file.Write("</u>");
	if(nr>=3 && stack_last.itallic)htm_file.Write("</i>");
	if(nr>=4 && stack_last.size)htm_file.WriteFormat("</h%i>",stack_last.size+1);
	if(nr>=5 && stack_last.color)htm_file.Write("</font>");
	if(nr>=6 && stack_last.font)htm_file.Write("</span>");

	if(nr>=6 && stack_now.font)htm_file.Write("\n<span style='font-family:\"Courier New\"'>\n");
	if(nr>=5 && stack_now.color)htm_file.WriteFormat("<font color=#%06X>",color[stack_now.color]);
	if(nr>=4 && stack_now.size)htm_file.WriteFormat("<h%i>",stack_now.size+1);
	if(nr>=3 && stack_now.itallic)htm_file.Write("<i>");
	if(nr>=2 && stack_now.unterline)htm_file.Write("<u>");
	if(nr>=1 && stack_now.blood)htm_file.Write("<b>");

	stack_last =	stack_now;

return 1;
}


//*****************************************************************************
//*
//*		RtfCheckNull
//*
//*****************************************************************************
void RtfCheckNull()
{
	RtfPush();
	memset(&stack_now,0,sizeof(stack_now));
	RtfCheckType();
	RtfPop();

}

//*****************************************************************************
//*
//*		RtfSetStyle
//*
//*****************************************************************************
int RtfSetStyle(int Nr)
{

	if(Nr<0 || Nr>styles_count)return 0;
	stack_now=styles[Nr];


return 1;
}

//*****************************************************************************
//*
//*		RtfTokenLen
//*
//*****************************************************************************
int RtfTokenLen(const char *Token)
{
int			x,len=0;

	if(*Token=='\\'){len++;Token++;}

	x=strwlen(Token);

	if(Token[x]=='-'){x++;x+=strwlen(Token+x,0x01);}
	if(Token[x]==' ') x++;

return len+x;
}

//*****************************************************************************
//*
//*		RtfReadLink
//*
//*****************************************************************************
int RtfReadLink()
{
char		buffer[256],name[256];
char	   *text,*ptr;
int			x,y;

	text=ReadText(7);
	if(!RtfStepTo('{'))return 0;
	ptr=ReadToken();

	if(strcmp(ptr,"v"))
		{
		htm_file.Write(text);
		RtfStepOver();
		return 0;
		}

	strcpy(buffer,text);
	text=ReadText(7);
	for(x=0;x<256;x++)
		{
		if(text[x]== 0)break;
		if(text[x]=='.')text[x]='_';
		if(text[x]==' ')text[x]='_';
		}

	if(!stricmp (text,base_link))text=base_file;
	if(!strnicmp(text,"!PopupID",8))
		{
		x=strchar(text	,'>');if(text[x])x++;
		y=strchar(text+x,'\'');

		   y=html_tabels.Find(y,text+x);
		if(y>=0)
			{
			x		= html_tabels.DataGet(y);
			text	= html_temp[x];
			}
		else{
			x=strchar(text	,',');if(text[x])x++;if(text[x])x++;if(text[x])x++;
			y=strchar(text+x,'>');
			if(y>sizeof(name)-6)y=sizeof(name)-6;
			memcpy(name,text+x ,y);
			name[y]=0;
			}
		}

	if(!stricmp(text,"!CopyTopic()"))
		{
		RtfStepOver();
		return 1;
		}

	y		= strchar(text,'>');
	text[y] = 0;

	htm_file.Write("<A href=\"");
	htm_file.Write(text);
	htm_file.Write(".html\">");
	WriteHtml(buffer);
	htm_file.Write("</A>");

	RtfStepOver();

return 1;
}

//*****************************************************************************
//*
//*		RtfFootNode
//*
//*****************************************************************************
// 	Ergibt:		0 = Keine Fussnote gefunden
// 				1 = Fussnote gefunden
// 				2 = Neue HTML Datei erzeugt
int RtfFootNode(char Type)
{
char	   *text,*mem;
int			x,add,found;


	if(!rtf_file.Text(rtf_add,&mem,256))return 0;
	rtf_add=0;

	text=ScanText(0xFF,&add);

	if(Type=='$' && !strncmp(text,"\\footnote ",10))
		{
			text+=10;
		if(*text=='$')text++;
		if(*text==' ')text++;
		strlcpy(rtf_name,text,sizeof(rtf_name));
		found=1;
		}

	if(Type=='#' && !strncmp(text,"\\footnote ",10))
		{
			text+=10;
		if(*text=='#')text++;
		if(*text==' ')text++;
		strlcpy(rtf_link,text,sizeof(rtf_name));
		found=1;
		}

	if(Type=='K' && !strncmp(text,"\\footnote ",10))
		{
			text+=10;
		if(*text=='K')text++;
		if(*text==' ')text++;
		strlcpy(rtf_keys,text,sizeof(rtf_keys));
		found=1;
		}

	if(Type=='+' && !strncmp(text,"\\footnote ",10))
		{
			text+=10;
		if(*text=='+')text++;
		if(*text==' ')text++;
		strlcpy(rtf_keyn,text,sizeof(rtf_keyn));
		found=1;
		}

//*****************************************************************************

	if(!found)return 0;

	rtf_file.Text(add,&mem,256);
	add=strwlen(mem,0xE0);
	rtf_file.Text(add,&mem,256);


	if(Type!='#')return 1;
	if(rtf_link[0]==0)return 1;

	for(x=0;x<256;x++)
		{
		if(rtf_link[x]== 0)break;
		if(rtf_link[x]=='.')rtf_link[x]='_';
		if(rtf_link[x]==' ')rtf_link[x]='_';
		}

	if(base_link[0]==0) 										// Erster rtf_link
		{
		strlcpy(base_link,rtf_link ,sizeof(base_link    ));
		strlcpy(rtf_link ,base_file,sizeof(     rtf_link));
		if(!*rtf_name)strlcpy(rtf_name,base_file,sizeof(rtf_name));
		}

	RtfCheckNull();
	CloseHtml();
	CreateHtml(base_name,rtf_link,rtf_name);
	strlcpy(class_name,rtf_link,sizeof(class_name));
	WriteHhk(rtf_name,rtf_link);


	html_files.Add(rtf_link);									// Dateinamen speichern




return 2;
}

//*****************************************************************************
//*
//*		WriteLink
//*
//*****************************************************************************
int WriteLink()
{
char	   *mem;
int			len,x,y,pos,len1,ok=1;



	if(!rtf_file.Text(rtf_add,&mem,1024))return 0;
	rtf_add=0;

	for(x=0;x<1024;x++)
		{
		if(mem[x]== 0)return 0;
		if(mem[x]=='}')return 0;
		if(mem[x]=='{')return 0;
		if(!strnicmp(mem+x,"\\uldb ",6)){x+=6;break;}
		}

	for(;x<1024;x++)
		{
		if(mem[x]== 0)return 0;
		if(mem[x]=='}')return 0;
		if(mem[x]=='{'){x++;break;}
		}

	for(pos=x;x<1024;x++)										// Suche Text
		{
		if(mem[x]== 0)return 0;
		if(mem[x]=='{')return 0;
		if(mem[x]=='}'){x++;break;}
		}

																// Hole Text
	   len=x-1-pos;
	if(len<0)len=0;
	for(;len>0 && mem[pos+len-1]==' ';len--);

	for(;x<1024;x++)
		{
		if(mem[x]== 0)return 0;
		if(mem[x]=='{')return 0;
		if(mem[x]=='}'){x++;break;}
		}

	for(;x<1024;x++)
		{
		if(mem[x]== 0)return 0;
		if(mem[x]=='}')return 0;
		if(mem[x]=='{'){x++;break;}
		}

	for(;x<1024;x++)
		{
		if(mem[x]== 0)return 0;
		if(mem[x]=='}')return 0;
		if(mem[x]=='{')return 0;
		if(!strnicmp(mem+x,"\\v ",3)){x+=3;break;}
		}


	for(y=0;stop_links[y];y++)									// Prfe on link auslassen
		{
		if(!stricmp(base_file,stop_links[y]))continue;
		if(mem[x]=='{')
			{
			len1=strcspn(mem+x+1,"}");
			if(!strnicmp(mem+x+1,stop_links[y],len1)){ok=0;break;}
			}
		else{
			len1=strcspn(mem+x	,"}");
			if(!strnicmp(mem+x	,stop_links[y],len1)){ok=0;break;}
			}
		}




	if(ok)RtfCheckType();
	if(ok)htm_file.Write("\n");

	if(class_list && !class_ok)
		{
		if(ok)RtfCheckNull();
		if(!class_first)
			{
			if(ok)htm_file.Write("\n<table border=1 cellpadding=5 cols=2 frame=below rules=rows><font face=\"verdana,arial,helvetica\" size=\"2\">\n");
			class_first=1;
			}

		if(ok)htm_file.Write("<tr valign=top>\n<td width=32%>");
		}


	if(mem[x]=='{')
		{
		len1=strcspn(mem+x+1,"}");
		if(ok)htm_file.Write("<A href=\"");
		if(ok)htm_file.Write(mem+x+1,len1);
		if(ok)htm_file.Write(".html\">");
		x+=len1+3;
		}
	else{
		len1=strcspn(mem+x,"}");
		if(ok)htm_file.Write("<A href=\"");
		if(ok)htm_file.Write(mem+x,len1);
		if(ok)htm_file.Write(".html\">");
		x+=len1+1;
		}

	for(;len>0;len--,pos++) 									// Schreibe Text
		{
		if(mem[pos]=='\\')
			{
			y		= RtfTokenLen(mem+pos)-1;
			len    -= y;
			pos    += y;
			continue;
			}

		if(ok)WriteHtml(mem[pos]);
		}


	if(ok)htm_file.Write("</A> ");

	if(!ok)
		{
		if(mem[x]=='|')x+=1;
		if(mem[x]==' ' && mem[x+1]=='|')x+=2;
		if(mem[x]==' ' && mem[x+1]==' ' && mem[x+2]=='|')x+=3;
		}

	rtf_file.Text(x,&mem,1024);
	rtf_add=0;

	if(class_list && !class_ok)
		{
		if(ok)RtfCheckNull();
		if(ok)htm_file.Write("</td>\n<td width=68%>");
		class_ok=1;
		}


	RtfPop();


return 1;
}

//*****************************************************************************
//*
//*		WriteFootNote
//*
//*****************************************************************************
// {\AZ #{\footnote CFilePuffer_OpenMem}}  {\AZ ${\footnote CFileBuffer::OpenMem }}
int WriteFootNote()
{
char	   *mem,buffer1[64],buffer2[64];
int			len,x,pos,pos1,len1;


	if(!rtf_file.Text(rtf_add,&mem,1024))return 0;
	rtf_add=0;


	if(!strnicmp(mem,"K{\\footnote ",12))
		{
		x	= 12;
		x  += strcspn(mem+x,"}{");

		for(;x<1024;x++)
			{
			if(mem[x]== 0)return 0;
			if(mem[x]=='{')return 0;
			if(mem[x]=='}'){x++;break;}
			}

		for(;x<1024;x++)
			{
			if(mem[x]== 0)return 0;
			if(mem[x]=='{')return 0;
			if(mem[x]=='}'){x++;break;}
			}

		rtf_file.Text(x,&mem);
		rtf_add=0;

		RtfPop();
		return 0;
		}


	if(strnicmp(mem,"#{\\footnote ",12))return 0;

	pos = x=12;
	len = strcspn(mem+x,"}{$ \n\r\t");
	x  += len;
	for(;len>0 && mem[pos+len-1]==' ';len--);

	for(;x<1024;x++)
		{
		if(mem[x]== 0)return 0;
		if(mem[x]=='{')return 0;
		if(mem[x]=='}'){x++;break;}
		}

	for(;x<1024;x++)
		{
		if(mem[x]== 0)return 0;
		if(mem[x]=='{')return 0;
		if(mem[x]=='}'){x++;break;}
		}

	for(;x<1024;x++)
		{
		if(mem[x]== 0)return 0;
		if(mem[x]=='}')return 0;
		if(mem[x]=='{'){x++;break;}
		}

	for(;x<1024;x++)
		{
		if(mem[x]== 0)return 0;
		if(mem[x]=='}')return 0;
		if(mem[x]=='{')return 0;
		if(!strnicmp(mem+x,"\\AZ ${\\footnote ",16)){x+=16;break;}
		}

	pos1	= x;
	len1	= strcspn(mem+x,"}{");
	x	   += len1;

	for(;len1>0 && mem[pos1+len1-1]==' ';len1--);

	for(;x<1024;x++)
		{
		if(mem[x]== 0)return 0;
		if(mem[x]=='{')return 0;
		if(mem[x]=='}'){x++;break;}
		}

	for(;x<1024;x++)
		{
		if(mem[x]== 0)return 0;
		if(mem[x]=='{')return 0;
		if(mem[x]=='}'){x++;break;}
		}

	if(len >sizeof(buffer1))len =sizeof(buffer1)-1;
	if(len1>sizeof(buffer2))len1=sizeof(buffer2)-1;

	strlcpy(buffer1,mem+pos ,len +1);
	strlcpy(buffer2,mem+pos1,len1+1);

	rtf_file.Text(x,&mem,1024);
	rtf_add=0;


	RtfCheckNull();
	CloseHtml();
	CreateHtml(base_name,buffer1,buffer2);
	strlcpy(class_name,buffer1,sizeof(class_name));

	class_first = 0;
	class_list	= 0;
	class_ok	= 0;

	if(strstr(class_name,"_Class_members"	))class_list=1;
	if(strstr(class_name,"BitFunctions"		))class_list=1;
	if(strstr(class_name,"StringFunctions"	))class_list=1;
	if(strstr(class_name,"MemFunctions"		))class_list=1;
	if(strstr(class_name,"StringFunctions"	))class_list=1;
	if(strstr(class_name,"FileFunctions"	))class_list=1;

	WriteHhk(buffer2,class_name);

	RtfPop();

return 1;
}


//*****************************************************************************
//*
//*		RtfPush
//*
//*****************************************************************************
void RtfPush()
{

	if(stack_pos>=STACK_MAX)
		{
		printf("\nRtf Stack Ueberlauf !\n");
		exit(-1);
		}

	stack[stack_pos]=stack_now;
	stack_pos++;

}

//*****************************************************************************
//*
//*		RtfPop
//*
//*****************************************************************************
void RtfPop()
{

	if(stack_pos<=0)
		{
		printf("\nRtf Stack Unetrlauf !\n");
		return;
		}

	stack_pos--;
	stack_now	=  stack[stack_pos];
	multi_space = (stack_now.font==1);

}

//*****************************************************************************
//*
//*		ReadToken
//*
//*****************************************************************************
char *ReadToken(int *Nr)
{
static char		buffer[32];
char		   *mem;
int				len,pos,nr;


	if(Nr)*Nr=-1;

	if(!rtf_file.Text(rtf_add,&mem,32))return "";
	rtf_add=0;

	if(mem[rtf_add	]=='\r')rtf_add++;
	if(mem[rtf_add	]=='\n')rtf_add++;
	if(mem[rtf_add	]!='\\' ||
	   mem[rtf_add+1]=='\\' ||
	   mem[rtf_add+1]=='\'' ||
	   mem[rtf_add+1]=='-'	||
	   mem[rtf_add+1]=='{'	||
	   mem[rtf_add+1]=='}')
		{
		rtf_file.Text(rtf_add);
		rtf_add=0;
		return "";
		}

	rtf_add++;													// berspringe '\'
	if(!rtf_file.Text(rtf_add,&mem,32))return "";
	rtf_add=0;


	   len=RtfTokenLen(mem);
	if(len<=0)													// Token zu kurz
		{
		rtf_file.Text(rtf_add);
		rtf_add=0;
		return "";
		}


	pos=strwlen(mem,0x06);										// Eine Zahl auslesen
	if(mem[pos]=='-' || (mem[pos]>='0' && mem[pos]<='9'))
		{
		nr=atoi(mem+pos);
		}
	else	nr=-1;
	if(Nr)*Nr=nr;

	rtf_add=len;												// Ein Leerzeichen berspringen

	for(;;rtf_add++)											// Zeilensprnge auslassen
		{
		if(mem[rtf_add]=='\n')continue;
		if(mem[rtf_add]=='\r')continue;
		break;
		}

	if(pos>sizeof(buffer)-1)pos=sizeof(buffer)-1;
	memcpy(buffer, mem,pos);
	buffer[pos]=0;

	rtf_file.Text(rtf_add,&mem,256);							// Token berspringen
	rtf_add=0;


																// Standard Tokens


	if(!strcmp(buffer,"b"	 ))stack_now.blood		= nr;
	if(!strcmp(buffer,"i"	 ))stack_now.itallic	= nr;
	if(!strcmp(buffer,"ul"	 ))stack_now.unterline	= nr;
	if(!strcmp(buffer,"cf"	 ))stack_now.color		= nr-1;
	if(!strcmp(buffer,"f"	 ))
		{
		font_size=nr;
		if(nr<0 && nr>=FONT_MAX)nr=0;
		else					nr=font[nr].nr;
		stack_now.font	=  nr;
		multi_space 	= (nr==1);
		}

	if(!strcmp(buffer,"fs"	 ))
		{
		   nr=(font_base-nr)/font_brt;
		if(nr< 1)nr=1;
		if(nr>=4)nr=0;
		stack_now.size=nr;
		}

	if(!strcmp(buffer,"plain"))
		{
		stack_now.blood 	= 0;
		stack_now.color 	= 0;
		stack_now.itallic	= 0;
		stack_now.unterline = 0;
		};

	strlwr(buffer);

	if(!strcmp(buffer,"strike"))return "uldb";

return buffer;
}


//*****************************************************************************
//*
//*		ReadText
//*
//*****************************************************************************
// 	Liest einen Text ein und holt ihn aus dem Puffer
// 	In Size wird die Lnge des zurckgegebenen Textes gespeichert
// 	Flags	:	Bit 0	Leerzeichen am Ende	  entfernen
// 				Bit 1	Leerzeichen am Anfang entfernen
// 				Bit 2	Tokens berspringen
// 				Bit 3	Klammer berspringen
// 				Bit 4	TAB zu Space
// 				Bit 5	Keine Doppelspaces
// 				Bit 6	Erstes Token abspeichern
// 				Bit 7	Nach '}' bei Eben 0 abbrechen
char *ReadText(char *EndChar,int Flags,int *Size)
{
static char		buffer[1024];
char		   *mem,zeichen[2]={0,0};
int				len,anz,ebene=0,token=1;


	if(!rtf_file.Text(rtf_add,&mem,1024))return "";
	rtf_add=0;


	for(len=0;len<sizeof(buffer)-1;)
		{
		zeichnen[0]	= mem[rtf_add]; 							// Zeichen Ende
		anz 		= strcspn(EndChar,zeichen);
		if(EndChar[anz])break;

		if(zeichen[0]=='\r'){rtf_add++;continue;}
		if(zeichen[0]=='\n'){rtf_add++;continue;}
		if(zeichen[0]=='\\')
			{
			if(mem[rtf_add+1]=='\\'){buffer[len]='\\';len++;rtf_add+=2;continue;}
			if(mem[rtf_add+1]=='{'){buffer[len]='\\';len++;rtf_add+=2;continue;}
			if(mem[rtf_add+1]=='}'){buffer[len]='\\';len++;rtf_add+=2;continue;}
			if(mem[rtf_add+1]=='\'')
				{
				buffer[len] = strtoh(mem+rtf_add+2,2);
				rtf_add    += 4;
				len++;
				continue;
				}

			if(~Flags&2)break;

			anz=RtfTokenLen(mem+rtf_add+1)+1;

			if(!token && (Flags&0x40) && len+anz<sizeof(buffer)-2)
				{
				memcpy(buffer+len,mem+rtf_add,anz);
				len 	   += anz;
				buffer[len] = ' ';
				len++;
				}

			rtf_add    += anz;
			token		= 1;
			continue;
			}

		if(zeichen[0]=='{')
			{
			if(~Flags&8)break;
			rtf_add++;
			ebene++;
			continue;
			}

		if(zeichen[0]=='}')
			{
			if(ebene<=0)break;
			rtf_add++;
			ebene--;
			if((Flags&0x80) && ebene<=0)break;
			continue;
			}

		if((Flags&0x10) && zeichen[0]=='\t')					// TAB zu SPACE
			{
			zeichen[0]=' ';
			}

		if((Flags&0x20) && zeichen[0]==' ') 					// Keine doppel SPACE's
		if(len>=0 && buffer[len-1]==' ')
			{
			len--;
			}

		buffer[len]=zeichen[0];
		rtf_add++;
		len++;
		}

	rtf_file.Text(rtf_add,&mem);
	rtf_add=0;

	for(;;rtf_add++)											// Zeilensprnge am Ende
		{
		if(mem[rtf_add]=='\n')continue;
		if(mem[rtf_add]=='\r')continue;
		break;
		}

	rtf_file.Text(rtf_add,&mem);
	rtf_add = 0;
	anz 	= 0;

	if(Flags&1)for(;len>0	&& buffer[len-1]==' ';len--);
	if(Flags&2)for(;anz<len && buffer[anz  ]==' ';anz++);

	buffer[len]=0;

	if(Size)*Size=len-anz;

return buffer+anz;
}

//*****************************************************************************
//*
//*		ScanText
//*
//*****************************************************************************
// 	Liest einen Text ein ohne ihn aus dem Puffer zu holen
// 	In Size wird die Lnge des im Puffer bersprungenen Textes gespeichert
// 	Flags	:	Bit 0	Leerzeichen am Ende	  entfernen
// 				Bit 1	Leerzeichen am Anfang entfernen
// 				Bit 2	Tokens berspringen
// 				Bit 3	Klammer berspringen
// 				Bit 4	TAB zu Space
// 				Bit 5	Keine Doppelspaces
// 				Bit 6	Erstes Token abspeichern
// 				Bit 7	Nach '}' bei Eben 0 abbrechen
char *ScanText(char *EndChar,int Flags,int *Size)
{
static char		buffer[1024];
char		   *mem,zeichen[2]={0,0};
int				len,anz,pos,ebene=0,token=0;


	if(!rtf_file.Text(rtf_add,&mem,1024))return "";
	rtf_add = 0;
	pos 	= 0;

	for(len=0;len<sizeof(buffer)-1;)
		{
		zeichen[0]	= mem[pos]; 								// Zeichen Ende
		anz 		= strcspn(EndChar,zeichen);
		if(EndChar[anz])break;

		if(zeichen[0]=='\r'){pos++;continue;}
		if(zeichen[0]=='\n'){pos++;continue;}
		if(zeichen[0]=='\\')
			{
			if(mem[pos+1]=='\\'){buffer[len]='\\';len++;pos+=2;continue;}
			if(mem[pos+1]=='{'){buffer[len]='\\';len++;pos+=2;continue;}
			if(mem[pos+1]=='}'){buffer[len]='\\';len++;pos+=2;continue;}
			if(mem[pos+1]=='\'')
				{
				buffer[len] = strtoh(mem+pos+2,2);
				pos 	   += 4;
				len++;
				continue;
				}

			if(~Flags&2)break;

			anz=RtfTokenLen(mem+pos+1)+1;

			if(!token && (Flags&0x40) && len+anz<sizeof(buffer)-2)
				{
				memcpy(buffer+len,mem+pos,anz);
				len 	   += anz;
				buffer[len] = ' ';
				len++;
				}

			pos    += anz;
			token	= 1;
			continue;
			}

		if(zeichen[0]=='{')
			{
			if(~Flags&8)break;
			pos++;
			ebene++;
			continue;
			}

		if(zeichen[0]=='}')
			{
			if(ebene<=0)break;
			pos++;
			ebene--;
			if((Flags&0x80) && ebene<=0)break;
			continue;
			}

		if((Flags&0x10) && zeichen[0]=='\t')					// TAB zu SPACE
			{
			zeichen[0]=' ';
			}

		if((Flags&0x20) && zeichen[0]==' ') 					// Keine doppel SPACE's
		if(len>=0 && buffer[len-1]==' ')
			{
			len--;
			}

		buffer[len]=zeichen[0];
		len++;
		pos++;
		}

	for(;;pos++)												// Zeilensprnge am Ende
		{
		if(mem[pos]=='\n')continue;
		if(mem[pos]=='\r')continue;
		break;
		}

	anz=0;

	if(Flags&1)for(;len>0	&& buffer[len-1]==' ';len--);
	if(Flags&2)for(;anz<len && buffer[anz  ]==' ';anz++);

	buffer[len]=0;

	if(Size)*Size=pos;

return buffer+anz;
}


//*****************************************************************************
//*
//*		RtfStepOver
//*
//*****************************************************************************
//  berspringe {} Klammern
//  Pos	: Gibt an wieviele ebenen nach unten
//  Ergibt 1 wenn alles ok sonst 0
int RtfStepOver(int Pos)
{
char	   *mem;
int			len=0;


	for(;;rtf_add++)
		{
		if(rtf_add>=len)
			{
			len 	= rtf_file.Text(rtf_add,&mem);
			rtf_add = 0;
			}

		if(mem[rtf_add]== 0)return 0;
		if(mem[rtf_add]=='{')Pos++;
		if(mem[rtf_add]=='}')
			{
			   Pos--;
			if(Pos==0)break;
			}
		}

	rtf_file.Text(rtf_add+1,&mem);
	rtf_add=0;

	for(;;rtf_add++)											// Zeilensprnge am Ende
		{
		if(mem[rtf_add]=='\n')continue;
		if(mem[rtf_add]=='\r')continue;
		break;
		}

	rtf_file.Text(rtf_add,&mem);
	rtf_add=0;


return 1;
}

//*****************************************************************************
//*
//*		RtfStepTo
//*
//*****************************************************************************
//  Geht bis zu Zeichen und holt es aus der Liste
//  Ergibt 1 wenn alles ok sonst 0
int RtfStepTo(char Zeichen)
{
char	   *mem;

	rtf_file.Text(rtf_add,&mem);
	rtf_add=0;

	for(;;rtf_add++)
		{
		if(mem[rtf_add]=='\n')continue;
		if(mem[rtf_add]=='\r')continue;
		if(mem[rtf_add]==Zeichen)break;
		return 0;
		}

	rtf_file.Text(rtf_add+1,&mem);
	rtf_add=0;

	for(;;rtf_add++)											// Zeilensprnge am Ende
		{
		if(mem[rtf_add]=='\n')continue;
		if(mem[rtf_add]=='\r')continue;
		break;
		}

	rtf_file.Text(rtf_add,&mem);
	rtf_add=0;


return 1;
}

//*****************************************************************************
//*
//*		RtfReadImage
//*
//*****************************************************************************
int RtfReadImage()
{
char	   *mem,*align="left";
char		file[64],from[MAX_PATH],to[MAX_PATH];
int			len,anz;


	rtf_file.Text(rtf_add,&mem);
	rtf_add=0;

	if(mem[0]!='\\')return 0;
	if(mem[1]!='{')return 0;
	if(mem[2]!='e')return 0;
	if(mem[3]!='w')return 0;
		{
		if(mem[4]!='r')
		if(mem[4]!='l')
		if(mem[4]!='c')return 0;

		if(mem[4]=='l')align="left";
		if(mem[4]=='r')align="right";
		if(mem[4]=='c')align="center";

		rtf_file.Text(5,&mem);
		rtf_add=strcspn(mem,"!{}");
		if(mem[rtf_add]=='!')rtf_add++;
		len=anz=strcspn(mem+rtf_add," \n\r{}\\");

		if(anz>=sizeof(file))anz=sizeof(file)-1;
		strlcpy(file,mem+rtf_add,anz+1);

		htm_file.WriteFormat("\n<img src=\"%s\" align=%s>",file,align);

		SetFileName(from,base_from,file);
		SetFileName(to  ,base_name,file);
		CopyFile(from,to,0);

		rtf_add += len;
		rtf_add +=strspn (mem+rtf_add," \n\r");
		if(mem[rtf_add]=='\\')rtf_add++;
		if(mem[rtf_add]=='}')rtf_add++;

		return 1;
		}

	if(mem[0]!='\\')return 0;
	if(mem[1]!='{')return 0;
	if(mem[2]!='b')return 0;
	if(mem[3]!='m')return 0;
	if(mem[4]!='r')
	if(mem[4]!='l')
	if(mem[4]!='c')return 0;

	if(mem[4]=='l')align="left";
	if(mem[4]=='r')align="right";
	if(mem[4]=='c')align="center";

	rtf_file.Text(5,&mem);
	rtf_add = strspn (mem		," \n\r"	);
	len 	= anz =strcspn(mem+rtf_add," \n\r{}\\");

	if(anz>=sizeof(file))anz=sizeof(file)-1;
	strlcpy(file,mem+rtf_add,anz+1);

	htm_file.WriteFormat("\n<img src=\"%s\" align=%s>",file,align);

	SetFileName(from,base_from,file);
	SetFileName(to  ,base_name,file);
	CopyFile(from,to,0);

	rtf_add += len;
	rtf_add +=strspn (mem+rtf_add," \n\r");
	if(mem[rtf_add]=='\\')rtf_add++;
	if(mem[rtf_add]=='}')rtf_add++;

return 1;
}


//*****************************************************************************
//*
//*		ReadRtfFontTable
//*
//*****************************************************************************
int ReadRtfFontTable()
{
char	   *ptr;
int			nr;



	memset(font,0,sizeof(font));
	font_count=1;

	if(!RtfStepTo('{'))return 0;
	if(strcmp(ReadToken(),"fonttbl"))return 0;

	for(;;) 													// Lade Farb Tabelle
		{
		if(!RtfStepTo('{'))break;

		ptr=ReadToken(&nr);
		if(strcmp(ptr,"f") || nr<0)return 0;
		if(nr>=FONT_MAX){RtfStepOver(1);continue;}				// Zuviele Schriften

			ptr=ReadToken();									// Lese Font Type
		if(*ptr)
			{
			strlcpy(font[nr].type,ptr,sizeof(font[nr].type));
			if(!strcmp(ptr,"fmodern"))font[nr].nr=1;
			}while(*ptr)ptr=ReadToken();						// Extra Tokens berspringen

		ptr=ReadText(";");										// Lese Font Namen
		strlcpy(font[nr].name,ptr,sizeof(font[nr].name));
		RtfStepOver(1);
		if(nr>=font_count)font_count=nr+1;
		}

	RtfStepOver(1);

return 1;
}


//*****************************************************************************
//*
//*		ReadRtfColorTable
//*
//*****************************************************************************
int ReadRtfColorTable()
{
char	   *mem;
char	   *ptr;
int			r,g,b,nr;


	if(!RtfStepTo('{'))return 0;
	if(strcmp(ReadToken(),"colortbl"))return 0;


	if(!rtf_file.Text(rtf_add,&mem,32))return 0;

	rtf_add=0;
	if(mem[0]==';')rtf_add++;


	r			= -1;g=-1;b=-1;
	color_count =  0;

	for(;;) 													// Lade Farb Tabelle
		{
		ptr=ReadToken(&nr);if(!*ptr)if(strcmp(ptr,"red"	 ))return 0;r=nr;
		ptr=ReadToken(&nr);if(!*ptr)if(strcmp(ptr,"green"))return 0;g=nr;
		ptr=ReadToken(&nr);if(!*ptr)if(strcmp(ptr,"blue" ))return 0;b=nr;

		if(!RtfStepTo(';'))return 0;

		   color[color_count] = (r<<16)|(g<<8)|(b);
		if(color[color_count]!=-1)color_count++;
		else color[color_count] = 0;

		if(RtfStepTo('}'))break;

		r=-1;g=-1;b=-1;
		}

return 1;
}

//*****************************************************************************
//*
//*		ReadRtfStyleSheet
//*
//*****************************************************************************
int ReadRtfStyleSheet(int DetectHeader)
{
char	   *ptr;
int			nr,ok=1,null=0;



	styles_count=0;
	memset(styles      ,0,sizeof(styles      ));
	memset(styles_names,0,sizeof(styles_names));

	if(DetectHeader)
		{
		if(!RtfStepTo('{'))return 0;
		if(strcmp(ReadToken(),"stylesheet"))return 0;
		}

	RtfPush();

	for(;;) 													// Lade Farb Tabelle
		{
		if(!RtfStepTo('{'))break;

		memset(&stack_now,0,sizeof(stack_now));
		ptr=ReadToken(&nr);
		if(nr<0)
			{
			RtfStepOver(1);
			ok=0;
			break;
			}

		if(strcmp(ptr,"s")){nr=0;null=1;}
		if(nr>=STYLE_MAX){RtfStepOver(1);continue;}while(*ptr)ptr=ReadToken();						// Styles einlesen	// Zuvile Syles

		ptr=ReadText(";");
		if(!RtfStepTo(';'))break;

		styles[nr]=stack_now;
		strlcpy(styles_names[nr],ptr,sizeof(styles_names[nr]));
		if(nr>=styles_count)styles_count=nr+1;
		if(!RtfStepTo('}'))break;
		}

	RtfPop();
	RtfStepOver(1);



	if(null)stack_now = styles[0];								// Standard Style


return ok;
}

//*****************************************************************************
//*
//*		ReadRtfHeader
//*
//*****************************************************************************
int ReadRtfHeader()
{
char	   *mem,*ptr,zeichen;


	font_base+=(font_brt*9)>>1;

	if(!rtf_file.Text(rtf_add,&mem))return 0;
	rtf_add = rtf_file.TextEmpty(1);
	if(!rtf_file.Text(rtf_add,&mem))return 0;
	rtf_add = rtf_file.TextChar(&zeichen);
	if(zeichen!='{')return 0;

	memset(stack,0,sizeof(stack));								// Stack initialisieren
	stack_pos++;
	color[0]	= 0;
	color_count = 1;

	ptr 		= ReadToken();
	if(strcmp(ptr,"rtf"))return 0;

	while(*ptr)ptr=ReadToken(); 								// Extra Tokens berspringen

	if(!ReadRtfFontTable ())return 0;
	if(!ReadRtfColorTable())return 0;


return 1;
}


//*****************************************************************************
//*
//*		RtfScan
//*
//*****************************************************************************
int RtfScan()
{
char	   *mem,*ptr;
int			wert,nr,x,par=0,par_sub=0;


	while(rtf_file.Text(rtf_add,&mem))
		{
		rtf_add=0;
		if(par)
			{
			par=0;
			if(mem[0]=='\n')par_sub=1;
			if(mem[0]=='\r' && mem[1]=='\n')par_sub=1;
			}

		if(mem[0]=='\n'){				rtf_add=1;continue;}
		if(mem[0]=='\r')
			{
			if(HtmlGetLast()!=' ')WriteHtml(' ');
			rtf_add=1;
			continue;
			}

		if(mem[0]=='\\' && *(ptr=ReadToken(&nr)))
			{
			if(!strcmp(ptr,"tab" )){WriteHtml('\t');continue;}
			if(!strcmp(ptr,"s"	 )){RtfSetStyle(nr);continue;}
			if(!strcmp(ptr,"uldb")){RtfReadLink(  );continue;}
			if(!strcmp(ptr,"v" ))
				{
				ptr = ScanText();
				x	= html_files.Count();
				if(*ptr && x)
					{
					x--;
					html_topics.Add(ptr,CSC_END,&x);
					}

				continue;
				}

			if(!strcmp(ptr,"par" ))
				{
				if(stack_now.size)
					{
					x				= stack_now.size;
					stack_now.size	= 0;
					RtfCheckType();
					stack_now.size=x;
					}

				if(class_list && class_first)
					{
					RtfCheckNull();
					if(!class_ok)
						{
						htm_file.Write("\n</font></table>\n<br>\n");
						HtmlSetLast(' ');
						class_first=0;
						continue;
						}

					RtfCheckNull();
					htm_file.Write("</td></tr>");
					class_ok=0;
					continue;
					}

				htm_file.Write("\n<br>");
				HtmlSetLast(' ');
				par=1;
				continue;
				}

			if(!strcmp(ptr,"pard" ))
				{
				if(stack_now.size)
					{
					x				= stack_now.size;
					stack_now.size	= 0;
					RtfCheckType();
					stack_now.size=x;
					}

				htm_file.Write("\n<br>");
				HtmlSetLast(' ');
				par=1;
				continue;
				}

			if(!strcmp(ptr,"az" ))
				{
				if(!WriteLink())WriteFootNote();
				}

			if(!strcmp(ptr,"stylesheet"))
				{
				ReadRtfStyleSheet(0);
				continue;
				}

			if(!strcmp(ptr,"up"))
				{
				ptr=ReadText("}");

				if(ptr[1]!= 0)continue;
				if(ptr[0]!='$' && ptr[0]!='#' && ptr[0]!='K' && ptr[0]!='+')continue;

				rtf_file.Text(rtf_add,&mem);
				rtf_add=0;

				if(mem[0]!='}')continue;
				if(stack_pos>0)RtfPop();

				rtf_file.Text(1,&mem);
				rtf_add=strwlen(mem,0xE0);

				RtfFootNode(ptr[0]);
				}

			continue;
			}

		if(mem[0]=='$' && mem[1]=='{'){rtf_add=1;if(RtfFootNode('$'))continue;}
		if(mem[0]=='#' && mem[1]=='{'){rtf_add=1;if(RtfFootNode('#'))continue;}
		if(mem[0]=='K' && mem[1]=='{'){rtf_add=1;if(RtfFootNode('K'))continue;}
		if(mem[0]=='+' && mem[1]=='{'){rtf_add=1;if(RtfFootNode('+'))continue;}


		if(mem[0]=='{')
			{
			rtf_add=1;
			RtfPush();
			continue;
			}

		if(mem[0]=='}')
			{
			if(stack_pos>0)RtfPop();
			rtf_add=1;
			continue;
			}

		if(mem[0]=='\\')
			{
			if(mem[1]=='{' && mem[2]=='b' && mem[3]=='m')
				{
				if(RtfReadImage())continue;
				}

			if(mem[1]=='{' && mem[2]=='e' && mem[3]=='w' && mem[4]=='c')
				{
				if(RtfReadImage())continue;
				}

			if(mem[1]=='\\' || mem[1]=='}' || mem[1]=='{')
				{
				rtf_add=2;
				RtfCheckType();
				WriteHtml(mem[1]);
				continue;
				}

			if(mem[1]=='|' || mem[1]=='~' || mem[1]=='-' || mem[1]=='_' || mem[1]==':')
				{
				rtf_add=2;
				continue;
				}
			}

		if(mem[0]=='\\')
		if(mem[1]=='\'')
			{
			rtf_add = 4;
			wert	= strtoh(mem+2,2);
			WriteHtml(wert);
			par_sub=0;
			continue;
			}

		if(class_list && class_first)
		if(!strnicmp(mem,"siehe",5))
			{
			RtfCheckNull();
			if(class_ok)htm_file.Write("</td></tr>");
			htm_file.Write("\n</font></table>\n");
			class_first = 0;
			class_list	= 0;
			class_ok	= 0;
			}


		if(par_sub && mem[0]==' ' && mem[1]==' ')
			{
			par_sub=0;
			rtf_add=1;
			continue;
			}

		RtfCheckType();
		WriteHtml(mem[0]);
		rtf_add=1;
		par_sub=0;
		}


	CloseHtml();
	printf("\nFertig\n");

return 1;
}


//*****************************************************************************
//*
//*		main
//*
//*****************************************************************************
int main(int argc, char* argv[])
{
char		name[256],path[256],*file,*ptr;
int			x,y;


	file=argv[1];

	for(x=2;x<argc;x++)
		{
		   ptr=argv[x];
		if(ptr[0]!='-' && ptr[0]!='/')continue;

		if(!strnicmp(ptr+1,"f:"		 ,2))font_base=atoi(ptr+1+2);
		if(!strnicmp(ptr+1,"b:"		 ,2))font_brt =atoi(ptr+1+2);
		if(!strnicmp(ptr+1,"html:"	 ,5))strlcpy(html_path,ptr+1+5,sizeof(html_path));
		if(!strnicmp(ptr+1,"lib:"	 ,4))strlcpy(class_lib,ptr+1+4,sizeof(class_lib));
		if(!stricmp (ptr+1,"s"		   ))strlcpy(html_path,GetFileName(file),sizeof(html_path));
		}

	DelBackSlash(html_path);
	SetFileType (html_path,"");
	if(font_brt<1)font_brt=1;

	if(argc<2)
		{
		printf("\n\nSyntax:	  RtfDatei [Zielpfad] [-lib:?] [-html:?] [-f:?] [-f:?] [-s] [-p]\n");
		printf("\n\tRtfDatei   : Datei die in  Html-Hilfe umgewandelt werden soll.");
		printf("\n\tZielpfad   : Pfad in dem die Html-Hilfe erstell werden soll.");
		printf("\n\t-lib:Name  : Name fuer die Bibliothek");
		printf("\n\t-html:Pfad : Sub Pfad in dem die Html-Dateien erstellt werden");
		printf("\n\t-f:?	   : Basis Schriftgroesse (18=default)");
		printf("\n\t-b:?	   : Schriftstep ab der eine andere Schriftgroesse kommt");
		printf("\n\t-s:Pfad	   : Dateinamen als Pfad fuer die Html-Dateien verwenden\n\n");
		return 0;
		}

	if(!rtf_file.Open(file))
		{
		printf("\n\nKann Datei '%s' nicht laden.\n\n",file);
		return -1;
		}

	if(argc>2 && argv[2][0]!='-' && argv[2][0]!='/')
		{
		if(!CreatePath(argv[2]))
			{
			printf("\n\nKann Pfad '%s' nicht erzeugen.\n\n",argv[2]);
			return -1;
			}

		strlcpy(base_path,argv[2],sizeof(base_path));
		}
	else{
		GetFilePath(base_path,file,sizeof(base_path));
		}


//******************** Erzeuge HTML Dateien ***********************************

	if(!ReadRtfHeader())
		{
		printf("\n\nFalscher oder fehlerhafter RTF Header.\n\n",file);
		return -1;
		}


	strcpy(path,file);											// Tabellen zu Ortung laden
	SetFileType(path,"tab");
	if(tab_file.Open(path))
		{
		char	tab[256],htm[256];
		int		anz,nr;

		do	{	
			anz=tab_file.TextWord(tab,sizeof(tab));
			tab_file.Text(anz);
			tab_file.TextWord(htm,sizeof(htm));

			if(tab[0] && htm[0])
				{
				nr = html_temp.Count();




				html_temp.Add(htm);
				html_tabels.Add(tab,CSC_END,&nr);
				}
			}while(tab_file.TextLine());
		}


	GetFilePath (base_from,file,sizeof(base_from));
	strlcpy		(base_name,base_path,sizeof(base_name));
	AddBackSlash(base_name);
	AddBackSlash(base_path);
	SetFileName (base_name,html_path);
	CreatePath	(base_name);
	AddBackSlash(base_name);
	GetFileName (base_file,file,sizeof(base_file));
	SetFileType (base_file,"");
	CreateHhk	(base_path,GetFileName(file),class_lib);

	GetFileName(name,file,sizeof(name));
	SetFileType(name,"");
	RtfScan();

	for(x=html_topics.Count()-1;x>=0;x--)
		{
		ptr=html_topics[x];
		for(y=x-1;y>=0;y--)
			{
			if(strcmp(ptr,html_topics[y]))continue;
			if(html_topics.DataGet(x)!=html_topics.DataGet(y))continue;
			html_topics.Del(y);
			y++;
			x--;
			}
		}


	CloseHtml();
	CloseHhk();



return 0;
}
