//*****************************************************************************
//*
//*
//*		TextDlg.cpp
//*
//*
//*****************************************************************************
//
//	(C) Copyright Anton Zechner 2007
//
#include	"StdAfx.h"
#include	"TextDlg.h"
#include	"AfxUtility.h"

typedef	struct
	{
	char *text;
	int	  id;
	}MenuItem;


MenuItem	TextMenu[]={
		{	"Beliebige  Zeichen&folge",    		2	},
        {	"&Wort",                       		3	},
        {	"&Zahl",                       		4	},
        {	"&Leerraum",                   		5	},
        {	"&Leerraum oder Zeilenumbruch",		6	},
        {	"Leer&raum oder ""(null)""",   		7	},
        {	"Leer&raum oder ""(null) oder \\n", 8	},
        {	"",							   		0	},
        {	"Zeilen&anfang",               		9	},
        {	"Zeilen&ende",                		10	},
        {	"Wortende",                    		14	},
        {	"Wortanfang",                  		13	},
		{	"Zeilenumbruch",					16	},
        {	"",							   		0	},
        {	"Zeichen Aus&wahl",            		17	},
        {	"Zeichen Auswahl oder \"(null)\"",	18	},
        {	"Zeichenketten Auswahl",			19	},
		{	"Zeichenketten ohne |...|",			21	},
		{	"Zeichen nicht aus {...}",			20	},
        {	"",									 0	},
        {	"Text via strwlen oder (null)",		22	},
		{	"Zeichen via strwchar",				23	},
		{	"Zeichen via strwchar oder (null)",	24	},
        {	"",									0	},
        {	"Beliebiges &Zeichen",         		1	},
        {	"Buchstabe",                   		15	},
        {	"Einzelne Zahl",               		11	},
        {	"Zahl oder Buchstabe",         		12	},
		{0}};

#define 	ID_TEXT_POS		0x1691
#define 	ID_TEXT_CNT		25

BEGIN_MESSAGE_MAP(CTextFindDlg, CDialog)
	//{{AFX_MSG_MAP(CTextFindDlg)
	ON_WM_DESTROY()
	ON_BN_CLICKED(IDOK       		,OnFind)
	ON_BN_CLICKED(IDCANCEL     		,OnCancel)
	ON_BN_CLICKED(IDC_BUTTON2		,OnSelect)
	ON_BN_CLICKED(IDC_CHECK2		,OnClick)
	ON_BN_CLICKED(IDC_CHECK4		,OnClick)
	ON_COMMAND_RANGE(ID_TEXT_POS,ID_TEXT_POS+ID_TEXT_CNT,OnMenu)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

DLG_OLDPOS(CTextFindDlg)



CStringChain	CTextFindDlg::auswahl;		// Zuletzt gesuchte Texte
BOOL			CTextFindDlg::init=0;		// Wurden die Registry Daten geladen ?
int				CTextFindDlg::flags=0;		// Suchen Flags
int				CTextFindDlg::lines=10;		// Zeilenanzahl fr Mult-Line-Suche


//*****************************************************************************
//*
//*		Konstruktor ... Grundeinstellung der Variabeln
//*
//*****************************************************************************
CTextFindDlg::CTextFindDlg(CWnd *pParent) : CDialog(CTextFindDlg::IDD,pParent)
{

	allow_results = 0;

}

//*****************************************************************************
//*
//*		DoModal
//*
//*****************************************************************************
// Ausfhren des Dialoges
// Ergibt IDOK wenn Text gesucht wurde
INT_PTR	CTextFindDlg::DoModal(const char *Text)
{
int		x;


	Init();

	grosklein     = (flags&FLAG_FIND_CASE	      )? 1:0;
	wort		  = (flags&FLAG_FIND_WORD	      )? 1:0;
	ausdruck	  = (flags&FLAG_FIND_EXPRESSION   )? 1:0;
	multi_line	  = (flags&FLAG_FIND_MULTILINNE   )? 1:0;
	use_results   = (flags&FLAG_FIND_USE_RESULTS  )? 1:0;

	if(Text)
		{
		text = Text;
		}
	else{
		if(auswahl.Count()>0)text=auswahl[0];
		}


	x = CDialog::DoModal();


return	x;
}

//*****************************************************************************
//*
//*		DoDataExchange
//*
//*****************************************************************************
void CTextFindDlg::DoDataExchange(CDataExchange *pDX)
{

	CDialog::DoDataExchange(pDX);

	DDX_Text	( pDX , IDC_COMBO1,	text		 );
	DDX_Text	( pDX , IDC_EDIT1,	line_str	 );
	DDX_Check	( pDX , IDC_CHECK1, grosklein    );
	DDX_Check	( pDX , IDC_CHECK2, multi_line   );
	DDX_Check	( pDX , IDC_CHECK3, wort         );
	DDX_Check	( pDX , IDC_CHECK4, ausdruck     );
	DDX_Check	( pDX , IDC_CHECK5, use_results  );

}

//*****************************************************************************
//*
//*		OnInitDialog
//*
//*****************************************************************************
BOOL CTextFindDlg::OnInitDialog()
{
HWND    cbbox;
int		x;


	SET_DLG_OLDPOS()

	SetButtonBitmap(this,IDC_BUTTON2,IDB_TYPE);

	if(!allow_results)
		{
		GetDlgItem(IDC_CHECK5)->EnableWindow(FALSE);
		use_results = 0;
		}

	UpdateData(FALSE);
	OnClick();
	SubclassComboBox(this,IDC_COMBO1,SCB_COLORMSG);
	cbbox=GetDlgItem(IDC_COMBO1)->m_hWnd;

	line_str.Format("%u",lines&0xFF);

	for(x=0;x<auswahl.Count();x++)
		{
		::SendMessage(cbbox,CB_INSERTSTRING,x,(LPARAM)auswahl[x]);
		}


return CDialog::OnInitDialog();
}

//*****************************************************************************
//*
//*		OnDestroy
//*
//*****************************************************************************
void CTextFindDlg::OnDestroy()
{

	DelButtonBitmap(this,IDC_BUTTON2);

	CDialog::OnDestroy();

}

//*****************************************************************************
//*
//*		OnCancel
//*
//*****************************************************************************
// Benden des Dialoges
void CTextFindDlg::OnCancel()
{

	GET_DLG_OLDPOS()

	EndDialog(IDCANCEL);
}

//*****************************************************************************
//*
//*		OnFind
//*
//*****************************************************************************
//	Suchen mit beenden des Dialoges
void CTextFindDlg::OnFind()
{
CComboBox	*cb;
int			 nr;


	GET_DLG_OLDPOS()

	UpdateData();


			cb=(CComboBox*)GetDlgItem(IDC_COMBO1);
	   nr=  cb->GetCurSel();
	if(nr<0)cb->GetWindowText(text);
	else	cb->GetLBText(nr,text);

				   flags =0;
	if(grosklein  )flags|=FLAG_FIND_CASE;
	if(wort		  )flags|=FLAG_FIND_WORD;
	if(ausdruck	  )flags|=FLAG_FIND_EXPRESSION;
	if(multi_line )flags|=FLAG_FIND_MULTILINNE;
	if(use_results)flags|=FLAG_FIND_USE_RESULTS;

	lines=strtoi(line_str);

	if(text=="")
		{
		MessageBeep(MB_ICONASTERISK);
		return;
		}



	auswahl.CAdd(text);
	Exit();

	EndDialog(IDOK);

}

//*****************************************************************************
//*
//*		OnSelect
//*
//*****************************************************************************
void CTextFindDlg::OnSelect()
{
int		x;
RECT	reck;
CMenu	menu;			

	
	
	menu.CreatePopupMenu();								// Men fr Suche


	for(x=0;TextMenu[x].text;x++)
		{
		if(TextMenu[x].id)
			{
			menu.AppendMenu(MF_STRING,ID_TEXT_POS+TextMenu[x].id-1,TextMenu[x].text);
			}
		else{
			menu.AppendMenu(MF_SEPARATOR);
			}
		}

	GetDlgItem(IDC_BUTTON2)->GetWindowRect(&reck);
	menu.TrackPopupMenu(TPM_LEFTALIGN,reck.right,reck.top,this);
	menu.DestroyMenu();

}

//*****************************************************************************
//*
//*		OnMenu
//*
//*****************************************************************************
void CTextFindDlg::OnMenu(UINT Art)
{
CComboBox  *edit;
char 		puffer[256],text[280];
int			len,pos;


	Art-=ID_TEXT_POS-1;


		edit=(CComboBox*)GetDlgItem(IDC_COMBO1);
		edit->GetWindowText(puffer,255);puffer[255]=0;
	pos=edit->GetEditSel()&0xFFFF;



	   len=strlen(puffer);
	if(len<pos)pos=len;

	memcpy(text,puffer,pos);

	switch(Art)
			{
	case 1:	strcpy(text+pos,"?");			break;
	case 2:	strcpy(text+pos,"*");			break;
	case 3:	strcpy(text+pos,"\\w");			break;
	case 4:	strcpy(text+pos,"\\z");			break;
	case 5:	strcpy(text+pos,"\\_");			break;
	case 6:	strcpy(text+pos,"\\-");			break;
	case 7:	strcpy(text+pos,"\\.");			break;
	case 8:	strcpy(text+pos,"\\+");			break;
	case 9:	strcpy(text+pos,"\\a");			break;
	case 10:strcpy(text+pos,"\\e");			break;
	case 11:strcpy(text+pos,"\\p");			break;
	case 12:strcpy(text+pos,"\\o");			break;
	case 13:strcpy(text+pos,"\\g");			break;
	case 14:strcpy(text+pos,"\\f");			break;
	case 15:strcpy(text+pos,"\\m");			break;
	case 16:strcpy(text+pos,"\\q");			break;
	case 17:strcpy(text+pos,"\\[]");		break;
	case 18:strcpy(text+pos,"\\()");		break;
	case 19:strcpy(text+pos,"\\<>");		break;
	case 20:strcpy(text+pos,"\\{}");		break;
	case 21:strcpy(text+pos,"\\||");		break;
	case 22:strcpy(text+pos,"\\##");		break;
	case 23:strcpy(text+pos,"\\&&");		break;
	case 24:strcpy(text+pos,"\\$$");		break;
			}

	len =strlen(text+pos)+pos;
		 strcpy(text+len,puffer+pos);

	if(Art>=17)len--;

	UpdateData(FALSE);
	edit->SetWindowText(text);
	edit->SetFocus();
	edit->SetEditSel(len,len);


	ausdruck=1;
	GetDlgItem(IDC_CHECK4)->SendMessage(BM_SETCHECK,1);
}

//*****************************************************************************
//*
//*		Init
//*
//*****************************************************************************
// Registry Daten laden
void CTextFindDlg::Init()
{
CRegKeys	key;
char	   *str;


	if(init)return;
	   init=1;						// Wurden die Registry Daten geladen ?

	auswahl.ContainerInit();

	if(!key.Open( HKEY_CURRENT_USER,0,CRK_READ))return;
	if(!key.Up  ( "TextSeach"))return;
		key.Get ( flags, "Flags");
		key.Get ( lines, "Lines");
	if(	key.Get ((void**)&str, "Strings", REG_MULTI_SZ ))
		{
		auswahl.Add(&str);
		delete str;
		}

	auswahl.ContainerInit();

}

//*****************************************************************************
//*
//*		Exit
//*
//*****************************************************************************
// Registry Daten speichern
void CTextFindDlg::Exit()
{
CRegKeys	key;
char	   *str=0;
int			len;


	if(!init)return;				// Wurden die Registry Daten geladen ?


	len=auswahl.Chain(&str);

	if(!key.Open( HKEY_CURRENT_USER,0,CRK_CREATE))return;
	if(!key.Up  ( "TextSeach"))return;
		key.Set ( flags,  "Flags");
		key.Set ( lines, "Lines");
		key.Set ( str,len,"Strings",REG_MULTI_SZ );

	delete str;

}


//*****************************************************************************
//*
//*		GetText
//*
//*****************************************************************************
//	Such Text abfragen
int	 CTextFindDlg::GetText(char *Puffer,int Max)
{
int  len;

	if(Max<=0)return 0;
	   Max--;

	   len=text.GetLength();
	if(len>Max)len=Max;

	memcpy(Puffer,text,len);
	Puffer[len]=0;

return len;
}

char *CTextFindDlg::GetText()
{
	return (char*)((LPCSTR)text);
}


//*****************************************************************************
//*
//*		OnClick
//*
//*****************************************************************************
void CTextFindDlg::OnClick()
{

	UpdateData();
	EnableDlgItem(IDC_CHECK2,ausdruck);
	EnableDlgItem(IDC_EDIT1,multi_line);

}
