//*****************************************************************************
//*
//*
//*		ZipDlg.cpp: Implementierungsdatei
//*
//*
//*****************************************************************************
#include	"StdAfx.h"
#include	"AfxUtility.h"
#include	"DataFinder.h"
#include	"FileListCtrl.h"
#include	"ZipDlg.h"


#ifdef		_DEBUG
#define new	 DEBUG_NEW
#undef		 THIS_FILE
static char	 THIS_FILE[] = __FILE__;
#endif

#define 	 IDMESSAGE		0x5730
#define 	 IDREADY		0x5731
#define 	 IDSTART		0x5732
#define 	 IDEXIT			0x5733
#define 	 IDTIMER		0x5734


BEGIN_MESSAGE_MAP(CZipDlg, CDialog)
	//{{AFX_MSG_MAP(CZipDlg)
	ON_BN_CLICKED(IDC_BUTTON1, OnFileName)
	ON_BN_CLICKED(IDC_BUTTON4, OnComparePath)
	ON_BN_CLICKED(IDC_BUTTON5, OnCompareBase)
	ON_WM_DESTROY()
	ON_COMMAND(IDMESSAGE,OnMessage)
	ON_COMMAND(IDREADY	,OnReady)
	ON_COMMAND(IDSTART	,OnStart)
	ON_COMMAND(IDEXIT	,OnExit)
	ON_WM_TIMER()
	ON_BN_CLICKED(IDC_CHECK2, OnCheck2)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

DLG_OLDPOS(CZipDlg)



//*****************************************************************************
//*
//*		Dialogfeld CZipDlg
//*
//*****************************************************************************
CZipDlg::CZipDlg(CWnd *pParent)	: CDialog(CZipDlg::IDD,pParent)
{

	//{{AFX_DATA_INIT(CZipDlg)
	m_sZipFile		= _T("");
	m_sBasePath		= _T("");
	m_sAddPath		= _T("");
	m_sPathChanged	= _T("");
	m_sBaseChanged	= _T("");
	m_bOnlyChanged	= FALSE;
	m_bOnlySelected = FALSE;
	//}}AFX_DATA_INIT

	m_pSemaphore = 0;
}



//*****************************************************************************
//*
//*		DoDataExchange
//*
//*****************************************************************************
void CZipDlg::DoDataExchange(CDataExchange *pDX)
{

	CDialog::DoDataExchange(pDX);

	//{{AFX_DATA_MAP(CZipDlg)
	DDX_CBString(pDX, IDC_COMBO1, m_sZipFile);
	DDX_CBString(pDX, IDC_COMBO2, m_sBasePath);
	DDX_CBString(pDX, IDC_COMBO3, m_sAddPath);
	DDX_CBString(pDX, IDC_COMBO4, m_sPathChanged);
	DDX_CBString(pDX, IDC_COMBO5, m_sBaseChanged);
	DDX_Check 	(pDX, IDC_CHECK1, m_bOnlySelected);
	DDX_Check 	(pDX, IDC_CHECK2, m_bOnlyChanged);
	//}}AFX_DATA_MAP

}



//*****************************************************************************
//*
//*		OnInitDialog
//*
//*****************************************************************************
BOOL CZipDlg::OnInitDialog()
{
CRegKeys	sKey;
POSITION	hPos;


	SET_DLG_OLDPOS()


	m_bOnly = FALSE;
	hPos	= m_pFileList->GetFirstSelectedItemPosition();

	if(hPos)
		{
		m_pFileList->GetNextSelectedItem(hPos);
		if(hPos)m_bOnly=TRUE;
		}

	GetDlgItem(IDC_CHECK1)->EnableWindow(m_bOnly);

	m_pProgress=(CProgressCtrl*)GetDlgItem(IDC_PROGRESS1);

	ComboBoxLoad(this,IDC_COMBO1, "ZipFileList","#ZipDialog");
	ComboBoxLoad(this,IDC_COMBO2, "BaseList"   ,"#ZipDialog");
	ComboBoxLoad(this,IDC_COMBO3, "ZipPathList","#ZipDialog");
	ComboBoxLoad(this,IDC_COMBO4,"#CompareList","#ZipDialog",m_sPathChanged);
	ComboBoxLoad(this,IDC_COMBO5, "SourceList" ,"#ZipDialog");

	if(sKey.Open(0,CRK_READ))
	if(sKey.Up("ZipDialog"))
		{
		sKey.Get(m_sZipFile,"ZipFile");
		sKey.Get(m_sAddPath,"ZipPath");
		}

	CDialog::OnInitDialog();

	m_iStop		 = 0;
	m_iScanReady = 0;
	m_uSizeMax	 = 1;
	m_uSize		 = 0;
	m_cText[0]	 = 0;

	SetButtonBitmap(this,IDC_BUTTON1,IDB_OPEN);
	SetButtonBitmap(this,IDC_BUTTON4,IDB_OPEN);
	SetButtonBitmap(this,IDC_BUTTON5,IDB_OPEN);

	SetDlgItemText(IDC_TEXT,"Scanne Pfade");
	GetDlgItem(IDOK      )->EnableWindow(FALSE);
	GetDlgItem(IDCANCEL  )->EnableWindow(FALSE);
	GetDlgItem(IDC_CHECK1)->EnableWindow(FALSE);
	GetDlgItem(IDC_COMBO2)->EnableWindow(FALSE);

	AfxBeginThread(ZipProc,this);



return TRUE;
}



//*****************************************************************************
//*
//*		OnDestroy
//*
//*****************************************************************************
void CZipDlg::OnDestroy()
{

	DelButtonBitmap(this,IDC_BUTTON1);
	DelButtonBitmap(this,IDC_BUTTON4);
	DelButtonBitmap(this,IDC_BUTTON5);

	CDialog::OnDestroy();

}

//*****************************************************************************
//*
//*		OnCheck2
//*
//*****************************************************************************
void CZipDlg::OnCheck2()
{

	UpdateData();

	GetDlgItem(IDC_COMBO4 )->EnableWindow(m_bOnlyChanged);
	GetDlgItem(IDC_COMBO5 )->EnableWindow(m_bOnlyChanged);
	GetDlgItem(IDC_BUTTON4)->EnableWindow(m_bOnlyChanged);
	GetDlgItem(IDC_BUTTON5)->EnableWindow(m_bOnlyChanged);

}

//*****************************************************************************
//*
//*		OnFileName
//*
//*****************************************************************************
void CZipDlg::OnFileName()
{

	if(m_iScanReady>=2)return;

	UpdateData();


	CFileDialog	sDlg(FALSE,"*.zip",m_sZipFile,OFN_PATHMUSTEXIST,"ZIP-Dateien (*.zip)|*.zip|Alle Dateien (*.*)|*.*|");

	if(sDlg.DoModal()!=IDOK)return;

	m_sZipFile=sDlg.GetPathName();

	UpdateData(FALSE);

}


//*****************************************************************************
//*
//*		OnComparePath
//*
//*****************************************************************************
void CZipDlg::OnComparePath()
{
CPathDlg	sDlg;



	if(m_iScanReady>=2)return;

	UpdateData();

	sDlg.SetPath(m_sPathChanged);
	sDlg.SetTitle("Vergelichspfad frs Einfgen");

	if(sDlg.DoModal()!=IDOK)return;

	m_sPathChanged = sDlg.GetPath();

	UpdateData(FALSE);

}


//*****************************************************************************
//*
//*		OnCompareBase
//*
//*****************************************************************************
void CZipDlg::OnCompareBase()
{
CPathDlg	sDlg;



	if(m_iScanReady>=2)return;

	UpdateData();

	sDlg.SetPath(m_sBaseChanged);
	sDlg.SetTitle("Basispfad frs Vergleichen");

	if(sDlg.DoModal()!=IDOK)return;

	m_sBaseChanged = sDlg.GetPath();

	UpdateData(FALSE);

}

//*****************************************************************************
//*
//*		OnReady
//*
//*****************************************************************************
//	Die Datei Pfade  wurden gescannt
void CZipDlg::OnReady()
{

	SetDlgItemText(IDC_COMBO2,m_sBasePath);

	GetDlgItem(IDOK      )->EnableWindow(TRUE);
	GetDlgItem(IDCANCEL  )->EnableWindow(TRUE);
	GetDlgItem(IDC_CHECK1)->EnableWindow(m_bOnly);
	GetDlgItem(IDC_COMBO2)->EnableWindow(TRUE);

	SetDlgItemText(IDC_TEXT,"");


	m_iScanReady = 1;
}


//*****************************************************************************
//*
//*		OnStart
//*
//*****************************************************************************
//	Das Zippen wurde begonnen
void CZipDlg::OnStart()
{
	GetDlgItem(IDC_COMBO1)->EnableWindow(FALSE);
	GetDlgItem(IDC_COMBO2)->EnableWindow(FALSE);
	GetDlgItem(IDC_COMBO3)->EnableWindow(FALSE);
	GetDlgItem(IDC_CHECK1)->EnableWindow(FALSE);
	GetDlgItem(IDOK      )->EnableWindow(FALSE);

}

//*****************************************************************************
//*
//*		OnMessage
//*
//*****************************************************************************
//	Eine Nachricht kommt vom Thread
void CZipDlg::OnMessage()
{

	MessageBox(m_sMessage,"Dateien zippen");
	m_pSemaphore->Unlock();

}

//*****************************************************************************
//*
//*		OnExit
//*
//*****************************************************************************
//	Der Thread ist beendet
void CZipDlg::OnExit()
{
	m_iScanReady = 2;

	if(m_iStop)
		{
		OnCancel();
		return;
		}

	OnOK();
}

//*****************************************************************************
//*
//*		OnCancel
//*
//*****************************************************************************
void CZipDlg::OnCancel()
{

	if(m_iScanReady==0)return;

	GET_DLG_OLDPOS()

	m_iStop=1;

	if(m_iScanReady==1)
		{
		m_pSemaphore->Unlock();
		return;
		}

	KillTimer(IDTIMER);
	CDialog::OnCancel();

}


//*****************************************************************************
//*
//*		OnOK
//*
//*****************************************************************************
void CZipDlg::OnOK()
{
CRegKeys	sKey;


	GET_DLG_OLDPOS()

	if(m_iScanReady==0)return;

	UpdateData();

	if(m_sZipFile.IsEmpty())
		{
		MessageBox("Es ist kein Name angegeben !","Fehler",MB_OK|MB_ICONERROR);
		return;
		}

	if(m_bOnlyChanged)
		{
		if(m_sPathChanged.IsEmpty())
			{
			MessageBox("Es ist kein Vergleichspfad fr genderte Dateien angegeben !","Fehler",MB_OK|MB_ICONERROR);
			return;
			}

		if(m_sBaseChanged.IsEmpty())
			{
			MessageBox("Es ist kein Basispfad fr genderte Dateien angegeben !","Fehler",MB_OK|MB_ICONERROR);
			return;
			}

		DelBackSlash(m_sPathChanged);

		if(ExistFile(m_sPathChanged)<2)
			{
			MessageBox("Der Vergleichspfad fr genderte Dateien existiert nicht !","Fehler",MB_OK|MB_ICONERROR);
			return;
			}

		DelBackSlash(m_sBaseChanged);

		if(ExistFile(m_sBaseChanged)<2)
			{
			MessageBox("Der Basispfad fr genderte Dateien existiert nicht !","Fehler",MB_OK|MB_ICONERROR);
			return;
			}
		}

	if(m_iScanReady==1)
		{
		ComboBoxSave(this,IDC_COMBO1, "ZipFileList","#ZipDialog");
		ComboBoxSave(this,IDC_COMBO2, "BaseList"   ,"#ZipDialog");
		ComboBoxSave(this,IDC_COMBO3, "ZipPathList","#ZipDialog");
		ComboBoxSave(this,IDC_COMBO4,"#CompareList","#ZipDialog");
		ComboBoxSave(this,IDC_COMBO5, "SourceList" ,"#ZipDialog");


		if(sKey.Open(0,CRK_CREATE))
		if(sKey.Up("ZipDialog"))
			{
			sKey.Set(m_sZipFile,"ZipFile");
			sKey.Set(m_sAddPath,"ZipPath");
			}

		m_pSemaphore->Unlock();
		SetTimer(IDTIMER,300,NULL);
		return;
		}


	KillTimer(IDTIMER);
	CDialog::OnOK();
}



//*****************************************************************************
//*
//*		ZipProc
//*
//*****************************************************************************
UINT _cdecl CZipDlg::ZipProc(void *pParam){return ((CZipDlg*)pParam)->ZipProc();}
UINT        CZipDlg::ZipProc()
{
CZipFile	sZip;
int			iState,iOff,iPos;
int			iCount,iLen,iMax;
int			iIndex,iAdd,iNum;
char		cBuffer [MAX_PATH];
char		cAssign [MAX_PATH];
char		cCompare[MAX_PATH];
LPCTSTR		pFile;
LPCTSTR		pPath;



	iCount = m_pFileList->GetItemCount();
	pPath  = m_pFileList->GetPathName(0);

	if(!pPath)pPath="";

	iLen =strlcpy (cBuffer,pPath,sizeof(cBuffer));
	iLen-=strbwlen(cBuffer+iLen,0x00300000,iLen);

	for(iIndex=1;iIndex<iCount;iIndex++)
		{
			pPath = m_pFileList->GetPathName(iIndex);
		if(!pPath)continue;

		if(!memicmp(cBuffer,pPath,iLen))
			{
			if(pPath[iLen]=='\\')continue;
			if(pPath[iLen]=='/' )continue;
			}

		while(iLen>0)
			{
			iLen-=strdwlen(cBuffer+iLen,0x00300000,iLen);
			iLen-=strbwlen(cBuffer+iLen,0x00300000,iLen);

			if(!memicmp(cBuffer,pPath,iLen))
				{
				if(pPath[iLen]=='\\')break;
				if(pPath[iLen]=='/' )break;
				if(pPath[iLen]== 0  )break;
				}

			cBuffer[iLen]=0;
			}

		cBuffer[iLen]=0;
		if(iLen<=0)break;
		}

	m_sBasePath  = cBuffer;
	m_pSemaphore = new CSemaphore(0,0xFFFF);

	PostMessage(WM_COMMAND,IDREADY);

	m_pSemaphore->Lock();

	if(m_iStop)
		{
		delete m_pSemaphore;
		PostMessage(WM_COMMAND,IDEXIT);
		return 0;
		}


//*****************************************************************************


	m_sZipCreate = m_sZipFile;
	iLen=strlcpy(cBuffer,m_sBasePath,sizeof(cBuffer));
	iMax=strlcpy(cAssign,m_sAddPath ,sizeof(cAssign));

	PathConvert(cAssign);
	iAdd=strwlen(cAssign,0x00100000);
	memmove(cAssign,cAssign+iAdd,iMax-iAdd+1);
	iMax-=iAdd;
	cAssign[iMax]=0;

	iMax=AddBackSlash(cAssign);
	iLen=AddBackSlash(cBuffer);

	PostMessage(WM_COMMAND,IDSTART	);

	sZip.Progress(this,Progress);
	sZip.ProgressDel(-1,1);
	sZip.ProgressAdd(CAF_PROG_WRITE);
	sZip.ProgressAdd(CAF_PROG_FLUSH);

	if(sZip.Open(m_sZipCreate,CAF_CREATE)!=CAF_ERROR_OK)
		{
		m_sMessage=sZip.ErrorText();
		PostMessage(WM_COMMAND,IDMESSAGE);
		m_pSemaphore->Lock();

		delete m_pSemaphore;
		PostMessage(WM_COMMAND,IDEXIT);
		return 0;
		}


//*****************************************************************************


	if(m_bOnlyChanged)									// Nur vernderte Dateien einfgen
		{
		AddBackSlash(m_sPathChanged);
		AddBackSlash(m_sBaseChanged);
		PathConvert (m_sPathChanged);
		PathConvert (m_sBaseChanged);

		iOff	= strlcpy(cCompare,m_sPathChanged,sizeof(cCompare));
		}


	iPos = m_sBaseChanged.GetLength();

	for(iIndex=0;iIndex<iCount;iIndex++)
		{
			pFile = m_pFileList->GetFileName(iIndex,1);
			pPath = m_pFileList->GetPathName(iIndex);
		if(!pPath)continue;

		if(m_bOnlySelected)
			{
			iState = m_pFileList->GetItemState(iIndex,LVIS_SELECTED);

			if(!(iState&LVIS_SELECTED))
				{
				continue;
				}
			}
														// Nur vernderte Dateien einfgen
		if(m_bOnlyChanged && !strnicmp(pFile,m_sBaseChanged,iPos))
			{
			strlcpy(cCompare+iOff,pFile+iPos,sizeof(cCompare)-iOff);

			if(CmpFileData(pFile,cCompare))
				{
				continue;
				}
			}

		if(!memcmp(cBuffer,pPath,iLen))
			{
			iNum=strlen(pPath+iLen);
			if(iNum+iMax>sizeof(cAssign)-2)continue;
			memcpy(cAssign+iMax,pPath+iLen,iNum+1);
			m_uSizeMax += m_pFileList->GetFileLength(iIndex);
			sZip.Add(pFile,0,0,cAssign);
 			}
		else{
			cAssign[iMax]=0;
			m_uSizeMax += m_pFileList->GetFileLength(iIndex);
			sZip.Add(pFile,0,0,cAssign);
			}
		}

	sZip.Close();

	if(m_iStop)RemoveFile(m_sZipCreate);


	delete m_pSemaphore;
	PostMessage(WM_COMMAND,IDEXIT);



return 0;
}



//*****************************************************************************
//*
//*		Progress
//*
//*****************************************************************************
//	Progressfunktion fr Zip-Datei
int  _cdecl CZipDlg::Progress(void *pParam,int iArt,int iSub,CArchiveFile *pZip,char *pText){return ((CZipDlg*)pParam)->Progress(iArt,iSub,pZip,pText);}
int         CZipDlg::Progress(             int iArt,int iSub,CArchiveFile *pZip,char *pText)
{

	if(m_iStop)return 1;

	if(pText && *pText)
		{
		if(iArt==CAF_PROG_WRITE)
			{
			if(*pText=='\n')pText++;
			m_uSize+=(unsigned)pZip->Len(iSub);
			strlcpy(m_cText,pText,sizeof(m_cText));
			m_iSetText=1;
			}
		}


return 0;
}


//*****************************************************************************
//*
//*		OnTimer
//*
//*****************************************************************************
void CZipDlg::OnTimer(UINT_PTR nIDEvent)
{

	if(nIDEvent==IDTIMER && m_iSetText)
		{
		__int64		iPos;

		iPos  = m_uSize;
		iPos *= 100;
		iPos /= m_uSizeMax;

		m_pProgress->SetPos((int)iPos);
		m_iSetText = 0;
		SetDlgItemText(IDC_TEXT,m_cText);
		return;
		}


	CDialog::OnTimer(nIDEvent);
}

